This file contains information about GCC releases which has been generated
automatically from the online release notes.  It covers releases of GCC
(and the former EGCS project) since EGCS 1.0, on the line of development
that led to GCC 3. For information on GCC 2.8.1 and older releases of GCC 2,
see ONEWS.

======================================================================
http://gcc.gnu.org/gcc-7/index.html

                              GCC 7 Release Series

   Jan 25, 2018

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 7.3.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 7.2 relative to previous releases of GCC.

Release History

   GCC 7.3
          Jan 25, 2018 ([2]changes, [3]documentation)

   GCC 7.2
          Aug 14, 2017 ([4]changes, [5]documentation)

   GCC 7.1
          May 2, 2017 ([6]changes, [7]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [8]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [9]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [10]GCC
   project web site or contact the [11]GCC development mailing list.

   To obtain GCC please use [12]our mirror sites or [13]our SVN server.


    For questions related to the use of GCC, please consult these web
    pages and the [14]GCC manuals. If that fails, the
    [15]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [16]gcc@gcc.gnu.org. All of [17]our lists have public
    archives.

   Copyright (C) [18]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [19]maintained by the GCC team. Last modified
   2018-01-25[20].

References

   1. http://www.gnu.org/
   2. http://gcc.gnu.org/gcc-7/changes.html
   3. http://gcc.gnu.org/onlinedocs/7.3.0/
   4. http://gcc.gnu.org/gcc-7/changes.html
   5. http://gcc.gnu.org/onlinedocs/7.2.0/
   6. http://gcc.gnu.org/gcc-7/changes.html
   7. http://gcc.gnu.org/onlinedocs/7.1.0/
   8. http://gcc.gnu.org/gcc-7/buildstat.html
   9. http://gcc.gnu.org/onlinedocs/gcc/Contributors.html
  10. http://gcc.gnu.org/index.html
  11. mailto:gcc@gcc.gnu.org
  12. http://gcc.gnu.org/mirrors.html
  13. http://gcc.gnu.org/svn.html
  14. https://gcc.gnu.org/onlinedocs/
  15. mailto:gcc-help@gcc.gnu.org
  16. mailto:gcc@gcc.gnu.org
  17. https://gcc.gnu.org/lists.html
  18. http://www.fsf.org/
  19. https://gcc.gnu.org/about.html
  20. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-7/changes.html

                              GCC 7 Release Series
                        Changes, New Features, and Fixes

   This page is a brief summary of some of the huge number of improvements
   in GCC 7. For more information, see the [1]Porting to GCC 7 page and
   the [2]full GCC documentation.

Caveats

     * GCC now uses [3]LRA (a new local register allocator) by default for
       new targets.
     * The non-standard C++0x type traits has_trivial_default_constructor,
       has_trivial_copy_constructor and has_trivial_copy_assign have been
       removed.
     * The libstdc++ [4]Profile Mode has been deprecated and will be
       removed in a future version.
     * The Cilk+ extensions to the C and C++ languages have been
       deprecated.
     * On ARM targets (arm*-*-*), [5]a bug introduced in GCC 5 that
       affects conformance to the procedure call standard (AAPCS) has been
       fixed. The bug affects some C++ code where class objects are passed
       by value to functions and could result in incorrect or inconsistent
       code being generated. This is an ABI change. If the option -Wpsabi
       is enabled (on by default) the compiler will emit a diagnostic note
       for code that might be affected.

General Optimizer Improvements

     * GCC 7 can determine the return value or range of return values of
       some calls to the sprintf family of functions and make it available
       to other optimization passes. Some calls to the snprintf function
       with a zero size argument can be folded into constants. This
       optimization is included in -O1 and can be selectively controlled
       by the -fprintf-return-value option.
     * A new store merging pass has been added. It merges constant stores
       to adjacent memory locations into fewer, wider, stores. It is
       enabled by the -fstore-merging option and at the -O2 optimization
       level or higher (and -Os).
     * A new code hoisting optimization has been added to the partial
       redundancy elimination pass. It attempts to move evaluation of
       expressions executed on all paths to the function exit as early as
       possible. This primarily helps improve code size, but can improve
       the speed of the generated code as well. It is enabled by the
       -fcode-hoisting option and at the -O2 optimization level or higher
       (and -Os).
     * A new interprocedural bitwise constant propagation optimization has
       been added, which propagates knowledge about which bits of
       variables are known to be zero (including pointer alignment
       information) across the call graph. It is enabled by the
       -fipa-bit-cp option if -fipa-cp is enabled as well, and is enabled
       at the -O2 optimization level and higher (and -Os). This
       optimization supersedes interprocedural alignment propagation of
       GCC 6, and therefore the option -fipa-cp-alignment is now
       deprecated and ignored.
     * A new interprocedural value range propagation optimization has been
       added, which propagates integral range information across the call
       graph when variable values can be proven to be within those ranges.
       It is enabled by the -fipa-vrp option and at the -O2 optimization
       level and higher (and -Os).
     * A new loop splitting optimization pass has been added. Certain
       loops which contain a condition that is always true on one side of
       the iteration space and always false on the other are split into
       two loops, such that each of the two new loops iterates on just one
       side of the iteration space and the condition does not need to be
       checked inside of the loop. It is enabled by the -fsplit-loops
       option and at the -O3 optimization level or higher.
     * The shrink-wrapping optimization can now separate portions of
       prologues and epilogues to improve performance if some of the work
       done traditionally by prologues and epilogues is not needed on
       certain paths. This is controlled by the -fshrink-wrap-separate
       option, enabled by default. It requires target support, which is
       currently only implemented in the PowerPC and AArch64 ports.
     * AddressSanitizer gained a new sanitization option,
       -fsanitize-address-use-after-scope, which enables sanitization of
       variables whose address is taken and used after a scope where the
       variable is defined:

int
main (int argc, char **argv)
{
  char *ptr;
    {
      char my_char;
      ptr = &my_char;
    }

  *ptr = 123;
  return *ptr;
}

==28882==ERROR: AddressSanitizer: stack-use-after-scope on address 0x7fffb8dba99
0 at pc 0x0000004006d5 bp 0x7fffb8dba960 sp 0x7fffb8dba958
WRITE of size 1 at 0x7fffb8dba990 thread T0
    #0 0x4006d4 in main /tmp/use-after-scope-1.c:10
    #1 0x7f9c71943290 in __libc_start_main (/lib64/libc.so.6+0x20290)
    #2 0x400739 in _start (/tmp/a.out+0x400739)

Address 0x7fffb8dba990 is located in stack of thread T0 at offset 32 in frame
    #0 0x40067f in main /tmp/use-after-scope-1.c:3

  This frame has 1 object(s):
    [32, 33) 'my_char' <== Memory access at offset 32 is inside this variable

       The option is enabled by default with -fsanitize=address and
       disabled by default with -fsanitize=kernel-address. Compared to the
       LLVM compiler, where the option already exists, the implementation
       in the GCC compiler has some improvements and advantages:
          + Complex uses of gotos and case labels are properly handled and
            should not report any false positive or false negatives.
          + C++ temporaries are sanitized.
          + Sanitization can handle invalid memory stores that are
            optimized out by the LLVM compiler when optimization is
            enabled.
     * The -fsanitize=signed-integer-overflow suboption of the
       UndefinedBehavior Sanitizer now diagnoses arithmetic overflows even
       on arithmetic operations with generic vectors.
     * Version 5 of the [6]DWARF debugging information standard is
       supported through the -gdwarf-5 option. The DWARF version 4
       debugging information remains the default until consumers of
       debugging information are adjusted.

New Languages and Language specific improvements

   OpenACC support in C, C++, and Fortran continues to be maintained and
   improved. See the [7]OpenACC and [8]Offloading wiki pages for further
   information.

  Ada

     * On mainstream native platforms, Ada programs no longer require the
       stack to be made executable in order to run properly.

  BRIG (HSAIL)

   Support for processing BRIG 1.0 files was added in this release. BRIG
   is a binary format for HSAIL (Heterogeneous System Architecture
   Intermediate Language). The BRIG frontend can be used for implementing
   HSAIL "finalizers" (compilation of HSAIL to a native ISA) for
   gcc-supported targets. An implementation of an HSAIL runtime library,
   libhsail-rt is also included.

  C family

     * New command-line options have been added for the C and C++
       compilers:
          + -Wimplicit-fallthrough warns when a switch case falls through.
            This warning has five different levels. The compiler is able
            to parse a wide range of fallthrough comments, depending on
            the level. It also handles control-flow statements, such as
            ifs. It's possible to suppress the warning by either adding a
            fallthrough comment, or by using a null statement:
            __attribute__ ((fallthrough)); (C, C++), or [[fallthrough]];
            (C++17), or [[gnu::fallthrough]]; (C++11/C++14). This warning
            is enabled by -Wextra.
          + -Wpointer-compare warns when a pointer is compared with a zero
            character constant. Such code is now invalid in C++11 and GCC
            rejects it. This warning is enabled by default.
          + -Wduplicated-branches warns when an if-else has identical
            branches.
          + -Wrestrict warns when an argument passed to a
            restrict-qualified parameter aliases with another argument.
          + -Wmemset-elt-size warns for memset calls, when the first
            argument references an array, and the third argument is a
            number equal to the number of elements of the array, but not
            the size of the array. This warning is enabled by -Wall.
          + -Wint-in-bool-context warns about suspicious uses of integer
            values where boolean values are expected. This warning is
            enabled by -Wall.
          + -Wswitch-unreachable warns when a switch statement has
            statements between the controlling expression and the first
            case label which will never be executed. This warning is
            enabled by default.
          + -Wexpansion-to-defined warns when defined is used outside #if.
            This warning is enabled by -Wextra or -Wpedantic.
          + -Wregister warns about uses of the register storage specifier.
            In C++17 this keyword has been removed and for C++17 this is a
            pedantic warning enabled by default. The warning is not
            emitted for the GNU Explicit Register Variables extension.
          + -Wvla-larger-than=N warns about unbounded uses of
            variable-length arrays, and about bounded uses of
            variable-length arrays whose bound can be larger than N bytes.
          + -Wduplicate-decl-specifier warns when a declaration has
            duplicate const, volatile, restrict or _Atomic specifier. This
            warning is enabled by -Wall.
     * GCC 6's C and C++ frontends were able to offer suggestions for
       misspelled field names:

spellcheck-fields.cc:52:13: error: 'struct s' has no member named 'colour'; did
you mean 'color'?
   return ptr->colour;
               ^~~~~~

       GCC 7 greatly expands the scope of these suggestions. Firstly, it
       adds fix-it hints to such suggestions:

spellcheck-fields.cc:52:13: error: 'struct s' has no member named 'colour'; did
you mean 'color'?
   return ptr->colour;
               ^~~~~~
               color

       The suggestions now cover many other things, such as misspelled
       function names:

spellcheck-identifiers.c:11:3: warning: implicit declaration of function 'gtk_wi
dget_showall'; did you mean 'gtk_widget_show_all'? [-Wimplicit-function-declarat
ion]
   gtk_widget_showall (w);
   ^~~~~~~~~~~~~~~~~~
   gtk_widget_show_all

       misspelled macro names and enum values:

spellcheck-identifiers.cc:85:11: error: 'MAX_ITEM' undeclared here (not in a fun
ction); did you mean 'MAX_ITEMS'?
 int array[MAX_ITEM];
           ^~~~~~~~
           MAX_ITEMS

       misspelled type names:

spellcheck-typenames.c:7:14: error: unknown type name 'singed'; did you mean 'si
gned'?
 void test (singed char e);
            ^~~~~~
            signed

       and, in the C frontend, named initializers:

test.c:7:20: error: 'struct s' has no member named 'colour'; did you mean 'color
'?
 struct s test = { .colour = 3 };
                    ^~~~~~
                    color

     * The preprocessor can now offer suggestions for misspelled
       directives, e.g.:

test.c:5:2: error:invalid preprocessing directive #endfi; did you mean #endif?
 #endfi
  ^~~~~
  endif

     * Warnings about format strings now underline the pertinent part of
       the string, and can offer suggested fixes. In some cases, the
       pertinent argument is underlined.

test.c:51:29: warning: format '%s' expects argument of type 'char *', but argume
nt 3 has type 'int' [-Wformat=]
   printf ("foo: %d  bar: %s baz: %d", 100, i + j, 102);
                          ~^                ~~~~~
                          %d

     * The new -Wdangling-else command-line option has been split out of
       -Wparentheses and warns about dangling else.
     * The -Wshadow warning has been split into three variants.
       -Wshadow=global warns for any shadowing. This is the default when
       using -Wshadow without any argument. -Wshadow=local only warns for
       a local variable shadowing another local variable or parameter.
       -Wshadow=compatible-local only warns for a local variable shadowing
       another local variable or parameter whose type is compatible (in
       C++ compatible means that the type of the shadowing variable can be
       converted to that of the shadowed variable).
       The following example shows the different kinds of shadow warnings:

enum operation { add, count };
struct container { int nr; };

int
container_count (struct container c, int count)
{
  int r = 0;
  for (int count = 0; count > 0; count--)
    {
      struct container count = c;
      r += count.nr;
    }
  return r;
}

       -Wshadow=compatible-local will warn for the parameter being
       shadowed with the same type:

warn-test.c:8:12: warning: declaration of 'count' shadows a parameter [-Wshadow=
compatible-local]
   for (int count = 0; count > 0; count--)
            ^~~~~
warn-test.c:5:42: note: shadowed declaration is here
 container_count (struct container c, int count)
                                          ^~~~~

       -Wshadow=local will warn for the above and for the shadowed
       declaration with incompatible type:

warn-test.c:10:24: warning: declaration of 'count' shadows a previous local [-Ws
hadow=local]
       struct container count = c;
                        ^~~~~
warn-test.c:8:12: note: shadowed declaration is here
   for (int count = 0; count > 0; count--)
            ^~~~~

       -Wshadow=global will warn for all of the above and the shadowing of
       the global declaration:

warn-test.c:5:42: warning: declaration of 'count' shadows a global declaration [
-Wshadow]
 container_count (struct container c, int count)
                                          ^~~~~
warn-test.c:1:23: note: shadowed declaration is here
 enum operation { add, count };
                       ^~~~~

     * GCC 7 contains a number of enhancements that help detect buffer
       overflow and other forms of invalid memory accesses.
          + The -Walloc-size-larger-than=size option detects calls to
            standard and user-defined memory allocation functions
            decorated with attribute alloc_size whose argument exceeds the
            specified size (PTRDIFF_MAX by default). The option also
            detects arithmetic overflow in the computation of the size in
            two-argument allocation functions like calloc where the total
            size is the product of the two arguments. Since calls with an
            excessive size cannot succeed they are typically the result of
            programming errors. Such bugs have been known to be the source
            of security vulnerabilities and a target of exploits.
            -Walloc-size-larger-than=PTRDIFF_MAX is included in -Wall.
            For example, the following call to malloc incorrectly tries to
            avoid passing a negative argument to the function and instead
            ends up unconditionally invoking it with an argument less than
            or equal to zero. Since after conversion to the type of the
            argument of the function (size_t) a negative argument results
            in a value in excess of the maximum PTRDIFF_MAX the call is
            diagnosed.

void* f (int n)
{
  return malloc (n > 0 ? 0 : n);
}

warning: argument 1 range [2147483648, 4294967295] exceeds maximum object size 2
147483647 [-Walloc-size-larger-than=]

          + The -Walloc-zero option detects calls to standard and
            user-defined memory allocation functions decorated with
            attribute alloc_size with a zero argument. -Walloc-zero is not
            included in either -Wall or -Wextra and must be explicitly
            enabled.
          + The -Walloca option detects all calls to the alloca function
            in the program. -Walloca is not included in either -Wall or
            -Wextra and must be explicitly enabled.
          + The -Walloca-larger-than=size option detects calls to the
            alloca function whose argument either may exceed the specified
            size, or that is not known to be sufficiently constrained to
            avoid exceeding it. -Walloca-larger-than is not included in
            either -Wall or -Wextra and must be explicitly enabled.
            For example, compiling the following snippet with
            -Walloca-larger-than=1024 results in a warning because even
            though the code appears to call alloca only with sizes of 1kb
            and less, since n is signed, a negative value would result in
            a call to the function well in excess of the limit.

void f (int n)
{
  char *d;
  if (n < 1025)
    d = alloca (n);
  else
    d = malloc (n);
  ...
}

warning: argument to 'alloca may be too large due to conversion from 'int' to 'l
ong unsigned int' [-Walloca-larger-than=]

            In contrast, a call to alloca that isn't bounded at all such
            as in the following function will elicit the warning below
            regardless of the size argument to the option.

void f (size_t n)
{
  char *d = alloca (n);
  ...
}

warning: unbounded use of 'alloca' [-Walloca-larger-than=]

          + The -Wformat-overflow=level option detects certain and likely
            buffer overflow in calls to the sprintf family of formatted
            output functions. Although the option is enabled even without
            optimization it works best with -O2 and higher.
            For example, in the following snippet the call to sprintf is
            diagnosed because even though its output has been constrained
            using the modulo operation it could result in as many as three
            bytes if mday were negative. The solution is to either
            allocate a larger buffer or make sure the argument is not
            negative, for example by changing mday's type to unsigned or
            by making the type of the second operand of the modulo
            expression unsigned: 100U.

void* f (int mday)
{
  char *buf = malloc (3);
  sprintf (buf, "%02i", mday % 100);
  return buf;
}

warning: 'sprintf may write a terminating nul past the end of the destination [-
Wformat-overflow=]
note: 'sprintf' output between 3 and 4 bytes into a destination of size 3

          + The -Wformat-truncation=level option detects certain and
            likely output truncation in calls to the snprintf family of
            formatted output functions. -Wformat-truncation=1 is included
            in -Wall and enabled without optimization but works best with
            -O2 and higher.
            For example, the following function attempts to format an
            integer between 0 and 255 in hexadecimal, including the 0x
            prefix, into a buffer of four characters. But since the
            function must always terminate output by the null character
            ('\0') such a buffer is only big enough to fit just one digit
            plus the prefix. Therefore the snprintf call is diagnosed. To
            avoid the warning either use a bigger buffer or handle the
            function's return value which indicates whether or not its
            output has been truncated.

void f (unsigned x)
{
  char d[4];
  snprintf (d, sizeof d, "%#02x", x & 0xff);
  ...
}

warning: 'snprintf' output may be truncated before the last format character [-W
format-truncation=]
note: 'snprintf' output between 3 and 5 bytes into a destination of size 4

          + The -Wnonnull option has been enhanced to detect a broader set
            of cases of passing null pointers to functions that expect a
            non-null argument (those decorated with attribute nonnull). By
            taking advantage of optimizations the option can detect many
            more cases of the problem than in prior GCC versions.
          + The -Wstringop-overflow=type option detects buffer overflow in
            calls to string handling functions like memcpy and strcpy. The
            option relies on [9]Object Size Checking and has an effect
            similar to defining the _FORTIFY_SOURCE macro.
            -Wstringop-overflow=2 is enabled by default.
            For example, in the following snippet, because the call to
            strncat specifies a maximum that allows the function to write
            past the end of the destination, it is diagnosed. To correct
            the problem and avoid the overflow the function should be
            called with a size of at most sizeof d - strlen(d) - 1.

void f (const char *fname)
{
  char d[8];
  strncpy (d, "/tmp/", sizeof d);
  strncat (d, fname, sizeof d);
  ...
}

warning: specified bound 8 equals the size of the destination [-Wstringop-overfl
ow=]

     * The <limits.h> header provided by GCC defines macros such as
       INT_WIDTH for the width in bits of integer types, if
       __STDC_WANT_IEC_60559_BFP_EXT__ is defined before the header is
       included. The <stdint.h> header defines such macros as SIZE_WIDTH
       and INTMAX_WIDTH for the width of some standard typedef names for
       integer types, again if __STDC_WANT_IEC_60559_BFP_EXT__ is defined
       before the header is included; note that GCC's implementation of
       this header is only used for freestanding compilations, not hosted
       compilations, on most systems. These macros come from ISO/IEC TS
       18661-1:2014.
     * The <float.h> header provided by GCC defines the macro
       CR_DECIMAL_DIG, from ISO/IEC TS 18661-1:2014, if
       __STDC_WANT_IEC_60559_BFP_EXT__ is defined before the header is
       included. This represents the number of decimal digits for which
       conversions between decimal character strings and binary formats,
       in both directions, are correctly rounded, and currently has the
       value of UINTMAX_MAX on all systems, reflecting that GCC's
       compile-time conversions are correctly rounded for any number of
       digits.
     * New __builtin_add_overflow_p, __builtin_sub_overflow_p,
       __builtin_mul_overflow_p built-in functions have been added. These
       work similarly to their siblings without the _p suffix, but do not
       actually store the result of the arithmetics anywhere, just return
       whether the operation would overflow. Calls to these built-ins with
       integer constant arguments evaluate to integer constants
       expressions.
       For example, in the following, c is assigned the result of a * b
       only if the multiplication does not overflow, otherwise it is
       assigned the value zero. The multiplication is performed at
       compile-time and without triggering a -Woverflow warning.

enum {
  a = 12345678,
  b = 87654321,
  c = __builtin_mul_overflow_p (a, b, a) ? 0 : a * b
};

  C

     * The C front end now supports type names _FloatN for floating-point
       types with IEEE interchange formats and _FloatNx for floating-point
       types with IEEE extended formats. These type names come from
       ISO/IEC TS 18661-3:2015.
       The set of types supported depends on the target for which GCC is
       configured. Most targets support _Float32, _Float32x and _Float64.
       _Float128 is supported on targets where IEEE binary128 encoding was
       already supported as long double or __float128. _Float64x is
       supported on targets where a type with either binary128 or Intel
       extended precision format is available.
       Constants with these types are supported using suffixes fN, FN, fNx
       and FNx (e.g., 1.2f128 or 2.3F64x). Macros such as FLT128_MAX are
       defined in <float.h> if __STDC_WANT_IEC_60559_TYPES_EXT__ is
       defined before it is included.
       These new types are always distinct from each other and from float,
       double and long double, even if they have the same encoding.
       Complex types such as _Complex _Float128 are also supported.
       Type-generic built-in functions such as __builtin_isinf support the
       new types, and the following type-specific built-in functions have
       versions (suffixed fN or fNx) for the new types:
       __builtin_copysign, __builtin_fabs, __builtin_huge_val,
       __builtin_inf, __builtin_nan, __builtin_nans.
     * Compilation with -fopenmp is now compatible with the C11 _Atomic
       keyword.

  C++

     * The C++ front end has experimental support for all of the current
       C++17 draft with the -std=c++1z or -std=gnu++1z flags, including if
       constexpr, class template argument deduction, auto template
       parameters, and structured bindings. For a full list of new
       features, see [10]the C++ status page.
     * C++17 support for new of over-aligned types can be enabled in other
       modes with the -faligned-new flag.
     * The C++17 evaluation order requirements can be selected in other
       modes with the -fstrong-eval-order flag, or disabled in C++17 mode
       with -fno-strong-eval-order.
     * The default semantics of inherited constructors has changed in all
       modes, following [11]P0136. Essentially, overload resolution
       happens as if calling the inherited constructor directly, and the
       compiler fills in construction of the other bases and members as
       needed. Most uses should not need any changes. The old behavior can
       be restored with -fno-new-inheriting-ctors, or -fabi-version less
       than 11.
     * The resolution of DR 150 on matching of template template
       parameters, allowing default template arguments to make a template
       match a parameter, is currently enabled by default in C++17 mode
       only. The default can be overridden with -f{no-,}new-ttp-matching.
     * The C++ front end will now provide fix-it hints for some missing
       semicolons, allowing for automatic fixes by IDEs:

test.cc:4:11: error: expected ';' after class definition
 class a {}
           ^
           ;

     * -Waligned-new has been added to the C++ front end. It warns about
       new of type with extended alignment without -faligned-new.

    Runtime Library (libstdc++)

     * The type of exception thrown by iostreams, std::ios_base::failure,
       now uses the [12]cxx11 ABI.
     * Experimental support for C++17, including the following new
       features:
          + std::string_view;
          + std::any, std::optional, and std::variant;
          + std::invoke, std::is_invocable, std::is_nothrow_invocable, and
            invoke_result;
          + std::is_swappable, and std::is_nothrow_swappable;
          + std::apply, and std::make_from_tuple;
          + std::void_t, std::bool_constant, std::conjunction,
            std::disjunction, and std::negation;
          + Variable templates for type traits;
          + Mathematical Special Functions;
          + std::chrono::floor, std::chrono::ceil, std::chrono::round, and
            std::chrono::abs;
          + std::clamp, std::gcd, std::lcm, 3-dimensional std::hypot;
          + std::scoped_lock, std::shared_mutex,
            std::atomic<T>::is_always_lock_free;
          + std::sample, std::default_searcher, std::boyer_moore_searcher
            and std::boyer_moore_horspool_searcher;
          + Extraction and re-insertion of map and set nodes, try_emplace
            members for maps, and functions for accessing containers
            std::size, std::empty, and std::data;
          + std::shared_ptr support for arrays,
            std::shared_ptr<T>::weak_type,
            std::enable_shared_from_this<T>::weak_from_this(), and
            std::owner_less<void>;
          + std::byte;
          + std::as_const, std::not_fn,
            std::has_unique_object_representations, constexpr
            std::addressof.
       Thanks to Daniel Kruegler, Tim Shen, Edward Smith-Rowland, and
       Ville Voutilainen for work on the C++17 support.
     * A new power-of-two rehashing policy for use with the _Hashtable
       internals, thanks to Franc,ois Dumont.

  Fortran

     * Support for a number of extensions for compatibility with legacy
       code with new flags:
          + -fdec-structure Support for DEC STRUCTURE and UNION
          + -fdec-intrinsic-ints Support for new integer intrinsics with
            B/I/J/K prefixes such as BABS, JIAND...
          + -fdec-math Support for additional math intrinsics, including
            COTAN and degree-valued trigonometric functions such as TAND,
            ASIND...
          + -fdec Enable the -fdec-* family of extensions.
     * New flag -finit-derived to allow default initialization of
       derived-type variables.
     * Improved DO loops with step equal to 1 or -1, generates faster code
       without a loop preheader. A new warning, -Wundefined-do-loop, warns
       when a loop iterates either to HUGE(i) (with step equal to 1), or
       to -HUGE(i) (with step equal to -1). Invalid behavior can be caught
       at run time with -fcheck=do enabled:

program test
  implicit none
  integer(1) :: i
  do i = -HUGE(i)+10, -HUGE(i)-1, -1
    print *, i
  end do
end program test

At line 8 of file do_check_12.f90
Fortran runtime error: Loop iterates infinitely

     * Version 4.5 of the [13]OpenMP specification is now partially
       supported in the Fortran compiler; the largest missing item is
       structure element mapping.
     * User-defined derived-type input/output (UDTIO) is added.
     * Derived type coarrays with allocatable and pointer components are
       partially supported.
     * Non-constant stop codes and error stop codes (Fortran 2015
       feature).
     * Derived types with allocatable components of recursive type.
     * Intrinsic assignment to polymorphic variables.
     * Improved submodule support.
     * Improved diagnostics (polymorphic results in pure functions).
     * Coarray: Support for failed images (Fortan 2015 feature).

  Go

     * GCC 7 provides a complete implementation of the Go 1.8.1 user
       packages.
     * Compared to the Go 1.8.1 toolchain, the garbage collector is more
       conservative and less concurrent.
     * Escape analysis is available for experimental use via the
       -fgo-optimize-allocs option. The -fgo-debug-escape prints
       information useful for debugging escape analysis choices.

  Java (GCJ)

   The GCC Java frontend and associated libjava runtime library have been
   removed from GCC.

libgccjit

   The libgccjit API gained support for marking calls as requiring
   tail-call optimization via a new entrypoint:
   [14]gcc_jit_rvalue_set_bool_require_tail_call.

   libgccjit performs numerous checks at the API boundary, but if these
   succeed, it previously ignored errors and other diagnostics emitted
   within the core of GCC, and treated the compile of a gcc_jit_context as
   having succeeded. As of GCC 7 it now ensures that if any diagnostics
   are emitted, they are visible from the libgccjit API, and that the the
   context is flagged as having failed.

New Targets and Target Specific Improvements

  AArch64

     * GCC has been updated to the latest revision of the procedure call
       standard (AAPCS64) to provide support for parameter passing when
       data types have been over-aligned.
     * The ARMv8.3-A architecture is now supported. It can be used by
       specifying the -march=armv8.3-a option.
     * The option -msign-return-address= is supported to enable return
       address protection using ARMv8.3-A Pointer Authentication
       Extensions. For more information on the arguments accepted by this
       option, please refer to [15]AArch64-Options.
     * The ARMv8.2-A architecture and the ARMv8.2-A 16-bit Floating-Point
       Extensions are now supported. They can be used by specifying the
       -march=armv8.2-a or -march=armv8.2-a+fp16 options. The 16-bit
       Floating-Point Extensions introduce new half-precision data
       processing floating-point instructions.
     * Support has been added for the following processors (GCC
       identifiers in parentheses): ARM Cortex-A73 (cortex-a73), Broadcom
       Vulcan (vulcan), Cavium ThunderX CN81xx (thunderxt81), Cavium
       ThunderX CN83xx (thunderxt83), Cavium ThunderX CN88xx
       (thunderxt88), Cavium ThunderX CN88xx pass 1.x (thunderxt88p1),
       Cavium ThunderX 2 CN99xx (thunderx2t99), Qualcomm Falkor (falkor).
       The GCC identifiers can be used as arguments to the -mcpu or -mtune
       options, for example: -mcpu=cortex-a73 or -mtune=vulcan or as
       arguments to the equivalent target attributes and pragmas.

  ARC

     * Added support for ARC HS and ARC EM processors.
     * Added support for ARC EM variation found in Intel QuarkSE SoCs.
     * Added support for NPS400 ARC700 based CPUs.
     * Thread Local Storage is now supported by ARC CPUs.
     * Fixed errors for ARC600 when using 32x16 multiplier option.
     * Fixed PIE for ARC CPUs.
     * New CPU templates are supported via multilib.

  ARM

     * Support for the ARMv5 and ARMv5E architectures has been deprecated
       (which have no known implementations) and will be removed in a
       future GCC release. Note that ARMv5T, ARMv5TE and ARMv5TEJ
       architectures remain supported. The values armv5 and armv5e of
       -march are thus deprecated.
     * The ARMv8.2-A architecture and the ARMv8.2-A 16-bit Floating-Point
       Extensions are now supported. They can be used by specifying the
       -march=armv8.2-a or -march=armv8.2-a+fp16 options. The 16-bit
       Floating-Point Extensions introduce new half-precision data
       processing floating-point instructions.
     * The ARMv8-M architecture is now supported in its two architecture
       profiles: ARMv8-M Baseline and ARMv8-M Mainline with its DSP and
       Floating-Point Extensions. They can be used by specifying the
       -march=armv8-m.base, armv8-m.main or armv8-m.main+dsp options.
     * Support has been added for the following processors (GCC
       identifiers in parentheses): ARM Cortex-A73 (cortex-a73), ARM
       Cortex-M23 (cortex-m23) and ARM Cortex-M33 (cortex-m33). The GCC
       identifiers can be used as arguments to the -mcpu or -mtune
       options, for example: -mcpu=cortex-a73 or -mtune=cortex-m33.
     * A new command-line option -mpure-code has been added. It does not
       allow constant data to be placed in code sections. This option is
       only available when generating non-PIC code for ARMv7-M targets.
     * Support for the ACLE Coprocessor Intrinsics has been added. This
       enables the generation of coprocessor instructions through the use
       of intrinsics such as cdp, ldc, and others.
     * The configure option --with-multilib-list now accepts the value
       rmprofile to build multilib libraries for a range of embedded
       targets. See our [16]installation instructions for details.

  AVR

     * On the reduced Tiny cores, the progmem [17]variable attribute is
       now properly supported. Respective read-only variables are located
       in flash memory in section .progmem.data. No special code is needed
       to access such variables; the compiler automatically adds an offset
       of 0x4000 to all addresses, which is needed to access variables in
       flash memory. As opposed to ordinary cores where it is sufficient
       to specify the progmem attribute with definitions, on the reduced
       Tiny cores the attribute also has to be specified with (external)
       declarations:

extern const int array[] __attribute__((__progmem__));

int get_value2 (void)
{
  /* Access via addresses array + 0x4004 and array + 0x4005. */
  return array[2];
}

const int* get_address (unsigned idx)
{
  /* Returns array + 0x4000 + 2 * idx. */
  return &array[idx];
}

     * A new command-line option -Wmisspelled-isr has been added. It turns
       off -- or turns into errors -- warnings that are reported for
       interrupt service routines (ISRs) which don't follow AVR-LibC's
       naming convention of prefixing ISR names with __vector.
     * __builtin_avr_nops(n) is a new [18]built-in function that inserts n
       NOP instructions into the instruction stream. n must be a value
       known at compile time.

  IA-32/x86-64

     * Support for the AVX-512 Fused Multiply Accumulation Packed Single
       precision (4FMAPS), AVX-512 Vector Neural Network Instructions Word
       variable precision (4VNNIW), AVX-512 Vector Population Count
       (VPOPCNTDQ) and Software Guard Extensions (SGX) ISA extensions has
       been added.

  NVPTX

     * OpenMP target regions can now be offloaded to NVidia PTX GPGPUs.
       See the [19]Offloading Wiki on how to configure it.

  PowerPC / PowerPC64 / RS6000

     * The PowerPC port now uses LRA by default.
     * GCC now diagnoses inline assembly that clobbers register r2. This
       has always been invalid code, and is no longer quietly tolerated.
     * The PowerPC port's support for ISA 3.0 (-mcpu=power9) has been
       enhanced to generate more of the new instructions by default, and
       to provide more built-in functions to generate code for other new
       instructions.
     * The configuration option --enable-gnu-indirect-function is now
       enabled by default on PowerPC GNU/Linux builds.
     * The PowerPC port will now allow 64-bit and 32-bit integer types to
       be allocated to the VSX vector registers (ISA 2.06 and above). In
       addition, on ISA 3.0, 16-bit and 8-bit integer types can be
       allocated in the vector registers. Previously, only 64-bit integer
       types were allowed in the traditional floating point registers.
     * New options -mstack-protector-guard=global,
       -mstack-protector-guard=tls, -mstack-protector-guard-reg=, and
       -mstack-protector-guard-offset= change how the stack protector gets
       the value to use as canary.

  S/390, System z, IBM z Systems, IBM Z

     * Support for the IBM z14 processor has been added. When using the
       -march=z14 option, the compiler will generate code making use of
       the new instructions introduced with the vector enhancement
       facility and the miscellaneous instruction extension facility 2.
       The -mtune=z14 option enables z14 specific instruction scheduling
       without making use of new instructions.
     * Builtins for the new vector instructions have been added and can be
       enabled using the -mzvector option.

  RISC-V

     * Support for the RISC-V instruction set has been added.

  RX

   Basic support for atomic built-in function has been added. It is
   currently implemented by flipping interrupts off and on as needed.

  SH

     * Support for SH5/SH64 has been removed.
     * Improved utilization of delay slots on SH2A.
     * Improved utilization of zero-displacement conditional branches.
     * The following deprecated options have been removed
          + -mcbranchdi
          + -mcmpeqdi
          + -minvalid-symbols
          + -msoft-atomic
          + -mspace
          + -madjust-unroll
     * Support for the following SH2A instructions has been added
          + mov.b @-Rm,R0
          + mov.w @-Rm,R0
          + mov.l @-Rm,R0
          + mov.b R0,@Rn+
          + mov.w R0,@Rn+
          + mov.l R0,@Rn+

  SPARC

     * The SPARC port now uses LRA by default.
     * Support for the new Subtract-Extended-with-Carry instruction
       available in SPARC M7 (Niagara 7) has been added.

Operating Systems

  AIX

     * Visibility support has been enabled for AIX 7.1 and above.

  Fuchsia

     * Support has been added for the [20]Fuchsia OS.

  RTEMS

     * The ABI changes on ARM so that no short enums are used by default.

Other significant improvements

     * -fverbose-asm previously emitted information on the meanings of
       assembly expressions. This has been extended so that it now also
       prints comments showing the source lines that correspond to the
       assembly, making it easier to read the generated assembly
       (especially with larger functions). For example, given this C
       source file:

int test (int n)
{
  int i;
  int total = 0;

  for (i = 0; i < n; i++)
    total += i * i;
  return total;
}

       -fverbose-asm now gives output similar to this for the function
       body (when compiling for x86_64, with -Os):

       .text
       .globl  test
       .type   test, @@function
test:
.LFB0:
       .cfi_startproc
# example.c:4:   int total = 0;
       xorl    %eax, %eax      # <retval>
# example.c:6:   for (i = 0; i < n; i++)
       xorl    %edx, %edx      # i
.L2:
# example.c:6:   for (i = 0; i < n; i++)
       cmpl    %edi, %edx      # n, i
       jge     .L5     #,
# example.c:7:     total += i * i;
       movl    %edx, %ecx      # i, tmp92
       imull   %edx, %ecx      # i, tmp92
# example.c:6:   for (i = 0; i < n; i++)
       incl    %edx    # i
# example.c:7:     total += i * i;
       addl    %ecx, %eax      # tmp92, <retval>
       jmp     .L2     #
.L5:
# example.c:10: }
       ret
       .cfi_endproc

     * Two new options have been added for printing fix-it hints:
          + -fdiagnostics-parseable-fixits allows for fix-it hints to be
            emitted in a machine-readable form, suitable for consumption
            by IDEs. For example, given:

spellcheck-fields.cc:52:13: error: 'struct s' has no member named 'colour'; did
you mean 'color'?
   return ptr->colour;
               ^~~~~~
               color

            it will emit:

fix-it:"spellcheck-fields.cc":{52:13-52:19}:"color"

          + -fdiagnostics-generate-patch will print a patch in "unified"
            format after any diagnostics are printed, showing the result
            of applying all fix-it hints. For the above example it would
            emit:

--- spellcheck-fields.cc
+++ spellcheck-fields.cc
@@ -49,5 +49,5 @@

 color get_color(struct s *ptr)
 {
-  return ptr->colour;
+  return ptr->color;
 }

     * The gcc and g++ driver programs will now provide suggestions for
       misspelled arguments to command-line options.

$ gcc -c test.c -ftls-model=global-dinamic
gcc: error: unknown TLS model 'global-dinamic'
gcc: note: valid arguments to '-ftls-model=' are: global-dynamic initial-exec lo
cal-dynamic local-exec; did you mean 'global-dynamic'?

     * The compiler will now provide suggestions for misspelled
       parameters.

$ gcc -c test.c --param max-early-inliner-iteration=3
cc1: error: invalid --param name 'max-early-inliner-iteration'; did you mean 'ma
x-early-inliner-iterations'?

     * Profile-guided optimization (PGO) instrumentation, as well as test
       coverage (GCOV), can newly instrument constructors (functions marks
       with __attribute__((constructor))), destructors and C++
       constructors (and destructors) of classes that are used as the type
       of a global variable.
     * A new option -fprofile-update=atomic prevents creation of corrupted
       profiles created during an instrumentation run (-fprofile=generate)
       of an application. The downside of the option is a speed penalty.
       Providing -pthread on the command line selects atomic profile
       updating (when supported by the target).
     * GCC's already extensive testsuite has gained some new capabilities,
       to further improve the reliability of the compiler:
          + GCC now has an internal unit-testing API and a suite of tests
            for programmatic self-testing of subsystems.
          + GCC's C frontend has been extended so that it can parse dumps
            of GCC's internal representations, allowing for DejaGnu tests
            that more directly exercise specific optimization passes. This
            covers both the [21]GIMPLE representation (for testing
            higher-level optimizations) and the [22]RTL representation,
            allowing for more direct testing of lower-level details, such
            as register allocation and instruction selection.

GCC 7.1

   This is the [23]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 7.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 7.2

   This is the [24]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 7.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

  Target Specific Changes

    SPARC

     * Support for the SPARC M8 processor has been added.
     * The switches -mfix-ut700 and -mfix-gr712rc have been added to work
       around an erratum in LEON3FT processors.
     * Use of the Floating-point Multiply Single to Double (FsMULd)
       instruction can now be controlled by the -mfsmuld and -fno-fsmuld
       options.

  Operating Systems

    RTEMS

     * The Ada run-time support uses now thread-local storage (TLS).
     * Support for RISC-V has been added.
     * Support for 64-bit PowerPC using the ELFv2 ABI with 64-bit long
       double has been added.

GCC 7.3

   This is the [25]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 7.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

  Operating Systems

    RTEMS

     * Support has been added for Epiphany target.


    For questions related to the use of GCC, please consult these web
    pages and the [26]GCC manuals. If that fails, the
    [27]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [28]gcc@gcc.gnu.org. All of [29]our lists have public
    archives.

   Copyright (C) [30]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [31]maintained by the GCC team. Last modified
   2018-01-23[32].

References

   1. http://gcc.gnu.org/gcc-7/porting_to.html
   2. http://gcc.gnu.org/onlinedocs/index.html#current
   3. https://gcc.gnu.org/wiki/LRAIsDefault
   4. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/libstdc++/manual/manual/profile_mode.html
   5. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728
   6. http://www.dwarfstd.org/Download.php
   7. https://gcc.gnu.org/wiki/OpenACC
   8. https://gcc.gnu.org/wiki/Offloading
   9. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/gcc/Object-Size-Checking.html
  10. https://gcc.gnu.org/projects/cxx-status.html#cxx1z
  11. http://wg21.link/p0136
  12. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/libstdc++/manual/using_dual_abi.html
  13. http://www.openmp.org/specifications/
  14. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/jit/topics/expressions.html#gcc_jit_rvalue_set_bool_require_tail_call
  15. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/gcc/AArch64-Options.html#AArch64-Options
  16. https://gcc.gnu.org/install/configure.html
  17. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/gcc/AVR-Variable-Attributes.html
  18. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/gcc/AVR-Built-in-Functions.html
  19. https://gcc.gnu.org/wiki/Offloading
  20. https://fuchsia.googlesource.com/
  21. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/gccint/GIMPLE-Tests.html
  22. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/gccint/RTL-Tests.html
  23. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=7.0
  24. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=7.2
  25. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=7.3
  26. https://gcc.gnu.org/onlinedocs/
  27. mailto:gcc-help@gcc.gnu.org
  28. mailto:gcc@gcc.gnu.org
  29. https://gcc.gnu.org/lists.html
  30. http://www.fsf.org/
  31. https://gcc.gnu.org/about.html
  32. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-6/index.html

                              GCC 6 Release Series

   July 4, 2017

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 6.4.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 6.3 relative to previous releases of GCC.

Release History

   GCC 6.4
          July 4, 2017 ([2]changes, [3]documentation)

   GCC 6.3
          December 21, 2016 ([4]changes, [5]documentation)

   GCC 6.2
          August 22, 2016 ([6]changes, [7]documentation)

   GCC 6.1
          April 27, 2016 ([8]changes, [9]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [10]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [11]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [12]GCC
   project web site or contact the [13]GCC development mailing list.

   To obtain GCC please use [14]our mirror sites or [15]our SVN server.


    For questions related to the use of GCC, please consult these web
    pages and the [16]GCC manuals. If that fails, the
    [17]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [18]gcc@gcc.gnu.org. All of [19]our lists have public
    archives.

   Copyright (C) [20]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [21]maintained by the GCC team. Last modified
   2017-07-04[22].

References

   1. http://www.gnu.org/
   2. http://gcc.gnu.org/gcc-6/changes.html
   3. http://gcc.gnu.org/onlinedocs/6.4.0/
   4. http://gcc.gnu.org/gcc-6/changes.html
   5. http://gcc.gnu.org/onlinedocs/6.3.0/
   6. http://gcc.gnu.org/gcc-6/changes.html
   7. http://gcc.gnu.org/onlinedocs/6.2.0/
   8. http://gcc.gnu.org/gcc-6/changes.html
   9. http://gcc.gnu.org/onlinedocs/6.1.0/
  10. http://gcc.gnu.org/gcc-6/buildstat.html
  11. http://gcc.gnu.org/onlinedocs/gcc/Contributors.html
  12. http://gcc.gnu.org/index.html
  13. mailto:gcc@gcc.gnu.org
  14. http://gcc.gnu.org/mirrors.html
  15. http://gcc.gnu.org/svn.html
  16. https://gcc.gnu.org/onlinedocs/
  17. mailto:gcc-help@gcc.gnu.org
  18. mailto:gcc@gcc.gnu.org
  19. https://gcc.gnu.org/lists.html
  20. http://www.fsf.org/
  21. https://gcc.gnu.org/about.html
  22. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-6/changes.html

                              GCC 6 Release Series
                        Changes, New Features, and Fixes

   This page is a brief summary of some of the huge number of improvements
   in GCC 6. For more information, see the [1]Porting to GCC 6 page and
   the [2]full GCC documentation.

Caveats

     * The default mode for C++ is now -std=gnu++14 instead of
       -std=gnu++98.
     * Support for a number of older systems and recently unmaintained or
       untested target ports of GCC has been declared obsolete in GCC 6.
       Unless there is activity to revive them, the next release of GCC
       will have their sources permanently removed.
       The following ports for individual systems on particular
       architectures have been obsoleted:
          + SH5 / SH64 (sh64-*-*) as announced [3]here.
     * The AVR port requires binutils version 2.26.1 or later for the fix
       for [4]PR71151 to work.

General Optimizer Improvements

     * UndefinedBehaviorSanitizer gained a new sanitization option,
       -fsanitize=bounds-strict, which enables strict checking of array
       bounds. In particular, it enables -fsanitize=bounds as well as
       instrumentation of flexible array member-like arrays.
     * Type-based alias analysis now disambiguates accesses to different
       pointers. This improves precision of the alias oracle by about
       20-30% on higher-level C++ programs. Programs doing invalid type
       punning of pointer types may now need -fno-strict-aliasing to work
       correctly.
     * Alias analysis now correctly supports the weakref and alias
       attributes. This allows accessing both a variable and its alias in
       one translation unit which is common with link-time optimization.
     * Value range propagation now assumes that the this pointer in C++
       member functions is non-null. This eliminates common null pointer
       checks but also breaks some non-conforming code-bases (such as
       Qt-5, Chromium, KDevelop). As a temporary work-around
       -fno-delete-null-pointer-checks can be used. Wrong code can be
       identified by using -fsanitize=undefined.
     * Link-time optimization improvements:
          + warning and error attributes are now correctly preserved by
            declaration linking and thus -D_FORTIFY_SOURCE=2 is now
            supported with -flto.
          + Type merging was fixed to handle C and Fortran
            interoperability rules as defined by the Fortran 2008 language
            standard.
            As an exception, CHARACTER(KIND=C_CHAR) is not inter-operable
            with char in all cases because it is an array while char is
            scalar. INTEGER(KIND=C_SIGNED_CHAR) should be used instead. In
            general, this inter-operability cannot be implemented, for
            example on targets where the argument passing convention for
            arrays differs from scalars.
          + More type information is now preserved at link time, reducing
            the loss of accuracy of the type-based alias analysis compared
            to builds without link-time optimization.
          + Invalid type punning on global variables and declarations is
            now reported with -Wodr-type-mismatch.
          + The size of LTO object files was reduced by about 11%
            (measured by compiling Firefox 46.0).
          + Link-time parallelization (enabled using -flto=n) was
            significantly improved by decreasing the size of streamed data
            when partitioning programs. The size of streamed IL while
            compiling Firefox 46.0 was reduced by 66%.
          + The linker plugin was extended to pass information about the
            type of binary produced to the GCC back end. (That can also be
            controlled manually by -flinker-output.) This makes it
            possible to properly configure the code generator and support
            incremental linking. Incremental linking of LTO objects by gcc
            -r is now supported for plugin-enabled setups.
            There are two ways to perform incremental linking:
              1. Linking by ld -r will result in an object file with all
                 sections from individual object files mechanically
                 merged. This delays the actual link-time optimization to
                 the final linking step and thus permits whole program
                 optimization. Linking the final binary with such object
                 files is however slower.
              2. Linking by gcc -r will lead to link-time optimization and
                 emit the final binary into the object file. Linking such
                 an object file is fast but avoids any benefits from whole
                 program optimization.
            GCC 7 will support incremental link-time optimization with gcc
            -r.
     * Inter-procedural optimization improvements:
          + Basic jump threading is now performed before profile
            construction and inline analysis, resulting in more realistic
            size and time estimates that drive the heuristics of the
            inliner and function cloning passes.
          + Function cloning now more aggressively eliminates unused
            function parameters.

New Languages and Language specific improvements

   Compared to GCC 5, the GCC 6 release series includes a much improved
   implementation of the [5]OpenACC 2.0a specification. Highlights are:
     * In addition to single-threaded host-fallback execution, offloading
       is supported for nvptx (Nvidia GPUs) on x86_64 and PowerPC 64-bit
       little-endian GNU/Linux host systems. For nvptx offloading, with
       the OpenACC parallel construct, the execution model allows for an
       arbitrary number of gangs, up to 32 workers, and 32 vectors.
     * Initial support for parallelized execution of OpenACC kernels
       constructs:
          + Parallelization of a kernels region is switched on by
            -fopenacc combined with -O2 or higher.
          + Code is offloaded onto multiple gangs, but executes with just
            one worker, and a vector length of 1.
          + Directives inside a kernels region are not supported.
          + Loops with reductions can be parallelized.
          + Only kernels regions with one loop nest are parallelized.
          + Only the outer-most loop of a loop nest can be parallelized.
          + Loop nests containing sibling loops are not parallelized.
       Typically, using the OpenACC parallel construct gives much better
       performance, compared to the initial support of the OpenACC kernels
       construct.
     * The device_type clause is not supported. The bind and nohost
       clauses are not supported. The host_data directive is not supported
       in Fortran.
     * Nested parallelism (cf. CUDA dynamic parallelism) is not supported.
     * Usage of OpenACC constructs inside multithreaded contexts (such as
       created by OpenMP, or pthread programming) is not supported.
     * If a call to the acc_on_device function has a compile-time constant
       argument, the function call evaluates to a compile-time constant
       value only for C and C++ but not for Fortran.

   See the [6]OpenACC and [7]Offloading wiki pages for further
   information.

  C family

     * Version 4.5 of the [8]OpenMP specification is now supported in the
       C and C++ compilers.
     * The C and C++ compilers now support attributes on enumerators. For
       instance, it is now possible to mark enumerators as deprecated:

enum {
  newval,
  oldval __attribute__ ((deprecated ("too old")))
};

     * Source locations for the C and C++ compilers are now tracked as
       ranges, rather than just points, making it easier to identify the
       subexpression of interest within a complicated expression. For
       example:

test.cc: In function 'int test(int, int, foo, int, int)':
test.cc:5:16: error: no match for 'operator*' (operand types are 'int' and 'foo'
)
   return p + q * r * s + t;
              ~~^~~

       In addition, there is now initial support for precise diagnostic
       locations within strings:

format-strings.c:3:14: warning: field width specifier '*' expects a matching 'in
t' argument [-Wformat=]
   printf("%*d");
            ^

     * Diagnostics can now contain "fix-it hints", which are displayed in
       context underneath the relevant source code. For example:

fixits.c: In function 'bad_deref':
fixits.c:11:13: error: 'ptr' is a pointer; did you mean to use '->'?
   return ptr.x;
             ^
             ->

     * The C and C++ compilers now offer suggestions for misspelled field
       names:

spellcheck-fields.cc:52:13: error: 'struct s' has no member named 'colour'; did
you mean 'color'?
   return ptr->colour;
               ^~~~~~

     * New command-line options have been added for the C and C++
       compilers:
          + -Wshift-negative-value warns about left shifting a negative
            value.
          + -Wshift-overflow warns about left shift overflows. This
            warning is enabled by default. -Wshift-overflow=2 also warns
            about left-shifting 1 into the sign bit.
          + -Wtautological-compare warns if a self-comparison always
            evaluates to true or false. This warning is enabled by -Wall.
          + -Wnull-dereference warns if the compiler detects paths that
            trigger erroneous or undefined behavior due to dereferencing a
            null pointer. This option is only active when
            -fdelete-null-pointer-checks is active, which is enabled by
            optimizations in most targets. The precision of the warnings
            depends on the optimization options used.
          + -Wduplicated-cond warns about duplicated conditions in an
            if-else-if chain.
          + -Wmisleading-indentation warns about places where the
            indentation of the code gives a misleading idea of the block
            structure of the code to a human reader. For example, given
            [9]CVE-2014-1266:

sslKeyExchange.c: In function 'SSLVerifySignedServerKeyExchange':
sslKeyExchange.c:629:3: warning: this 'if' clause does not guard... [-Wmisleadin
g-indentation]
    if ((err = SSLHashSHA1.update(&hashCtx, &signedParams)) != 0)
    ^~
sslKeyExchange.c:631:5: note: ...this statement, but the latter is misleadingly
indented as if it is guarded by the 'if'
        goto fail;
        ^~~~

            This warning is enabled by -Wall.
     * The C and C++ compilers now emit saner error messages if
       merge-conflict markers are present in a source file.

test.c:3:1: error: version control conflict marker in file
 <<<<<<< HEAD
 ^~~~~~~

  C

     * It is possible to disable warnings when an initialized field of a
       structure or a union with side effects is being overridden when
       using designated initializers via a new warning option
       -Woverride-init-side-effects.
     * A new type attribute scalar_storage_order applying to structures
       and unions has been introduced. It specifies the storage order (aka
       endianness) in memory of scalar fields in structures or unions.

  C++

     * The default mode has been changed to -std=gnu++14.
     * [10]C++ Concepts are now supported when compiling with -fconcepts.
     * -flifetime-dse is more aggressive in dead-store elimination in
       situations where a memory store to a location precedes a
       constructor to that memory location.
     * G++ now supports [11]C++17 fold expressions, u8 character literals,
       extended static_assert, and nested namespace definitions.
     * G++ now allows constant evaluation for all non-type template
       arguments.
     * G++ now supports C++ Transactional Memory when compiling with
       -fgnu-tm.

    Runtime Library (libstdc++)

     * Extensions to the C++ Library to support mathematical special
       functions (ISO/IEC 29124:2010), thanks to Edward Smith-Rowland.
     * Experimental support for C++17, including the following new
       features:
          + std::uncaught_exceptions function (this is also available for
            -std=gnu++NN modes);
          + new member functions try_emplace and insert_or_assign for
            unique_key maps;
          + non-member functions std::size, std::empty, and std::data for
            accessing containers and arrays;
          + std::invoke;
          + std::shared_mutex;
          + std::void_t and std::bool_constant metaprogramming utilities.
       Thanks to Ville Voutilainen for contributing many of the C++17
       features.
     * An experimental implementation of the File System TS.
     * Experimental support for most features of the second version of the
       Library Fundamentals TS. This includes polymorphic memory resources
       and array support in shared_ptr, thanks to Fan You.
     * Some assertions checked by Debug Mode can now also be enabled by
       _GLIBCXX_ASSERTIONS. The subset of checks enabled by the new macro
       have less run-time overhead than the full _GLIBCXX_DEBUG checks and
       don't affect the library ABI, so can be enabled per-translation
       unit.
     * Timed mutex types are supported on more targets, including Darwin.
     * Improved std::locale support for DragonFly and FreeBSD, thanks to
       John Marino and Andreas Tobler.

  Fortran

     * Fortran 2008 SUBMODULE support.
     * Fortran 2015 EVENT_TYPE, EVENT_POST, EVENT_WAIT, and EVENT_QUERY
       support.
     * Improved support for Fortran 2003 deferred-length character
       variables.
     * Improved support for OpenMP and OpenACC.
     * The MATMUL intrinsic is now inlined for straightforward cases if
       front-end optimization is active. The maximum size for inlining can
       be set to n with the -finline-matmul-limit=n option and turned off
       with -finline-matmul-limit=0.
     * The -Wconversion-extra option will warn about REAL constants which
       have excess precision for their kind.
     * The -Winteger-division option has been added, which warns about
       divisions of integer constants which are truncated. This option is
       included in -Wall by default.

libgccjit

     * The driver code is now run in-process within libgccjit, providing a
       small speed-up of the compilation process.
     * The API has gained entrypoints for
          + [12]timing how long was spent in different parts of code,
          + [13]creating switch statements,
          + [14]allowing unreachable basic blocks in a function, and
          + [15]adding arbitrary command-line options to a compilation.

New Targets and Target Specific Improvements

  AArch64

     * A number of AArch64-specific options have been added. The most
       important ones are summarised in this section; for more detailed
       information please refer to the documentation.
     * The command-line options -march=native, -mcpu=native and
       -mtune=native are now available on native AArch64 GNU/Linux
       systems. Specifying these options causes GCC to auto-detect the
       host CPU and choose the optimal setting for that system.
     * -fpic is now supported when generating code for the small code
       model (-mcmodel=small). The size of the global offset table (GOT)
       is limited to 28KiB under the LP64 SysV ABI, and 15KiB under the
       ILP32 SysV ABI.
     * The AArch64 port now supports target attributes and pragmas. Please
       refer to the [16]documentation for details of available attributes
       and pragmas as well as usage instructions.
     * Link-time optimization across translation units with different
       target-specific options is now supported.
     * The option -mtls-size= is now supported. It can be used to specify
       the bit size of TLS offsets, allowing GCC to generate better TLS
       instruction sequences.
     * The option -fno-plt is now fully functional.
     * The ARMv8.1-A architecture and the Large System Extensions are now
       supported. They can be used by specifying the -march=armv8.1-a
       option. Additionally, the +lse option extension can be used in a
       similar fashion to other option extensions. The Large System
       Extensions introduce new instructions that are used in the
       implementation of atomic operations.
     * The ACLE half-precision floating-point type __fp16 is now supported
       in the C and C++ languages.
     * The ARM Cortex-A35 processor is now supported via the
       -mcpu=cortex-a35 and -mtune=cortex-a35 options as well as the
       equivalent target attributes and pragmas.
     * The Qualcomm QDF24xx processor is now supported via the
       -mcpu=qdf24xx and -mtune=qdf24xx options as well as the equivalent
       target attributes and pragmas.
     * Code generation for the ARM Cortex-A57 processor is improved. Among
       general code generation improvements, a better algorithm is added
       for allocating registers to floating-point multiply-accumulate
       instructions offering increased performance when compiling with
       -mcpu=cortex-a57 or -mtune=cortex-a57.
     * Code generation for the ARM Cortex-A53 processor is improved. A
       more accurate instruction scheduling model for the processor is now
       used, and a number of compiler tuning parameters have been set to
       offer increased performance when compiling with -mcpu=cortex-a53 or
       -mtune=cortex-a53.
     * Code generation for the Samsung Exynos M1 processor is improved. A
       more accurate instruction scheduling model for the processor is now
       used, and a number of compiler tuning parameters have been set to
       offer increased performance when compiling with -mcpu=exynos-m1 or
       -mtune=exynos-m1.
     * Improvements in the generation of conditional branches and literal
       pools allow the compiler to compile functions of a large size.
       Constant pools are now placed into separate rodata sections. The
       new option -mpc-relative-literal-loads generates per-function
       literal pools, limiting the maximum size of functions to 1MiB.
     * Several correctness issues generating Advanced SIMD instructions
       for big-endian targets have been fixed resulting in improved code
       generation for ACLE intrinsics with -mbig-endian.

  ARM

     * Support for revisions of the ARM architecture prior to ARMv4t has
       been deprecated and will be removed in a future GCC release. The
       -mcpu and -mtune values that are deprecated are: arm2, arm250,
       arm3, arm6, arm60, arm600, arm610, arm620, arm7, arm7d, arm7di,
       arm70, arm700, arm700i, arm710, arm720, arm710c, arm7100, arm7500,
       arm7500fe, arm7m, arm7dm, arm7dmi, arm8, arm810, strongarm,
       strongarm110, strongarm1100, strongarm1110, fa526, fa626. The value
       arm7tdmi is still supported. The values of -march that are
       deprecated are: armv2,armv2a,armv3,armv3m,armv4.
     * The ARM port now supports target attributes and pragmas. Please
       refer to the [17]documentation for details of available attributes
       and pragmas as well as usage instructions.
     * Support has been added for the following processors (GCC
       identifiers in parentheses): ARM Cortex-A32 (cortex-a32), ARM
       Cortex-A35 (cortex-a35) and ARM Cortex-R8 (cortex-r8). The GCC
       identifiers can be used as arguments to the -mcpu or -mtune
       options, for example: -mcpu=cortex-a32 or -mtune=cortex-a35.

  Heterogeneous Systems Architecture

     * GCC can now generate HSAIL (Heterogeneous System Architecture
       Intermediate Language) for simple OpenMP device constructs if
       configured with --enable-offload-targets=hsa. A new libgomp plugin
       then runs the HSA GPU kernels implementing these constructs on HSA
       capable GPUs via a standard HSA run time.
       If the HSA compilation back end determines it cannot output HSAIL
       for a particular input, it gives a warning by default. These
       warnings can be suppressed with -Wno-hsa. To give a few examples,
       the HSA back end does not implement compilation of code using
       function pointers, automatic allocation of variable sized arrays,
       functions with variadic arguments as well as a number of other less
       common programming constructs.
       When compilation for HSA is enabled, the compiler attempts to
       compile composite OpenMP constructs

#pragma omp target teams distribute parallel for

       into parallel HSA GPU kernels.

  IA-32/x86-64

     * GCC now supports the Intel CPU named Skylake with AVX-512
       extensions through -march=skylake-avx512. The switch enables the
       following ISA extensions: AVX-512F, AVX512VL, AVX-512CD, AVX-512BW,
       AVX-512DQ.
     * Support for new AMD instructions monitorx and mwaitx has been
       added. This includes new intrinsic and built-in support. It is
       enabled through option -mmwaitx. The instructions monitorx and
       mwaitx implement the same functionality as the old monitor and
       mwait instructions. In addition mwaitx adds a configurable timer.
       The timer value is received as third argument and stored in
       register %ebx.
     * x86-64 targets now allow stack realignment from a word-aligned
       stack pointer using the command-line option -mstackrealign or
       __attribute__ ((force_align_arg_pointer)). This allows functions
       compiled with a vector-aligned stack to be invoked from objects
       that keep only word-alignment.
     * Support for address spaces __seg_fs, __seg_gs, and __seg_tls. These
       can be used to access data via the %fs and %gs segments without
       having to resort to inline assembly. Please refer to the
       [18]documentation for usage instructions.
     * Support for AMD Zen (family 17h) processors is now available
       through the -march=znver1 and -mtune=znver1 options.

  MeP

     * Support for the MeP (mep-elf) architecture has been deprecated and
       will be removed in a future GCC release.

  MSP430

     * The MSP430 compiler now has the ability to automatically distribute
       code and data between low memory (addresses below 64K) and high
       memory. This only applies to parts that actually have both memory
       regions and only if the linker script for the part has been
       specifically set up to support this feature.
       A new attribute of either can be applied to both functions and
       data, and this tells the compiler to place the object into low
       memory if there is room and into high memory otherwise. Two other
       new attributes - lower and upper - can be used to explicitly state
       that an object should be placed in the specified memory region. If
       there is not enough left in that region the compilation will fail.
       Two new command-line options - -mcode-region=[lower|upper|either]
       and -mdata-region=[lower|upper|either] - can be used to tell the
       compiler what to do with objects that do not have one of these new
       attributes.

  PowerPC / PowerPC64 / RS6000

     * PowerPC64 now supports IEEE 128-bit floating-point using the
       __float128 data type. In GCC 6, this is not enabled by default, but
       you can enable it with -mfloat128. The IEEE 128-bit floating-point
       support requires the use of the VSX instruction set. IEEE 128-bit
       floating-point values are passed and returned as a single vector
       value. The software emulator for IEEE 128-bit floating-point
       support is only built on PowerPC GNU/Linux systems where the
       default CPU is at least power7. On future ISA 3.0 systems (POWER 9
       and later), you will be able to use the -mfloat128-hardware option
       to use the ISA 3.0 instructions that support IEEE 128-bit
       floating-point. An additional type (__ibm128) has been added to
       refer to the IBM extended double type that normally implements long
       double. This will allow for a future transition to implementing
       long double with IEEE 128-bit floating-point.
     * Basic support has been added for POWER9 hardware that will use the
       recently published OpenPOWER ISA 3.0 instructions. The following
       new switches are available:
          + -mcpu=power9: Implement all of the ISA 3.0 instructions
            supported by the compiler.
          + -mtune=power9: In the future, apply tuning for POWER9 systems.
            Currently, POWER8 tunings are used.
          + -mmodulo: Generate code using the ISA 3.0 integer instructions
            (modulus, count trailing zeros, array index support, integer
            multiply/add).
          + -mpower9-fusion: Generate code to suitably fuse instruction
            sequences for a POWER9 system.
          + -mpower9-dform: Generate code to use the new D-form
            (register+offset) memory instructions for the vector
            registers.
          + -mpower9-vector: Generate code using the new ISA 3.0 vector
            (VSX or Altivec) instructions.
          + -mpower9-minmax: Reserved for future development.
          + -mtoc-fusion: Keep TOC entries together to provide more fusion
            opportunities.
     * New constraints have been added to support IEEE 128-bit
       floating-point and ISA 3.0 instructions:
          + wb: Altivec register if -mpower9-dform is enabled.
          + we: VSX register if -mpower9-vector is enabled for 64-bit code
            generation.
          + wo: VSX register if -mpower9-vector is enabled.
          + wp: Reserved for future use if long double is implemented with
            IEEE 128-bit floating-point instead of IBM extended double.
          + wq: VSX register if -mfloat128 is enabled.
          + wF: Memory operand suitable for POWER9 fusion load/store.
          + wG: Memory operand suitable for TOC fusion memory references.
          + wL: Integer constant identifying the element number mfvsrld
            accesses within a vector.
     * Support has been added for __builtin_cpu_is() and
       __builtin_cpu_supports(), allowing for very fast access to
       AT_PLATFORM, AT_HWCAP, and AT_HWCAP2 values. This requires use of
       glibc 2.23 or later.
     * All hardware transactional memory builtins now correctly behave as
       memory barriers. Programmers can use #ifdef __TM_FENCE__ to
       determine whether their "old" compiler treats the builtins as
       barriers.
     * Split-stack support has been added for gccgo on PowerPC64 for both
       big- and little-endian (but not for 32-bit). The gold linker from
       at least binutils 2.25.1 must be available in the PATH when
       configuring and building gccgo to enable split stack. (The
       requirement for binutils 2.25.1 applies to PowerPC64 only.) The
       split-stack feature allows a small initial stack size to be
       allocated for each goroutine, which increases as needed.
     * GCC on PowerPC now supports the standard lround function.
     * A new configuration option ---with-advance-toolchain=at was added
       for PowerPC 64-bit GNU/Linux systems to use the header files,
       library files, and the dynamic linker from a specific Advance
       Toolchain release instead of the default versions that are provided
       by the GNU/Linux distribution. In general, this option is intended
       for the developers of GCC, and it is not intended for general use.
     * The "q", "S", "T", and "t" asm-constraints have been removed.
     * The "b", "B", "m", "M", and "W" format modifiers have been removed.

  S/390, System z, IBM z Systems

     * Support for the IBM z13 processor has been added. When using the
       -march=z13 option, the compiler will generate code making use of
       the new instructions and registers introduced with the vector
       extension facility. The -mtune=z13 option enables z13 specific
       instruction scheduling without making use of new instructions.
       Compiling code with -march=z13 reduces the default alignment of
       vector types bigger than 8 bytes to 8. This is an ABI change and
       care must be taken when linking modules compiled with different
       arch levels which interchange variables containing vector type
       values. For newly compiled code the GNU linker will emit a warning.
     * The -mzvector option enables a C/C++ language extension. This
       extension provides a new keyword vector which can be used to define
       vector type variables. (Note: This is not available when enforcing
       strict standard compliance e.g. with -std=c99. Either enable GNU
       extensions with e.g. -std=gnu99 or use __vector instead of vector.)
       Additionally a set of overloaded builtins is provided which is
       partially compatible to the PowerPC Altivec builtins. In order to
       make use of these builtins the vecintrin.h header file needs to be
       included.
     * The new command-line options -march=native, and -mtune=native are
       now available on native IBM z Systems. Specifying these options
       causes GCC to auto-detect the host CPU and choose the optimal
       setting for that system. If GCC is unable to detect the host CPU
       these options have no effect.
     * The IBM z Systems port now supports target attributes and pragmas.
       Please refer to the [19]documentation for details of available
       attributes and pragmas as well as usage instructions.
     * -fsplit-stack is now supported as part of the IBM z Systems port.
       This feature requires a recent gold linker to be used.
     * Support for the g5 and g6 -march=/-mtune= CPU level switches has
       been deprecated and will be removed in a future GCC release. -m31
       from now on defaults to -march=z900 if not specified otherwise.
       -march=native on a g5/g6 machine will default to -march=z900.

  SH

     * Support for SH5 / SH64 has been declared obsolete and will be
       removed in future releases.
     * Support for the FDPIC ABI has been added. It can be enabled using
       the new -mfdpic target option and --enable-fdpic configure option.

  SPARC

     * An ABI bug has been fixed in 64-bit mode. Unfortunately, this
       change will break binary compatibility with earlier releases for
       code it affects, but this should be pretty rare in practice. The
       conditions are: a 16-byte structure containing a double or a 8-byte
       vector in the second half is passed to a subprogram in slot #15,
       for example as 16th parameter if the first 15 ones have at most 8
       bytes. The double or vector was wrongly passed in floating-point
       register %d32 in lieu of on the stack as per the SPARC calling
       conventions.

Operating Systems

  AIX

     * DWARF debugging support for AIX 7.1 has been enabled as an optional
       debugging format. A more recent Technology Level (TL) and GCC built
       with that level are required for full exploitation of DWARF
       debugging capabilities.

  Linux

     * Support for the [20]musl C library was added for the AArch64, ARM,
       MicroBlaze, MIPS, MIPS64, PowerPC, PowerPC64, SH, i386, x32 and
       x86_64 targets. It can be selected using the new -mmusl option in
       case musl is not the default libc. GCC defaults to musl libc if it
       is built with a target triplet matching the *-linux-musl* pattern.

  RTEMS

     * The RTEMS thread model implementation changed. Mutexes now use
       self-contained objects defined in Newlib <sys/lock.h> instead of
       Classic API semaphores. The keys for thread specific data and the
       once function are directly defined via <pthread.h>. Self-contained
       condition variables are provided via Newlib <sys/lock.h>. The RTEMS
       thread model also supports C++11 threads.
     * OpenMP support now uses self-contained objects provided by Newlib
       <sys/lock.h> and offers a significantly better performance compared
       to the POSIX configuration of libgomp. It is possible to configure
       thread pools for each scheduler instance via the environment
       variable GOMP_RTEMS_THREAD_POOLS.

  Solaris

     * Solaris 12 is now fully supported. Minimal support had already been
       present in GCC 5.3.
     * Solaris 12 provides a full set of startup files (crt1.o, crti.o,
       crtn.o), which GCC now prefers over its own ones.
     * Position independent executables (PIE) are now supported on Solaris
       12.
     * Constructor priority is now supported on Solaris 12 with the system
       linker.
     * libvtv has been ported to Solaris 11 and up.

  Windows

     * The option -mstackrealign is now automatically activated in 32-bit
       mode whenever the use of SSE instructions is requested.

Other significant improvements

     * The gcc and g++ driver programs will now provide suggestions for
       misspelled command-line options.

$ gcc -static-libfortran test.f95
gcc: error: unrecognized command line option '-static-libfortran'; did you mean
'-static-libgfortran'?

     * The --enable-default-pie configure option enables generation of PIE
       by default.

                                    GCC 6.2

   This is the [21]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 6.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

Target Specific Changes

  SPARC

     * Support for --with-cpu-32 and --with-cpu-64 configure options has
       been added on bi-architecture platforms.
     * Support for the SPARC M7 (Niagara 7) processor has been added.
     * Support for the VIS 4.0 instruction set has been added.

                                    GCC 6.3

   This is the [22]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 6.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

Target Specific Changes

  IA-32/x86-64

     * Support for the [23]deprecated pcommit instruction has been
       removed.

                                    GCC 6.4

   This is the [24]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 6.4 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

Operating Systems

  RTEMS

     * The ABI changes on ARM so that no short enums are used by default.


    For questions related to the use of GCC, please consult these web
    pages and the [25]GCC manuals. If that fails, the
    [26]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [27]gcc@gcc.gnu.org. All of [28]our lists have public
    archives.

   Copyright (C) [29]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [30]maintained by the GCC team. Last modified
   2017-07-04[31].

References

   1. http://gcc.gnu.org/gcc-6/porting_to.html
   2. http://gcc.gnu.org/onlinedocs/index.html#current
   3. https://gcc.gnu.org/ml/gcc/2015-08/msg00101.html
   4. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=71151
   5. https://www.openacc.org/
   6. https://gcc.gnu.org/wiki/OpenACC
   7. https://gcc.gnu.org/wiki/Offloading
   8. http://www.openmp.org/specifications/
   9. https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2014-1266
  10. http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2015/n4377.pdf
  11. https://gcc.gnu.org/projects/cxx-status.html#cxx1z
  12. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/jit/topics/performance.html
  13. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/jit/topics/functions.html#gcc_jit_block_end_with_switch
  14. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/jit/topics/contexts.html#gcc_jit_context_set_bool_allow_unreachable_blocks
  15. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/jit/topics/contexts.html#gcc_jit_context_add_command_line_option
  16. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/gcc/AArch64-Function-Attributes.html#AArch64-Function-Attributes
  17. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/gcc/ARM-Function-Attributes.html#ARM-Function-Attributes
  18. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/gcc/Named-Address-Spaces.html#Named-Address-Spaces
  19. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/gcc/S_002f390-Function-Attributes.html#S_002f390-Function-Attributes
  20. http://www.musl-libc.org/
  21. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=6.2
  22. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=6.3
  23. https://software.intel.com/en-us/blogs/2016/09/12/deprecate-pcommit-instruction
  24. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=6.4
  25. https://gcc.gnu.org/onlinedocs/
  26. mailto:gcc-help@gcc.gnu.org
  27. mailto:gcc@gcc.gnu.org
  28. https://gcc.gnu.org/lists.html
  29. http://www.fsf.org/
  30. https://gcc.gnu.org/about.html
  31. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-5/index.html

                              GCC 5 Release Series

   October 10, 2017

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 5.5.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 5.4 relative to previous releases of GCC.

Release History

   GCC 5.5
          October 10, 2017 ([2]changes, [3]documentation)

   GCC 5.4
          June 3, 2016 ([4]changes, [5]documentation)

   GCC 5.3
          December 4, 2015 ([6]changes, [7]documentation)

   GCC 5.2
          July 16, 2015 ([8]changes, [9]documentation)

   GCC 5.1
          April 22, 2015 ([10]changes, [11]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [12]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [13]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [14]GCC
   project web site or contact the [15]GCC development mailing list.

   To obtain GCC please use [16]our mirror sites or [17]our SVN server.


    For questions related to the use of GCC, please consult these web
    pages and the [18]GCC manuals. If that fails, the
    [19]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [20]gcc@gcc.gnu.org. All of [21]our lists have public
    archives.

   Copyright (C) [22]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [23]maintained by the GCC team. Last modified
   2017-10-10[24].

References

   1. http://www.gnu.org/
   2. http://gcc.gnu.org/gcc-5/changes.html
   3. http://gcc.gnu.org/onlinedocs/5.5.0/
   4. http://gcc.gnu.org/gcc-5/changes.html
   5. http://gcc.gnu.org/onlinedocs/5.4.0/
   6. http://gcc.gnu.org/gcc-5/changes.html
   7. http://gcc.gnu.org/onlinedocs/5.3.0/
   8. http://gcc.gnu.org/gcc-5/changes.html
   9. http://gcc.gnu.org/onlinedocs/5.2.0/
  10. http://gcc.gnu.org/gcc-5/changes.html
  11. http://gcc.gnu.org/onlinedocs/5.1.0/
  12. http://gcc.gnu.org/gcc-5/buildstat.html
  13. http://gcc.gnu.org/onlinedocs/gcc/Contributors.html
  14. http://gcc.gnu.org/index.html
  15. mailto:gcc@gcc.gnu.org
  16. http://gcc.gnu.org/mirrors.html
  17. http://gcc.gnu.org/svn.html
  18. https://gcc.gnu.org/onlinedocs/
  19. mailto:gcc-help@gcc.gnu.org
  20. mailto:gcc@gcc.gnu.org
  21. https://gcc.gnu.org/lists.html
  22. http://www.fsf.org/
  23. https://gcc.gnu.org/about.html
  24. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-5/changes.html

                              GCC 5 Release Series
                        Changes, New Features, and Fixes

Caveats

     * The default mode for C is now -std=gnu11 instead of -std=gnu89.
     * The C++ runtime library (libstdc++) uses a new ABI by default (see
       [1]below).
     * The Graphite framework for loop optimizations no longer requires
       the CLooG library, only ISL version 0.14 (recommended) or 0.12.2.
       The installation manual contains more information about
       requirements to build GCC.
     * The non-standard C++0x type traits has_trivial_default_constructor,
       has_trivial_copy_constructor and has_trivial_copy_assign have been
       deprecated and will be removed in a future version. The standard
       C++11 traits is_trivially_default_constructible,
       is_trivially_copy_constructible and is_trivially_copy_assignable
       should be used instead.
     * On AVR, support has been added for the devices
       ATtiny4/5/9/10/20/40. This requires Binutils 2.25 or newer.
     * The AVR port uses a new scheme to describe supported devices: For
       each supported device the compiler provides a device-specific
       [2]spec file. If the compiler is used together with AVR-LibC, this
       requires at least GCC 5.2 and a version of AVR-LibC which
       implements [3]feature #44574.

General Optimizer Improvements

     * Inter-procedural optimization improvements:
          + An Identical Code Folding (ICF) pass (controlled via
            -fipa-icf) has been added. Compared to the identical code
            folding performed by the Gold linker this pass does not
            require function sections. It also performs merging before
            inlining, so inter-procedural optimizations are aware of the
            code re-use. On the other hand not all unifications performed
            by a linker are doable by GCC which must honor aliasing
            information. During link-time optimization of Firefox, this
            pass unifies about 31000 functions, that is 14% overall.
          + The devirtualization pass was significantly improved by adding
            better support for speculative devirtualization and dynamic
            type detection. About 50% of virtual calls in Firefox are now
            speculatively devirtualized during link-time optimization.
          + A new comdat localization pass allows the linker to eliminate
            more dead code in presence of C++ inline functions.
          + Virtual tables are now optimized. Local aliases are used to
            reduce dynamic linking time of C++ virtual tables on ELF
            targets and data alignment has been reduced to limit data
            segment bloat.
          + A new -fno-semantic-interposition option can be used to
            improve code quality of shared libraries where interposition
            of exported symbols is not allowed.
          + Write-only variables are now detected and optimized out.
          + With profile feedback the function inliner can now bypass
            --param inline-insns-auto and --param inline-insns-single
            limits for hot calls.
          + The IPA reference pass was significantly sped up making it
            feasible to enable -fipa-reference with -fprofile-generate.
            This also solves a bottleneck seen when building Chromium with
            link-time optimization.
          + The symbol table and call-graph API was reworked to C++ and
            simplified.
          + The interprocedural propagation of constants now also
            propagates alignments of pointer parameters. This for example
            means that the vectorizer often does not need to generate loop
            prologues and epilogues to make up for potential
            misalignments.
     * Link-time optimization improvements:
          + One Definition Rule based merging of C++ types has been
            implemented. Type merging enables better devirtualization and
            alias analysis. Streaming extra information needed to merge
            types adds about 2-6% of memory size and object size increase.
            This can be controlled by -flto-odr-type-merging.
          + Command-line optimization and target options are now streamed
            on a per-function basis and honored by the link-time
            optimizer. This change makes link-time optimization a more
            transparent replacement of per-file optimizations. It is now
            possible to build projects that require different optimization
            settings for different translation units (such as -ffast-math,
            -mavx, or -finline). Contrary to earlier GCC releases, the
            optimization and target options passed on the link command
            line are ignored.
            Note that this applies only to those command-line options that
            can be passed to optimize and target attributes. Command-line
            options affecting global code generation (such as -fpic),
            warnings (such as -Wodr), optimizations affecting the way
            static variables are optimized (such as -fcommon), debug
            output (such as -g), and --param parameters can be applied
            only to the whole link-time optimization unit. In these cases,
            it is recommended to consistently use the same options at both
            compile time and link time.
          + GCC bootstrap now uses slim LTO object files.
          + Memory usage and link times were improved. Tree merging was
            sped up, memory usage of GIMPLE declarations and types was
            reduced, and, support for on-demand streaming of variable
            constructors was added.
     * Feedback directed optimization improvements:
          + A new auto-FDO mode uses profiles collected by low overhead
            profiling tools (perf) instead of more expensive program
            instrumentation (via -fprofile-generate). SPEC2006 benchmarks
            on x86-64 improve by 4.7% with auto-FDO and by 7.3% with
            traditional feedback directed optimization.
          + Profile precision was improved in presence of C++ inline and
            extern inline functions.
          + The new gcov-tool utility allows manipulating profiles.
          + Profiles are now more tolerant to source file changes (this
            can be controlled by --param profile-func-internal-id).
     * Register allocation improvements:
          + A new local register allocator (LRA) sub-pass, controlled by
            -flra-remat, implements control-flow sensitive global register
            rematerialization. Instead of spilling and restoring a
            register value, it is recalculated if it is profitable. The
            sub-pass improved SPEC2000 generated code by 1% and 0.5%
            correspondingly on ARM and x86-64.
          + Reuse of the PIC hard register, instead of using a fixed
            register, was implemented on x86/x86-64 targets. This improves
            generated PIC code performance as more hard registers can be
            used. Shared libraries can significantly benefit from this
            optimization. Currently it is switched on only for x86/x86-64
            targets. As RA infrastructure is already implemented for PIC
            register reuse, other targets might follow this in the future.
          + A simple form of inter-procedural RA was implemented. When it
            is known that a called function does not use caller-saved
            registers, save/restore code is not generated around the call
            for such registers. This optimization can be controlled by
            -fipa-ra
          + LRA is now much more effective at generating spills of general
            registers into vector registers instead of memory on
            architectures (e.g., modern Intel processors) where this is
            profitable.
     * UndefinedBehaviorSanitizer gained a few new sanitization options:
          + -fsanitize=float-divide-by-zero: detect floating-point
            division by zero;
          + -fsanitize=float-cast-overflow: check that the result of
            floating-point type to integer conversions do not overflow;
          + -fsanitize=bounds: enable instrumentation of array bounds and
            detect out-of-bounds accesses;
          + -fsanitize=alignment: enable alignment checking, detect
            various misaligned objects;
          + -fsanitize=object-size: enable object size checking, detect
            various out-of-bounds accesses.
          + -fsanitize=vptr: enable checking of C++ member function calls,
            member accesses and some conversions between pointers to base
            and derived classes, detect if the referenced object does not
            have the correct dynamic type.
     * Pointer Bounds Checker, a bounds violation detector, has been added
       and can be enabled via -fcheck-pointer-bounds. Memory accesses are
       instrumented with run-time checks of used pointers against their
       bounds to detect pointer bounds violations (overflows). The Pointer
       Bounds Checker is available on x86/x86-64 GNU/Linux targets with a
       new ISA extension Intel MPX support. See the Pointer Bounds Checker
       [4]Wiki page for more details.

New Languages and Language specific improvements

     * [5]OpenMP 4.0 specification offloading features are now supported
       by the C, C++, and Fortran compilers. Generic changes:
          + Infrastructure (suitable for any vendor).
          + Testsuite which covers offloading from the [6]OpenMP 4.0
            Examples document.
       Specific for upcoming Intel Xeon Phi products:
          + Run-time library.
          + Card emulator.
     * GCC 5 includes a preliminary implementation of the OpenACC 2.0a
       specification. OpenACC is intended for programming accelerator
       devices such as GPUs. See [7]the OpenACC wiki page for more
       information.

  C family

     * The default setting of the -fdiagnostics-color= command-line option
       is now [8]configurable when building GCC using configuration option
       --with-diagnostics-color=. The possible values are: never, always,
       auto and auto-if-env. The new default auto uses color only when the
       standard error is a terminal. The default in GCC 4.9 was
       auto-if-env, which is equivalent to auto if there is a non-empty
       GCC_COLORS environment variable, and never otherwise. As in GCC
       4.9, an empty GCC_COLORS variable in the environment will always
       disable colors, no matter what the default is or what command-line
       options are used.
     * A new command-line option -Wswitch-bool has been added for the C
       and C++ compilers, which warns whenever a switch statement has an
       index of boolean type.
     * A new command-line option -Wlogical-not-parentheses has been added
       for the C and C++ compilers, which warns about "logical not" used
       on the left hand side operand of a comparison.
     * A new command-line option -Wsizeof-array-argument has been added
       for the C and C++ compilers, which warns when the sizeof operator
       is applied to a parameter that has been declared as an array in a
       function definition.
     * A new command-line option -Wbool-compare has been added for the C
       and C++ compilers, which warns about boolean expressions compared
       with an integer value different from true/false.
     * Full support for [9]Cilk Plus has been added to the GCC compiler.
       Cilk Plus is an extension to the C and C++ languages to support
       data and task parallelism.
     * A new attribute no_reorder prevents reordering of selected symbols
       against other such symbols or inline assembler. This enables to
       link-time optimize the Linux kernel without having to resort to
       -fno-toplevel-reorder that disables several optimizations.
     * New preprocessor constructs, __has_include and __has_include_next,
       to test the availability of headers have been added.
       This demonstrates a way to include the header <optional> only if it
       is available:

#ifdef __has_include
#  if __has_include(<optional>)
#    include <optional>
#    define have_optional 1
#  elif __has_include(<experimental/optional>)
#    include <experimental/optional>
#    define have_optional 1
#    define experimental_optional
#  else
#    define have_optional 0
#  endif
#endif

       The header search paths for __has_include and __has_include_next
       are equivalent to those of the standard directive #include and the
       extension #include_next respectively.
     * A new built-in function-like macro to determine the existence of an
       attribute, __has_attribute, has been added. The equivalent built-in
       macro __has_cpp_attribute was added to C++ to support
       [10]Feature-testing recommendations for C++. The macro
       __has_attribute is added to all C-like languages as an extension:

int
#ifdef __has_attribute
#  if __has_attribute(__noinline__)
  __attribute__((__noinline__))
#  endif
#endif
foo(int x);

       If an attribute exists, a nonzero constant integer is returned. For
       standardized C++ attributes a date is returned, otherwise the
       constant returned is 1. Both __has_attribute and
       __has_cpp_attribute will add underscores to an attribute name if
       necessary to resolve the name. For C++11 and onwards the attribute
       may be scoped.
     * A new set of built-in functions for arithmetics with overflow
       checking has been added: __builtin_add_overflow,
       __builtin_sub_overflow and __builtin_mul_overflow and for
       compatibility with clang also other variants. These builtins have
       two integral arguments (which don't need to have the same type),
       the arguments are extended to infinite precision signed type, +, -
       or * is performed on those, and the result is stored in an integer
       variable pointed to by the last argument. If the stored value is
       equal to the infinite precision result, the built-in functions
       return false, otherwise true. The type of the integer variable that
       will hold the result can be different from the types of the first
       two arguments. The following snippet demonstrates how this can be
       used in computing the size for the calloc function:

void *
calloc (size_t x, size_t y)
{
  size_t sz;
  if (__builtin_mul_overflow (x, y, &sz))
    return NULL;
  void *ret = malloc (sz);
  if (ret) memset (res, 0, sz);
  return ret;
}

       On e.g. i?86 or x86-64 the above will result in a mul instruction
       followed by a jump on overflow.
     * The option -fextended-identifiers is now enabled by default for
       C++, and for C99 and later C versions. Various bugs in the
       implementation of extended identifiers have been fixed.

  C

     * The default mode has been changed to -std=gnu11.
     * A new command-line option -Wc90-c99-compat has been added to warn
       about features not present in ISO C90, but present in ISO C99.
     * A new command-line option -Wc99-c11-compat has been added to warn
       about features not present in ISO C99, but present in ISO C11.
     * It is possible to disable warnings about conversions between
       pointers that have incompatible types via a new warning option
       -Wno-incompatible-pointer-types; warnings about implicit
       incompatible integer to pointer and pointer to integer conversions
       via a new warning option -Wno-int-conversion; and warnings about
       qualifiers on pointers being discarded via a new warning option
       -Wno-discarded-qualifiers.
     * To allow proper use of const qualifiers with multidimensional
       arrays, GCC will not warn about incompatible pointer types anymore
       for conversions between pointers to arrays with and without const
       qualifier (except when using -pedantic). Instead, a new warning is
       emitted only if the const qualifier is lost. This can be controlled
       with a new warning option -Wno-discarded-array-qualifiers.
     * The C front end now generates more precise caret diagnostics.
     * The -pg command-line option now only affects the current file in an
       LTO build.

  C++

     * G++ now supports [11]C++14 variable templates.
     * -Wnon-virtual-dtor doesn't warn anymore for final classes.
     * Excessive template instantiation depth is now a fatal error. This
       prevents excessive diagnostics that usually do not help to identify
       the problem.
     * G++ and libstdc++ now implement the feature-testing macros from
       [12]Feature-testing recommendations for C++.
     * G++ now allows typename in a template template parameter.

template<template<typename> typename X> struct D; // OK

     * G++ now supports [13]C++14 aggregates with non-static data member
       initializers.

struct A { int i, j = i; };
A a = { 42 }; // a.j is also 42

     * G++ now supports [14]C++14 extended constexpr.

constexpr int f (int i)
{
  int j = 0;
  for (; i > 0; --i)
    ++j;
  return j;
}

constexpr int i = f(42); // i is 42

     * G++ now supports the [15]C++14 sized deallocation functions.

void operator delete (void *, std::size_t) noexcept;
void operator delete[] (void *, std::size_t) noexcept;

     * A new One Definition Rule violation warning (controlled by -Wodr)
       detects mismatches in type definitions and virtual table contents
       during link-time optimization.
     * New warnings -Wsuggest-final-types and -Wsuggest-final-methods help
       developers to annotate programs with final specifiers (or anonymous
       namespaces) to improve code generation. These warnings can be used
       at compile time, but they are more useful in combination with
       link-time optimization.
     * G++ no longer supports [16]N3639 variable length arrays, as they
       were removed from the C++14 working paper prior to ratification.
       GNU VLAs are still supported, so VLA support is now the same in
       C++14 mode as in C++98 and C++11 modes.
     * G++ now allows passing a non-trivially-copyable class via C
       varargs, which is conditionally-supported with
       implementation-defined semantics in the standard. This uses the
       same calling convention as a normal value parameter.
     * G++ now defaults to -fabi-version=9 and -fabi-compat-version=2. So
       various mangling bugs are fixed, but G++ will still emit aliases
       with the old, wrong mangling where feasible. -Wabi=2 will warn
       about differences between ABI version 2 and the current setting.
     * G++ 5.2 fixes the alignment of std::nullptr_t. Most code is likely
       to be unaffected, but -Wabi=8 will warn about a non-static data
       member with type std::nullptr_t which changes position due to this
       change.

    Runtime Library (libstdc++)

     * A [17]Dual ABI is provided by the library. A new ABI is enabled by
       default. The old ABI is still supported and can be used by defining
       the macro _GLIBCXX_USE_CXX11_ABI to 0 before including any C++
       standard library headers.
     * A new implementation of std::string is enabled by default, using
       the small string optimization instead of copy-on-write reference
       counting.
     * A new implementation of std::list is enabled by default, with an
       O(1) size() function;
     * [18]Full support for C++11, including the following new features:
          + std::deque and std::vector<bool> meet the allocator-aware
            container requirements;
          + movable and swappable iostream classes;
          + support for std::align and std::aligned_union;
          + type traits std::is_trivially_copyable,
            std::is_trivially_constructible, std::is_trivially_assignable
            etc.;
          + I/O manipulators std::put_time, std::get_time, std::hexfloat
            and std::defaultfloat;
          + generic locale-aware std::isblank;
          + locale facets for Unicode conversion;
          + atomic operations for std::shared_ptr;
          + std::notify_all_at_thread_exit() and functions for making
            futures ready at thread exit.
     * Support for the C++11 hexfloat manipulator changes how the num_put
       facet formats floating point types when
       ios_base::fixed|ios_base::scientific is set in a stream's fmtflags.
       This change affects all language modes, even though the C++98
       standard gave no special meaning to that combination of flags. To
       prevent the use of hexadecimal notation for floating point types
       use str.unsetf(std::ios_base::floatfield) to clear the relevant
       bits in str.flags().
     * [19]Full experimental support for C++14, including the following
       new features:
          + std::is_final type trait;
          + heterogeneous comparison lookup in associative containers.
          + global functions cbegin, cend, rbegin, rend, crbegin, and
            crend for range access to containers, arrays and initializer
            lists.
     * [20]Improved experimental support for the Library Fundamentals TS,
       including:
          + class std::experimental::any;
          + function template std::experimental::apply;
          + function template std::experimental::sample;
          + function template std::experimental::search and related
            searcher types;
          + variable templates for type traits;
          + function template std::experimental::not_fn.
     * New random number distributions logistic_distribution and
       uniform_on_sphere_distribution as extensions.
     * [21]GDB Xmethods for containers and std::unique_ptr.

  Fortran

     * Compatibility notice:
          + The version of the module files (.mod) has been incremented.
          + For free-form source files [22]-Werror=line-truncation is now
            enabled by default. Note that comments exceeding the line
            length are not diagnosed. (For fixed-form source code, the
            same warning is available but turned off by default, such that
            excess characters are ignored. -ffree-line-length-n and
            -ffixed-line-length-n can be used to modify the default line
            lengths of 132 and 72 columns, respectively.)
          + The -Wtabs option is now more sensible: with -Wtabs the
            compiler warns if it encounters tabs and with -Wno-tabs this
            warning is turned off. Before, -Wno-tabs warned and -Wtabs
            disabled the warning. As before, this warning is also enabled
            by -Wall, -pedantic and the f95, f2003, f2008 and f2008ts
            options of -std=.
     * Incomplete support for colorizing diagnostics emitted by gfortran
       has been added. The option [23]-fdiagnostics-color controls when
       color is used in diagnostics. The default value of this option can
       be [24]configured when building GCC. The GCC_COLORS environment
       variable can be used to customize the colors or disable coloring
       completely. Sample diagnostics output:
      $ gfortran -fdiagnostics-color=always -Wuse-without-only test.f90
      test.f90:6:1:

       0 continue
       1
      Error: Zero is not a valid statement label at (1)
      test.f90:9:6:

         USE foo
            1
      Warning: USE statement at (1) has no ONLY qualifier [-Wuse-without-only]

     * The -Wuse-without-only option has been added to warn when a USE
       statement has no ONLY qualifier and thus implicitly imports all
       public entities of the used module.
     * Formatted READ and WRITE statements now work correctly in
       locale-aware programs. For more information and potential caveats,
       see [25]Section 5.3 Thread-safety of the runtime library in the
       manual.
     * [26]Fortran 2003:
          + The intrinsic IEEE modules (IEEE_FEATURES, IEEE_EXCEPTIONS and
            IEEE_ARITHMETIC) are now supported.
     * [27]Fortran 2008:
          + [28]Coarrays: Full experimental support of Fortran 2008's
            coarrays with -fcoarray=lib except for allocatable/pointer
            components of derived-type coarrays. GCC currently only ships
            with a single-image library (libcaf_single), but multi-image
            support based on MPI and GASNet is provided by the libraries
            of the [29]OpenCoarrays project.
     * TS18508 Additional Parallel Features in Fortran:
          + Support for the collective intrinsic subroutines CO_MAX,
            CO_MIN, CO_SUM, CO_BROADCAST and CO_REDUCE has been added,
            including -fcoarray=lib support.
          + Support for the new atomic intrinsics has been added,
            including -fcoarray=lib support.
     * Fortran 2015:
          + Support for IMPLICIT NONE (external, type).
          + ERROR STOP is now permitted in pure procedures.

  Go

     * GCC 5 provides a complete implementation of the Go 1.4.2 release.
     * Building GCC 5 with Go enabled will install two new programs:
       [30]go and [31]gofmt.

libgccjit

   New in GCC 5 is the ability to build GCC as a shared library for
   embedding in other processes (such as interpreters), suitable for
   Just-In-Time compilation to machine code.

   The shared library has a [32]C API and a [33]C++ wrapper API providing
   some "syntactic sugar". There are also bindings available from 3rd
   parties for [34]Python and for [35]D.

   For example, this library can be used by interpreters for [36]compiling
   functions from bytecode to machine code.

   The library can also be used for ahead-of-time compilation, enabling
   GCC to be plugged into a pre-existing frontend. An example of using
   this to build a compiler for an esoteric language we'll refer to as
   "brainf" can be seen [37]here.

   libgccjit is licensed under the GPLv3 (or at your option, any later
   version)

   It should be regarded as experimental at this time.

New Targets and Target Specific Improvements

  Reporting stack usage

     * The BFIN, FT32, H8300, IQ2000 and M32C targets now support the
       -fstack-usage option.

  AArch64

     * Code generation for the ARM Cortex-A57 processor has been improved.
       A more accurate instruction scheduling model for the processor is
       now used, and a number of compiler tuning parameters have been set
       to offer increased performance when compiling with -mcpu=cortex-a57
       or -mtune=cortex-a57.
     * A workaround for the ARM Cortex-A53 erratum 835769 has been added
       and can be enabled by giving the -mfix-cortex-a53-835769 option.
       Alternatively it can be enabled by default by configuring GCC with
       the --enable-fix-cortex-a53-835769 option.
     * The optional cryptographic extensions to the ARMv8-A architecture
       are no longer enabled by default when specifying the
       -mcpu=cortex-a53, -mcpu=cortex-a57 or -mcpu=cortex-a57.cortex-a53
       options. To enable these extensions add +crypto to the value of
       -mcpu or -march e.g. -mcpu=cortex-a53+crypto.
     * Support has been added for the following processors (GCC
       identifiers in parentheses): ARM Cortex-A72 (cortex-a72) and
       initial support for its big.LITTLE combination with the ARM
       Cortex-A53 (cortex-a72.cortex-a53), Cavium ThunderX (thunderx),
       Applied Micro X-Gene 1 (xgene1), and Samsung Exynos M1 (exynos-m1).
       The GCC identifiers can be used as arguments to the -mcpu or -mtune
       options, for example: -mcpu=xgene1 or -mtune=cortex-a72.cortex-a53.
       Using -mcpu=cortex-a72 requires a version of GNU binutils that has
       support for the Cortex-A72.
     * The transitional options -mlra and -mno-lra have been removed. The
       AArch64 backend now uses the local register allocator (LRA) only.

  ARM

     * Thumb-1 assembly code is now generated in unified syntax. The new
       option -masm-syntax-unified specifies whether inline assembly code
       is using unified syntax. By default the option is off which means
       non-unified syntax is used. However this is subject to change in
       future releases. Eventually the non-unified syntax will be
       deprecated.
     * It is now a configure-time error to use the --with-cpu configure
       option with either of --with-tune or --with-arch.
     * Code generation for the ARM Cortex-A57 processor has been improved.
       A more accurate instruction scheduling model for the processor is
       now used, and a number of compiler tuning parameters have been set
       to offer increased performance when compiling with -mcpu=cortex-a57
       or -mtune=cortex-a57.
     * Support has been added for the following processors (GCC
       identifiers in parentheses): ARM Cortex-A17 (cortex-a17) and
       initial support for its big.LITTLE combination with the ARM
       Cortex-A7 (cortex-a17.cortex-a7), ARM Cortex-A72 (cortex-a72) and
       initial support for its big.LITTLE combination with the ARM
       Cortex-A53 (cortex-a72.cortex-a53), ARM Cortex-M7 (cortex-m7),
       Applied Micro X-Gene 1 (xgene1), and Samsung Exynos M1 (exynos-m1).
       The GCC identifiers can be used as arguments to the -mcpu or -mtune
       options, for example: -mcpu=xgene1 or -mtune=cortex-a72.cortex-a53.
       Using -mcpu=cortex-a72 requires a version of GNU binutils that has
       support for the Cortex-A72.
     * The deprecated option -mwords-little-endian has been removed.
     * The options -mapcs, -mapcs-frame, -mtpcs-frame and
       -mtpcs-leaf-frame which are only applicable to the old ABI have
       been deprecated.
     * The transitional options -mlra and -mno-lra have been removed. The
       ARM backend now uses the local register allocator (LRA) only.

  AVR

     * The compiler no more supports individual devices like ATmega8.
       Specifying, say, -mmcu=atmega8 triggers the usage of the
       device-specific [38]spec file specs-atmega8 which is part of the
       installation and describes options for the sub-processes like
       compiler proper, assembler and linker. You can add support for a
       new device -mmcu=mydevice as follows:
         1. In an empty directory /someplace, create a new directory
            device-specs.
         2. Copy a device spec file from the installed device-specs
            folder, follow the comments in that file and then save it as
            /someplace/device-specs/specs-mydevice.
         3. Add -B /someplace -mmcu=mydevice to the compiler's
            command-line options. Notice that /someplace must specify an
            absolute path and that mydevice must not start with "avr".
         4. Provided you have a device-specific library libmydevice.a
            available, you can put it at /someplace, dito for a
            device-specific startup file crtmydevice.o.
       The contents of the device spec files depend on the compiler's
       configuration, in particular on --with-avrlibc=no and whether or
       not it is configured for RTEMS.
     * A new command-line option -nodevicelib has been added. It prevents
       the compiler from linking against AVR-LibC's device-specific
       library libdevice.a.
     * The following three command-line options have been added:

        -mrmw
                Set if the device supports the read-modify-write
                instructions LAC, LAS, LAT and XCH.

        -mn-flash=size
                Specify the flash size of the device in units of 64 KiB,
                rounded up to the next integer as needed. This option
                affects the availability of the [39]AVR address-spaces.

        -mskip-bug
                Set if the device is affected by the respective silicon
                bug.

       In general, you don't need to set these options by hand. The new
       device-specific spec file will set them as needed.

  IA-32/x86-64

     * New [40]ISA extensions support AVX-512{BW,DQ,VL,IFMA,VBMI} of
       Intel's CPU codenamed Skylake Server was added to GCC. That
       includes inline assembly support, new intrinsics, and basic
       autovectorization. These new AVX-512 extensions are available via
       the following GCC switches: AVX-512 Vector Length EVEX feature:
       -mavx512vl, AVX-512 Byte and Word instructions: -mavx512bw, AVX-512
       Dword and Qword instructions: -mavx512dq, AVX-512 FMA-52
       instructions: -mavx512ifma and for AVX-512 Vector Bit Manipulation
       Instructions: -mavx512vbmi.
     * New ISA extensions support Intel MPX was added to GCC. This new
       extension is available via the -mmpx compiler switch. Intel MPX is
       a set of processor features which, with compiler, run-time library
       and OS support, brings increased robustness to software by run-time
       checking pointer references against their bounds. In GCC Intel MPX
       is supported by Pointer Bounds Checker and libmpx run-time
       libraries.
     * The new -mrecord-mcount option for -pg generates a Linux kernel
       style table of pointers to mcount or __fentry__ calls at the
       beginning of functions. The new -mnop-mcount option in addition
       also generates nops in place of the __fentry__ or mcount call, so
       that a call per function can be later patched in. This can be used
       for low overhead tracing or hot code patching.
     * The new -malign-data option controls how GCC aligns variables.
       -malign-data=compat uses increased alignment compatible with GCC
       4.8 and earlier, -malign-data=abi uses alignment as specified by
       the psABI, and -malign-data=cacheline uses increased alignment to
       match the cache line size. -malign-data=compat is the default.
     * The new -mskip-rax-setup option skips setting up the RAX register
       when SSE is disabled and there are no variable arguments passed in
       vector registers. This can be used to optimize the Linux kernel.

  MIPS

     * MIPS Releases 3 and 5 are now directly supported. Use the
       command-line options -mips32r3, -mips64r3, -mips32r5 and -mips64r5
       to enable code-generation for these processors.
     * The Imagination P5600 processor is now supported using the
       -march=p5600 command-line option.
     * The Cavium Octeon3 processor is now supported using the
       -march=octeon3 command-line option.
     * MIPS Release 6 is now supported using the -mips32r6 and -mips64r6
       command-line options.
     * The o32 ABI has been modified and extended. The o32 64-bit
       floating-point register support is now obsolete and has been
       removed. It has been replaced by three ABI extensions FPXX, FP64A,
       and FP64. The meaning of the -mfp64 command-line option has
       changed. It is now used to enable the FP64A and FP64 ABI
       extensions.
          + The FPXX extension requires that code generated to access
            double-precision values use even-numbered registers. Code that
            adheres to this extension is link-compatible with all other
            o32 double-precision ABI variants and will execute correctly
            in all hardware FPU modes. The command-line options -mabi=32
            -mfpxx can be used to enable this extension. MIPS II is the
            minimum processor required.
          + The o32 FP64A extension requires that floating-point registers
            be 64-bit and odd-numbered single-precision registers are not
            allowed. Code that adheres to the o32 FP64A variant is
            link-compatible with all other o32 double-precision ABI
            variants. The command-line options -mabi=32 -mfp64
            -mno-odd-spreg can be used to enable this extension. MIPS32R2
            is the minimum processor required.
          + The o32 FP64 extension also requires that floating-point
            registers be 64-bit, but permits the use of single-precision
            registers. Code that adheres to the o32 FP64 variant is
            link-compatible with o32 FPXX and o32 FP64A variants only,
            i.e. it is not compatible with the original o32
            double-precision ABI. The command-line options -mabi=32 -mfp64
            -modd-spreg can be used to enable this extension. MIPS32R2 is
            the minimum processor required.
       The new ABI variants can be enabled by default using the configure
       time options --with-fp-32=[32|xx|64] and --with(out)-odd-sp-reg-32.
       It is strongly recommended that all vendors begin to set o32 FPXX
       as the default ABI. This will be required to run the generated code
       on MIPSR5 cores in conjunction with future MIPS SIMD (MSA) code and
       MIPSR6 cores.
     * GCC will now pass all floating-point options to the assembler if
       GNU binutils 2.25 is used. As a result, any inline assembly code
       that uses hard-float instructions should be amended to include a
       .set directive to override the global assembler options when
       compiling for soft-float targets.

  NDS32

     * The variadic function ABI implementation is now compatible with
       past Andes toolchains where the caller uses registers to pass
       arguments and the callee is in charge of pushing them on stack.
     * The options -mforce-fp-as-gp, -mforbid-fp-as-gp, and -mex9 have
       been removed since they are not yet available in the nds32 port of
       GNU binutils.
     * A new option -mcmodel=[small|medium|large] supports varied code
       models on code generation. The -mgp-direct option became
       meaningless and can be discarded.

  RX

     * A new command line option -mno-allow-string-insns can be used to
       disable the generation of the SCMPU, SMOVU, SMOVB, SMOVF, SUNTIL,
       SWHILE and RMPA instructions. An erratum released by Renesas shows
       that it is unsafe to use these instructions on addresses within the
       I/O space of the processor. The new option can be used when the
       programmer is concerned that the I/O space might be accessed. The
       default is still to enable these instructions.

  SH

     * The compiler will now pass the appropriate --isa= option to the
       assembler.
     * The default handling for the GBR has been changed from call
       clobbered to call preserved. The old behavior can be reinstated by
       specifying the option -fcall-used-gbr.
     * Support for the SH4A fpchg instruction has been added which will be
       utilized when switching between single and double precision FPU
       modes.
     * The compiler no longer uses the __fpscr_values array for switching
       between single and double FPU precision modes on non-SH4A targets.
       Instead mode switching will now be performed by storing, modifying
       and reloading the FPSCR, so that other FPSCR bits are preserved
       across mode switches. The __fpscr_values array that is defined in
       libgcc is still present for backwards compatibility, but it will
       not be referenced by compiler generated code anymore.
     * New builtin functions __builtin_sh_get_fpscr and
       __builtin_sh_set_fpscr have been added. The __builtin_sh_set_fpscr
       function will mask the specified bits in such a way that the SZ, PR
       and FR mode bits will be preserved, while changing the other bits.
       These new functions do not reference the __fpscr_values array. The
       old functions __set_fpscr and __get_fpscr in libgcc which access
       the __fpscr_values array are still present for backwards
       compatibility, but their usage is highly discouraged.
     * Some improvements to code generated for __atomic built-in
       functions.
     * When compiling for SH2E the compiler will no longer force the usage
       of delay slots for conditional branch instructions bt and bf. The
       old behavior can be reinstated (e.g. to work around a hardware bug
       in the original SH7055) by specifying the new option
       -mcbranch-force-delay-slot.

Operating Systems

  AIX

     * GCC now supports stabs debugging continuation lines to allow long
       stabs debug information without overflow that generates AIX linker
       errors.

  DragonFly BSD

     * GCC now supports the DragonFly BSD operating system.

  FreeBSD

     * GCC now supports the FreeBSD operating system for the arm port
       through the arm*-*-freebsd* target triplets.

  VxWorks MILS

     * GCC now supports the MILS (Multiple Independent Levels of Security)
       variant of WindRiver's VxWorks operating system for PowerPC
       targets.

Other significant improvements

     * The gcc-ar, gcc-nm, gcc-ranlib wrappers now understand a -B option
       to set the compiler to use.

     * When the new command-line option -freport-bug is used, GCC
       automatically generates a developer-friendly reproducer whenever an
       internal compiler error is encountered.

                                    GCC 5.2

   This is the [41]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 5.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

Target Specific Changes

  IA-32/x86-64

     * Support for new AMD instructions monitorx and mwaitx has been
       added. This includes new intrinsic and built-in support. It is
       enabled through option -mmwaitx. The instructions monitorx and
       mwaitx implement the same functionality as the old monitor and
       mwait instructions. In addition mwaitx adds a configurable timer.
       The timer value is received as third argument and stored in
       register %ebx.

  S/390, System z, IBM z Systems

     * Support for the IBM z13 processor has been added. When using the
       -march=z13 option, the compiler will generate code making use of
       the new instructions and registers introduced with the vector
       extension facility. The -mtune=z13 option enables z13 specific
       instruction scheduling without making use of new instructions.
       Compiling code with -march=z13 reduces the default alignment of
       vector types bigger than 8 bytes to 8. This is an ABI change and
       care must be taken when linking modules compiled with different
       arch levels which interchange variables containing vector type
       values. For newly compiled code the GNU linker will emit a warning.
     * The -mzvector option enables a C/C++ language extension. This
       extension provides a new keyword vector which can be used to define
       vector type variables. (Note: This is not available when enforcing
       strict standard compliance e.g. with -std=c99. Either enable GNU
       extensions with e.g. -std=gnu99 or use __vector instead of vector.)
       Additionally a set of overloaded builtins is provided which is
       partially compatible to the PowerPC Altivec builtins. In order to
       make use of these builtins the vecintrin.h header file needs to be
       included.

                                    GCC 5.3

   This is the [42]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 5.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

Target Specific Changes

  IA-32/x86-64

     * GCC now supports the Intel CPU named Skylake with AVX-512
       extensions through -march=skylake-avx512. The switch enables the
       following ISA extensions: AVX-512F, AVX512VL, AVX-512CD, AVX-512BW,
       AVX-512DQ.

  S/390, System z, IBM z Systems

     * With this version of GCC IBM z Systems support has been added to
       the GO runtime environment. GCC 5.3 has proven to be able to
       compile larger GO applications on IBM z Systems.

                                    GCC 5.4

   This is the [43]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 5.4 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

                                    GCC 5.5

   This is the [44]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 5.5 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

Target Specific Changes

  IA-32/x86-64

     * Support for the [45]deprecated pcommit instruction has been
       removed.


    For questions related to the use of GCC, please consult these web
    pages and the [46]GCC manuals. If that fails, the
    [47]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [48]gcc@gcc.gnu.org. All of [49]our lists have public
    archives.

   Copyright (C) [50]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [51]maintained by the GCC team. Last modified
   2017-10-10[52].

References

   1. http://gcc.gnu.org/gcc-5/changes.html#libstdcxx
   2. https://gcc.gnu.org/onlinedocs/gcc/Spec-Files.html
   3. https://savannah.nongnu.org/bugs/?44574
   4. https://gcc.gnu.org/wiki/Intel%20MPX%20support%20in%20the%20GCC%20compiler
   5. http://www.openmp.org/wp-content/uploads/OpenMP4.0.0.pdf
   6. http://www.openmp.org/wp-content/uploads/OpenMP4.0.0.Examples.pdf
   7. https://gcc.gnu.org/wiki/OpenACC
   8. https://gcc.gnu.org/install/configure.html
   9. https://www.cilkplus.org/
  10. https://isocpp.org/std/standing-documents/sd-6-sg10-feature-test-recommendations
  11. http://gcc.gnu.org/projects/cxx1y.html
  12. https://isocpp.org/std/standing-documents/sd-6-sg10-feature-test-recommendations
  13. http://gcc.gnu.org/projects/cxx1y.html
  14. http://gcc.gnu.org/projects/cxx1y.html
  15. http://gcc.gnu.org/projects/cxx1y.html
  16. http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2013/n3639.html
  17. http://gcc.gnu.org/onlinedocs/libstdc++/manual/using_dual_abi.html
  18. https://gcc.gnu.org/onlinedocs/gcc-5.1.0/libstdc++/manual/manual/status.html#status.iso.2011
  19. https://gcc.gnu.org/onlinedocs/gcc-5.1.0/libstdc++/manual/manual/status.html#status.iso.2014
  20. https://gcc.gnu.org/onlinedocs/gcc-5.1.0/libstdc++/manual/manual/status.html#status.iso.2014
  21. https://sourceware.org/gdb/current/onlinedocs/gdb/Xmethods-In-Python.html
  22. https://gcc.gnu.org/onlinedocs/gcc-5.1.0/gfortran/Error-and-Warning-Options.html
  23. https://gcc.gnu.org/onlinedocs/gcc-5.1.0/gcc/Language-Independent-Options.html
  24. https://gcc.gnu.org/install/configure.html
  25. https://gcc.gnu.org/onlinedocs/gcc-5.1.0/gfortran/Thread-safety-of-the-runtime-library.html
  26. https://gcc.gnu.org/wiki/Fortran2003Status
  27. https://gcc.gnu.org/wiki/Fortran2008Status
  28. https://gcc.gnu.org/wiki/Coarray
  29. http://www.opencoarrays.org/
  30. https://golang.org/cmd/go/
  31. https://golang.org/cmd/gofmt/
  32. https://gcc.gnu.org/onlinedocs/gcc-5.1.0/jit/intro/index.html
  33. https://gcc.gnu.org/onlinedocs/gcc-5.1.0/jit/cp/index.html
  34. https://github.com/davidmalcolm/pygccjit
  35. https://github.com/ibuclaw/gccjitd
  36. https://gcc.gnu.org/onlinedocs/gcc-5.1.0/jit/intro/tutorial04.html
  37. https://gcc.gnu.org/onlinedocs/gcc-5.1.0/jit/intro/tutorial05.html
  38. https://gcc.gnu.org/onlinedocs/gcc/Spec-Files.html
  39. https://gcc.gnu.org/onlinedocs/gcc/Named-Address-Spaces.html
  40. https://software.intel.com/sites/default/files/managed/39/c5/325462-sdm-vol-1-2abcd-3abcd.pdf
  41. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=5.2
  42. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=5.3
  43. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=5.4
  44. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=5.5
  45. https://software.intel.com/en-us/blogs/2016/09/12/deprecate-pcommit-instruction
  46. https://gcc.gnu.org/onlinedocs/
  47. mailto:gcc-help@gcc.gnu.org
  48. mailto:gcc@gcc.gnu.org
  49. https://gcc.gnu.org/lists.html
  50. http://www.fsf.org/
  51. https://gcc.gnu.org/about.html
  52. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-4.9/index.html

                             GCC 4.9 Release Series

   Aug 3, 2016

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 4.9.4.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 4.9.3 relative to previous releases of GCC.

   This release series is no longer maintained.

Release History

   GCC 4.9.4
          Aug 3, 2016 ([2]changes, [3]documentation)

   GCC 4.9.3
          June 26, 2015 ([4]changes, [5]documentation)

   GCC 4.9.2
          October 30, 2014 ([6]changes, [7]documentation)

   GCC 4.9.1
          July 16, 2014 ([8]changes, [9]documentation)

   GCC 4.9.0
          April 22, 2014 ([10]changes, [11]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [12]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [13]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [14]GCC
   project web site or contact the [15]GCC development mailing list.

   To obtain GCC please use [16]our mirror sites or [17]our SVN server.


    For questions related to the use of GCC, please consult these web
    pages and the [18]GCC manuals. If that fails, the
    [19]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [20]gcc@gcc.gnu.org. All of [21]our lists have public
    archives.

   Copyright (C) [22]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [23]maintained by the GCC team. Last modified
   2016-09-30[24].

References

   1. http://www.gnu.org/
   2. http://gcc.gnu.org/gcc-4.9/changes.html
   3. http://gcc.gnu.org/onlinedocs/4.9.4/
   4. http://gcc.gnu.org/gcc-4.9/changes.html
   5. http://gcc.gnu.org/onlinedocs/4.9.3/
   6. http://gcc.gnu.org/gcc-4.9/changes.html
   7. http://gcc.gnu.org/onlinedocs/4.9.2/
   8. http://gcc.gnu.org/gcc-4.9/changes.html
   9. http://gcc.gnu.org/onlinedocs/4.9.1/
  10. http://gcc.gnu.org/gcc-4.9/changes.html
  11. https://gcc.gnu.org/onlinedocs/4.9.0/
  12. http://gcc.gnu.org/gcc-4.9/buildstat.html
  13. https://gcc.gnu.org/onlinedocs/gcc/Contributors.html
  14. http://gcc.gnu.org/index.html
  15. mailto:gcc@gcc.gnu.org
  16. http://gcc.gnu.org/mirrors.html
  17. http://gcc.gnu.org/svn.html
  18. https://gcc.gnu.org/onlinedocs/
  19. mailto:gcc-help@gcc.gnu.org
  20. mailto:gcc@gcc.gnu.org
  21. https://gcc.gnu.org/lists.html
  22. http://www.fsf.org/
  23. https://gcc.gnu.org/about.html
  24. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-4.9/changes.html

                             GCC 4.9 Release Series
                        Changes, New Features, and Fixes

Caveats

     * The mudflap run time checker has been removed. The mudflap options
       remain, but do nothing.
     * Support for a number of older systems and recently unmaintained or
       untested target ports of GCC has been declared obsolete in GCC 4.9.
       Unless there is activity to revive them, the next release of GCC
       will have their sources permanently removed.
       The following ports for individual systems on particular
       architectures have been obsoleted:
          + Solaris 9 (*-*-solaris2.9). Details can be found in the
            [1]announcement.
     * On AArch64, the singleton vector types int64x1_t, uint64x1_t and
       float64x1_t exported by arm_neon.h are defined to be the same as
       their base types. This results in incorrect application of
       parameter passing rules to arguments of types int64x1_t and
       uint64x1_t, with respect to the AAPCS64 ABI specification. In
       addition, names of C++ functions with parameters of these types
       (including float64x1_t) are not mangled correctly. The current
       typedef declarations also unintentionally allow implicit casting
       between singleton vector types and their base types. These issues
       will be resolved in a near future release. See [2]PR60825 for more
       information.

   More information on porting to GCC 4.9 from previous versions of GCC
   can be found in the [3]porting guide for this release.

General Optimizer Improvements

     * AddressSanitizer, a fast memory error detector, is now available on
       ARM.
     * UndefinedBehaviorSanitizer (ubsan), a fast undefined behavior
       detector, has been added and can be enabled via
       -fsanitize=undefined. Various computations will be instrumented to
       detect undefined behavior at runtime. UndefinedBehaviorSanitizer is
       currently available for the C and C++ languages.
     * Link-time optimization (LTO) improvements:
          + Type merging was rewritten. The new implementation is
            significantly faster and uses less memory.
          + Better partitioning algorithm resulting in less streaming
            during link time.
          + Early removal of virtual methods reduces the size of object
            files and improves link-time memory usage and compile time.
          + Function bodies are now loaded on-demand and released early
            improving overall memory usage at link time.
          + C++ hidden keyed methods can now be optimized out.
          + When using a linker plugin, compiling with the -flto option
            now generates slim object files (.o) which only contain
            intermediate language representation for LTO. Use
            -ffat-lto-objects to create files which contain additionally
            the object code. To generate static libraries suitable for LTO
            processing, use gcc-ar and gcc-ranlib; to list symbols from a
            slim object file use gcc-nm. (This requires that ar, ranlib
            and nm have been compiled with plugin support.)
       Memory usage building Firefox with debug enabled was reduced from
       15GB to 3.5GB; link time from 1700 seconds to 350 seconds.
     * Inter-procedural optimization improvements:
          + New type inheritance analysis module improving
            devirtualization. Devirtualization now takes into account
            anonymous name-spaces and the C++11 final keyword.
          + New speculative devirtualization pass (controlled by
            -fdevirtualize-speculatively.
          + Calls that were speculatively made direct are turned back to
            indirect where direct call is not cheaper.
          + Local aliases are introduced for symbols that are known to be
            semantically equivalent across shared libraries improving
            dynamic linking times.
     * Feedback directed optimization improvements:
          + Profiling of programs using C++ inline functions is now more
            reliable.
          + New time profiling determines typical order in which functions
            are executed.
          + A new function reordering pass (controlled by
            -freorder-functions) significantly reduces startup time of
            large applications. Until binutils support is completed, it is
            effective only with link-time optimization.
          + Feedback driven indirect call removal and devirtualization now
            handle cross-module calls when link-time optimization is
            enabled.

New Languages and Language specific improvements

     * Version 4.0 of the [4]OpenMP specification is now supported in the
       C and C++ compilers and starting with the 4.9.1 release also in the
       Fortran compiler. The new -fopenmp-simd option can be used to
       enable OpenMP's SIMD directives while ignoring other OpenMP
       directives. The new [5]-fsimd-cost-model= option permits to tune
       the vectorization cost model for loops annotated with OpenMP and
       Cilk Plus simd directives. -Wopenmp-simd warns when the current
       cost model overrides simd directives set by the user.
     * The -Wdate-time option has been added for the C, C++ and Fortran
       compilers, which warns when the __DATE__, __TIME__ or __TIMESTAMP__
       macros are used. Those macros might prevent bit-wise-identical
       reproducible compilations.

  Ada

     * GNAT switched to Ada 2012 instead of Ada 2005 by default.

  C family

     * Support for colorizing diagnostics emitted by GCC has been added.
       The [6]-fdiagnostics-color=auto will enable it when outputting to
       terminals, -fdiagnostics-color=always unconditionally. The
       GCC_COLORS environment variable can be used to customize the colors
       or disable coloring. If GCC_COLORS variable is present in the
       environment, the default is -fdiagnostics-color=auto, otherwise
       -fdiagnostics-color=never.
       Sample diagnostics output:
    $ g++ -fdiagnostics-color=always -S -Wall test.C
    test.C: In function `int foo()':
    test.C:1:14: warning: no return statement in function returning non-void [-W
return-type]
     int foo () { }
                  ^
    test.C:2:46: error: template instantiation depth exceeds maximum of 900 (use
 -ftemplate-depth= to increase the maximum) instantiating `struct X<100>'
     template <int N> struct X { static const int value = X<N-1>::value; }; temp
late struct X<1000>;
                                                  ^
    test.C:2:46:   recursively required from `const int X<999>::value'
    test.C:2:46:   required from `const int X<1000>::value'
    test.C:2:88:   required from here

    test.C:2:46: error: incomplete type `X<100>' used in nested name specifier

     * With the new [7]#pragma GCC ivdep, the user can assert that there
       are no loop-carried dependencies which would prevent concurrent
       execution of consecutive iterations using SIMD (single instruction
       multiple data) instructions.
     * Support for [8]Cilk Plus has been added and can be enabled with the
       -fcilkplus option. Cilk Plus is an extension to the C and C++
       languages to support data and task parallelism. The present
       implementation follows ABI version 1.2; all features but _Cilk_for
       have been implemented.

  C

     * ISO C11 atomics (the _Atomic type specifier and qualifier and the
       <stdatomic.h> header) are now supported.
     * ISO C11 generic selections (_Generic keyword) are now supported.
     * ISO C11 thread-local storage (_Thread_local, similar to GNU C
       __thread) is now supported.
     * ISO C11 support is now at a similar level of completeness to ISO
       C99 support: substantially complete modulo bugs, extended
       identifiers (supported except for corner cases when
       -fextended-identifiers is used), floating-point issues (mainly but
       not entirely relating to optional C99 features from Annexes F and
       G) and the optional Annexes K (Bounds-checking interfaces) and L
       (Analyzability).
     * A new C extension __auto_type provides a subset of the
       functionality of C++11 auto in GNU C.

  C++

     * The G++ implementation of [9]C++1y return type deduction for normal
       functions has been updated to conform to [10]N3638, the proposal
       accepted into the working paper. Most notably, it adds
       decltype(auto) for getting decltype semantics rather than the
       template argument deduction semantics of plain auto:

int& f();
         auto  i1 = f(); // int
decltype(auto) i2 = f(); // int&

     * G++ supports [11]C++1y lambda capture initializers:

[x = 42]{ ... };

       Actually, they have been accepted since GCC 4.5, but now the
       compiler doesn't warn about them with -std=c++1y, and supports
       parenthesized and brace-enclosed initializers as well.
     * G++ supports [12]C++1y variable length arrays. G++ has supported
       GNU/C99-style VLAs for a long time, but now additionally supports
       initializers and lambda capture by reference. In C++1y mode G++
       will complain about VLA uses that are not permitted by the draft
       standard, such as forming a pointer to VLA type or applying sizeof
       to a VLA variable. Note that it now appears that VLAs will not be
       part of C++14, but will be part of a separate document and then
       perhaps C++17.

void f(int n) {
  int a[n] = { 1, 2, 3 }; // throws std::bad_array_length if n < 3
  [&a]{ for (int i : a) { cout << i << endl; } }();
  &a; // error, taking address of VLA
}

     * G++ supports the [13]C++1y [[deprecated]] attribute modulo bugs in
       the underlying [[gnu::deprecated]] attribute. Classes and functions
       can be marked deprecated and a diagnostic message added:

class A;
int bar(int n);
#if __cplusplus > 201103
class [[deprecated("A is deprecated in C++14; Use B instead")]] A;
[[deprecated("bar is unsafe; use foo() instead")]]
int bar(int n);

int foo(int n);
class B;
#endif
A aa; // warning: 'A' is deprecated : A is deprecated in C++14; Use B instead
int j = bar(2); // warning: 'int bar(int)' is deprecated : bar is unsafe; use fo
o() instead

     * G++ supports [14]C++1y digit separators. Long numeric literals can
       be subdivided with a single quote ' to enhance readability:

int i = 1048576;
int j = 1'048'576;
int k = 0x10'0000;
int m = 0'004'000'000;
int n = 0b0001'0000'0000'0000'0000'0000;

double x = 1.602'176'565e-19;
double y = 1.602'176'565e-1'9;

     * G++ supports [15]C++1y generic (polymorphic) lambdas.

// a functional object that will increment any type
auto incr = [](auto x) { return x++; };

     * As a GNU extension, G++ supports explicit template parameter syntax
       for generic lambdas. This can be combined in the expected way with
       the standard auto syntax.

// a functional object that will add two like-type objects
auto add = [] <typename T> (T a, T b) { return a + b; };

     * G++ supports unconstrained generic functions as specified by
       S:4.1.2 and S:5.1.1 of [16]N3889: Concepts Lite Specification.
       Briefly, auto may be used as a type-specifier in a parameter
       declaration of any function declarator in order to introduce an
       implicit function template parameter, akin to generic lambdas.

// the following two function declarations are equivalent
auto incr(auto x) { return x++; }
template <typename T>
auto incr(T x) { return x++; }

    Runtime Library (libstdc++)

     * [17]Improved support for C++11, including:
          + support for <regex>;
          + The associative containers in <map> and <set> and the
            unordered associative containers in <unordered_map> and
            <unordered_set> meet the allocator-aware container
            requirements;
     * [18]Improved experimental support for the upcoming ISO C++
       standard, C++14, including:
          + fixing constexpr member functions without const;
          + implementation of the std::exchange() utility function;
          + addressing tuples by type;
          + implemention of std::make_unique;
          + implemention of std::shared_lock;
          + making std::result_of SFINAE-friendly;
          + adding operator() to std::integral_constant;
          + adding user-defined literals for standard library types
            std::basic_string, std::chrono::duration, and std::complex;
          + adding two range overloads to non-modifying sequence oprations
            std::equal and std::mismatch;
          + adding IO manipulators for quoted strings;
          + adding constexpr members to <utility>, <complex>, <chrono>,
            and some containers;
          + adding compile-time std::integer_sequence;
          + adding cleaner transformation traits;
          + making <functional>s operator functors easier to use and more
            generic;
     * An implementation of std::experimental::optional.
     * An implementation of std::experimental::string_view.
     * The non-standard function std::copy_exception has been deprecated
       and will be removed in a future version. std::make_exception_ptr
       should be used instead.

  Fortran

     * Compatibility notice:
          + Module files: The version of the module files (.mod) has been
            incremented; additionally, module files are now compressed.
            Fortran MODULEs compiled by earlier GCC versions have to be
            recompiled, when they are USEd by files compiled with GCC 4.9.
            GCC 4.9 is not able to read .mod files of earlier GCC
            versions; attempting to do so gives an error message. Note:
            The ABI of the produced assembler data itself has not changed:
            object files and libraries are fully compatible with older
            versions (except as stated below).
          + ABI changes:
               o The [19]argument passing ABI has changed for scalar dummy
                 arguments of type INTEGER, REAL, COMPLEX and LOGICAL,
                 which have both the VALUE and the OPTIONAL attributes.
               o To support finalization the virtual table associated with
                 polymorphic variables has changed. Code containing CLASS
                 should be recompiled, including all files which define
                 derived types involved in the type definition used by
                 polymorphic variables. (Note: Due to the incremented
                 module version, trying to mix old code with new code will
                 usually give an error message.)
          + GNU Fortran no longer deallocates allocatable variables or
            allocatable components of variables declared in the main
            program. Since Fortran 2008, the standard explicitly states
            that variables declared in the Fortran main program
            automatically have the SAVE attribute.
          + When opening files, the close-on-exec flag is set if the
            system supports such a feature. This is generally considered
            good practice these days, but if there is a need to pass file
            descriptors to child processes the parent process must now
            remember to clear the close-on-exec flag by calling fcntl(),
            e.g. via ISO_C_BINDING, before executing the child process.
     * The deprecated command-line option -fno-whole-file has been
       removed. (-fwhole-file is the default since GCC 4.6.)
       -fwhole-file/-fno-whole-file continue to be accepted but do not
       influence the code generation.
     * The compiler no longer unconditionally warns about DO loops with
       zero iterations. This warning is now controlled by the -Wzerotrip
       option, which is implied by -Wall.
     * The new NO_ARG_CHECK attribute of the [20]!GCC$ directive can be
       used to disable the type-kind-rank (TKR) argument check for a dummy
       argument. The feature is similar to ISO/IEC TS 29133:2012's
       TYPE(*), except that it additionally also disables the rank check.
       Variables with NO_ARG_CHECK have to be dummy arguments and may only
       be used as argument to ISO_C_BINDING's C_LOC and as actual argument
       to another NO_ARG_CHECK dummy argument; also the other constraints
       of TYPE(*) apply. The dummy arguments should be declared as scalar
       or assumed-size variable of type type(*) (recommended) - or of type
       integer, real, complex or logical. With NO_ARG_CHECK, a pointer to
       the data without further type or shape information is passed,
       similar to C's void*. Note that also TS 29113's
       type(*),dimension(..) accepts arguments of any type and rank;
       contrary to NO_ARG_CHECK assumed-rank arguments pass an array
       descriptor which contains the array shape and stride of the
       argument.
     * [21]Fortran 2003:
          + Finalization is now supported. It is currently only done for a
            subset of those situations in which it should occur.
          + Experimental support for scalar character components with
            deferred length (i.e. allocatable string length) in derived
            types has been added. (Deferred-length character variables are
            supported since GCC 4.6.)
     * [22]Fortran 2008:
          + When STOP or ERROR STOP are used to terminate the execution
            and any exception (but inexact) is signaling, a warning is
            printed to ERROR_UNIT, indicating which exceptions are
            signaling. The [23]-ffpe-summary= command-line option can be
            used to fine-tune for which exceptions the warning should be
            shown.
          + Rounding on input (READ) is now handled on systems where
            strtod honours the rounding mode. (For output, rounding is
            supported since GCC 4.5.) Note that for input, the compatible
            rounding mode is handled as nearest (i.e., rounding to an even
            least significant [cf. IEC 60559:1989] for a tie, while
            compatible rounds away from zero in that case).

  Go

     * GCC 4.9 provides a complete implementation of the Go 1.2.1 release.

New Targets and Target Specific Improvements

  AArch64

     * The ARMv8-A crypto and CRC instructions are now supported through
       intrinsics. These are enabled when the architecture supports these
       and are available through the -march=armv8-a+crc and
       -march=armv8-a+crypto options.
     * Initial support for ILP32 has now been added to the compiler. This
       is now available through the command-line option -mabi=ilp32.
       Support for ILP32 is considered experimental as the ABI
       specification is still beta.
     * Coverage of more of the ISA including the SIMD extensions has been
       added. The Advanced SIMD intrinsics have also been improved.
     * The new local register allocator (LRA) is now on by default for the
       AArch64 backend.
     * The REE (Redundant extension elimination) pass has now been enabled
       by default for the AArch64 backend.
     * Tuning for the Cortex-A53 and Cortex-A57 has been improved.
     * Initial big.LITTLE tuning support for the combination of Cortex-A57
       and Cortex-A53 was added through the -mcpu=cortex-a57.cortex-a53
       option.
     * A number of structural changes have been made to both the ARM and
       AArch64 backends to facilitate improved code-generation.
     * As of GCC 4.9.2 a workaround for the ARM Cortex-A53 erratum 835769
       has been added and can be enabled by giving the
       -mfix-cortex-a53-835769 option. Alternatively it can be enabled by
       default by configuring GCC with the --enable-fix-cortex-a53-835769
       option.

  ARC

     * A port for Synopsys Designware ARC has been contributed by Embecosm
       and Synopsys Inc.

  ARM

     * Use of Advanced SIMD (Neon) for 64-bit scalar computations has been
       disabled by default. This was found to generate better code in only
       a small number of cases. It can be turned back on with the
       -mneon-for-64bits option.
     * Further support for the ARMv8-A architecture, notably implementing
       the restriction around IT blocks in the Thumb32 instruction set has
       been added. The -mrestrict-it option can be used with
       -march=armv7-a or the -march=armv7ve options to make code
       generation fully compatible with the deprecated instructions in
       ARMv8-A.
     * Support has now been added for the ARMv7ve variant of the
       architecture. This can be used by the -march=armv7ve option.
     * The ARMv8-A crypto and CRC instructions are now supported through
       intrinsics and are available through the -march=armv8-a+crc and
       mfpu=crypto-neon-fp-armv8 options.
     * LRA is now on by default for the ARM target. This can be turned off
       using the -mno-lra option. This option is a purely transitionary
       command-line option and will be removed in a future release. We are
       interested in any bug reports regarding functional and performance
       regressions with LRA.
     * A new option -mslow-flash-data to improve performance of programs
       fetching data on slow flash memory has now been introduced for the
       ARMv7-M profile cores.
     * A new option -mpic-data-is-text-relative for targets that allows
       data segments to be relative to text segments has been added. This
       is on by default for all targets except VxWorks RTP.
     * A number of infrastructural changes have been made to both the ARM
       and AArch64 backends to facilitate improved code-generation.
     * GCC now supports Cortex-A12 and the Cortex-R7 through the
       -mcpu=cortex-a12 and -mcpu=cortex-r7 options.
     * GCC now has tuning for the Cortex-A57 and Cortex-A53 through the
       -mcpu=cortex-a57 and -mcpu=cortex-a53 options.
     * Initial big.LITTLE tuning support for the combination of Cortex-A57
       and Cortex-A53 was added through the -mcpu=cortex-a57.cortex-a53
       option. Similar support was added for the combination of Cortex-A15
       and Cortex-A7 through the -mcpu=cortex-a15.cortex-a7 option.
     * Further performance optimizations for the Cortex-A15 and the
       Cortex-M4 have been added.
     * A number of code generation improvements for Thumb2 to reduce code
       size when compiling for the M-profile processors.

  AVR

     * A new command-line option -mfract-convert-truncate has been added.
       It allows compiler to use truncation instead of rounding towards
       zero for fractional fixed-point types.

  IA-32/x86-64

     * -mfpmath=sse is now implied by -ffast-math on all targets where
       SSE2 is supported.
     * Intel AVX-512 support was added to GCC. That includes inline
       assembly support, new registers and extending existing ones, new
       intrinsics (covered by corresponding testsuite), and basic
       autovectorization. AVX-512 instructions are available via the
       following GCC switches: AVX-512 foundation instructions: -mavx512f,
       AVX-512 prefetch instructions: -mavx512pf, AVX-512 exponential and
       reciprocal instructions: -mavx512er, AVX-512 conflict detection
       instructions: -mavx512cd.
     * It is now possible to call x86 intrinsics from select functions in
       a file that are tagged with the corresponding target attribute
       without having to compile the entire file with the -mxxx option.
       This improves the usability of x86 intrinsics and is particularly
       useful when doing [24]Function Multiversioning.
     * GCC now supports the new Intel microarchitecture named Silvermont
       through -march=silvermont.
     * GCC now supports the new Intel microarchitecture named Broadwell
       through -march=broadwell.
     * Optimizing for other Intel microarchitectures have been renamed to
       -march=nehalem, westmere, sandybridge, ivybridge, haswell, bonnell.
     * -march=generic has been retuned for better support of Intel core
       and AMD Bulldozer architectures. Performance of AMD K7, K8, Intel
       Pentium-M, and Pentium4 based CPUs is no longer considered
       important for generic.
     * -mtune=intel can now be used to generate code running well on the
       most current Intel processors, which are Haswell and Silvermont for
       GCC 4.9.
     * Support to encode 32-bit assembly instructions in 16-bit format is
       now available through the -m16 command-line option.
     * Better inlining of memcpy and memset that is aware of value ranges
       and produces shorter alignment prologues.
     * -mno-accumulate-outgoing-args is now honored when unwind
       information is output. Argument accumulation is also now turned off
       for portions of programs optimized for size.
     * Support for new AMD family 15h processors (Excavator core) is now
       available through the -march=bdver4 and -mtune=bdver4 options.

  MSP430

     * A new command-line option -mcpu= has been added to the MSP430
       backend. This option is used to specify the ISA to be used.
       Accepted values are msp430 (the default), msp430x and msp430xv2.
       The ISA is no longer deduced from the -mmcu= option as there are
       far too many different MCU names. The -mmcu= option is still
       supported, and this is still used to select linker scripts and
       generate a C preprocessor symbol that will be recognised by the
       msp430.h header file.

  NDS32

     * A new nds32 port supports the 32-bit architecture from Andes
       Technology Corporation.
     * The port provides initial support for the V2, V3, V3m instruction
       set architectures.

  Nios II

     * A port for the Altera Nios II has been contributed by Mentor
       Graphics.

  PowerPC / PowerPC64 / RS6000

     * GCC now supports Power ISA 2.07, which includes support for
       Hardware Transactional Memory (HTM), Quadword atomics and several
       VMX and VSX additions, including Crypto, 64-bit integer, 128-bit
       integer and decimal integer operations.
     * Support for the POWER8 processor is now available through the
       -mcpu=power8 and -mtune=power8 options.
     * The libitm library has been modified to add a HTM fastpath that
       automatically uses POWER's HTM hardware instructions when it is
       executing on a HTM enabled processor.
     * Support for the new powerpc64le-linux platform has been added. It
       defaults to generating code that conforms to the ELFV2 ABI.

  S/390, System z

     * Support for the Transactional Execution Facility included with the
       IBM zEnterprise zEC12 processor has been added. A set of GCC style
       builtins as well as XLC style builtins are provided. The builtins
       are enabled by default when using the -march=zEC12 option but can
       explicitly be disabled with -mno-htm. Using the GCC builtins also
       libitm supports hardware transactions on S/390.
     * The hotpatch features allows to prepare functions for hotpatching.
       A certain amount of bytes is reserved before the function entry
       label plus a NOP is inserted at its very beginning to implement a
       backward jump when applying a patch. The feature can either be
       enabled per compilation unit via the command-line option -mhotpatch
       or per function using the hotpatch attribute.
     * The shrink wrap optimization is now supported on S/390 and enabled
       by default.
     * A major rework of the routines to determine which registers need to
       be saved and restored in function prologue/epilogue now allow to
       use floating point registers as save slots. This will happen for
       certain leaf function with -march=z10 or higher.
     * The LRA rtl pass replaces reload by default on S/390.

  RX

     * The port now allows to specify the RX100, RX200, and RX600
       processors with the command-line options -mcpu=rx100, -mcpu=rx200
       and -mcpu=rx600.

  SH

     * Minor improvements to code generated for integer arithmetic and
       code that involves the T bit.
     * Added support for the SH2A clips and clipu instructions. The
       compiler will now try to utilize them for min/max expressions such
       as max (-128, min (127, x)).
     * Added support for the cmp/str instruction through built-in
       functions such as __builtin_strlen. When not optimizing for size,
       the compiler will now expand calls to e.g. strlen as an inlined
       sequences which utilize the cmp/str instruction.
     * Improved code generated around volatile memory loads and stores.
     * The option -mcbranchdi has been deprecated. Specifying it will
       result in a warning and will not influence code generation.
     * The option -mcmpeqdi has been deprecated. Specifying it will result
       in a warning and will not influence code generation.

GCC 4.9.1

   This is the [25]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.9.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

   Version 4.0 of the OpenMP specification is supported even in Fortran,
   not just C and C++.

GCC 4.9.2

   This is the [26]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.9.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 4.9.3

   This is the [27]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.9.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 4.9.4

   This is the [28]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.9.4 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).


    For questions related to the use of GCC, please consult these web
    pages and the [29]GCC manuals. If that fails, the
    [30]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [31]gcc@gcc.gnu.org. All of [32]our lists have public
    archives.

   Copyright (C) [33]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [34]maintained by the GCC team. Last modified
   2016-12-28[35].

References

   1. https://gcc.gnu.org/ml/gcc-patches/2013-05/msg00728.html
   2. https://gcc.gnu.org/PR60825
   3. https://gcc.gnu.org/gcc-4.9/porting_to.html
   4. http://www.openmp.org/specifications/
   5. https://gcc.gnu.org/onlinedocs/gcc-4.9.2/gcc/Optimize-Options.html#index-fsimd-cost-model-908
   6. https://gcc.gnu.org/onlinedocs/gcc-4.9.2/gcc/Language-Independent-Options.html#index-fdiagnostics-color-252
   7. https://gcc.gnu.org/onlinedocs/gcc-4.9.2/gcc/Loop-Specific-Pragmas.html
   8. https://www.cilkplus.org/
   9. http://gcc.gnu.org/projects/cxx1y.html
  10. http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2013/n3638.html
  11. http://gcc.gnu.org/projects/cxx1y.html
  12. http://gcc.gnu.org/projects/cxx1y.html
  13. http://gcc.gnu.org/projects/cxx1y.html
  14. http://gcc.gnu.org/projects/cxx1y.html
  15. http://gcc.gnu.org/projects/cxx1y.html
  16. http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2014/n3889.pdf
  17. https://gcc.gnu.org/onlinedocs/gcc-4.9.2/libstdc++/manual/manual/status.html#status.iso.2011
  18. https://gcc.gnu.org/onlinedocs/libstdc++/manual/status.html#status.iso.2014
  19. https://gcc.gnu.org/onlinedocs/gcc-4.9.2/gfortran/Argument-passing-conventions.html
  20. https://gcc.gnu.org/onlinedocs/gcc-4.9.2/gfortran/GNU-Fortran-Compiler-Directives.html
  21. https://gcc.gnu.org/wiki/Fortran2003Status
  22. https://gcc.gnu.org/wiki/Fortran2008Status
  23. https://gcc.gnu.org/onlinedocs/gcc-4.9.2/gfortran/Debugging-Options.html
  24. https://gcc.gnu.org/onlinedocs/gcc-4.9.2/gcc/Function-Multiversioning.html
  25. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.9.1
  26. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.9.2
  27. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.9.3
  28. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.9.4
  29. https://gcc.gnu.org/onlinedocs/
  30. mailto:gcc-help@gcc.gnu.org
  31. mailto:gcc@gcc.gnu.org
  32. https://gcc.gnu.org/lists.html
  33. http://www.fsf.org/
  34. https://gcc.gnu.org/about.html
  35. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-4.8/index.html

                             GCC 4.8 Release Series

   June 23, 2015

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 4.8.5.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 4.8.4 relative to previous releases of GCC.

   This release series is no longer maintained.

Release History

   GCC 4.8.5
          June 23, 2015 ([2]changes, [3]documentation)

   GCC 4.8.4
          December 19, 2014 ([4]changes, [5]documentation)

   GCC 4.8.3
          May 22, 2014 ([6]changes, [7]documentation)

   GCC 4.8.2
          October 16, 2013 ([8]changes, [9]documentation)

   GCC 4.8.1
          May 31, 2013 ([10]changes, [11]documentation)

   GCC 4.8.0
          March 22, 2013 ([12]changes, [13]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [14]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [15]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [16]GCC
   project web site or contact the [17]GCC development mailing list.

   To obtain GCC please use [18]our mirror sites or [19]our SVN server.


    For questions related to the use of GCC, please consult these web
    pages and the [20]GCC manuals. If that fails, the
    [21]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [22]gcc@gcc.gnu.org. All of [23]our lists have public
    archives.

   Copyright (C) [24]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [25]maintained by the GCC team. Last modified
   2016-09-30[26].

References

   1. http://www.gnu.org/
   2. http://gcc.gnu.org/gcc-4.8/changes.html
   3. https://gcc.gnu.org/onlinedocs/4.8.5/
   4. http://gcc.gnu.org/gcc-4.8/changes.html
   5. https://gcc.gnu.org/onlinedocs/4.8.4/
   6. http://gcc.gnu.org/gcc-4.8/changes.html
   7. https://gcc.gnu.org/onlinedocs/4.8.3/
   8. http://gcc.gnu.org/gcc-4.8/changes.html
   9. https://gcc.gnu.org/onlinedocs/4.8.2/
  10. http://gcc.gnu.org/gcc-4.8/changes.html
  11. https://gcc.gnu.org/onlinedocs/4.8.1/
  12. http://gcc.gnu.org/gcc-4.8/changes.html
  13. https://gcc.gnu.org/onlinedocs/4.8.0/
  14. http://gcc.gnu.org/gcc-4.8/buildstat.html
  15. https://gcc.gnu.org/onlinedocs/gcc/Contributors.html
  16. http://gcc.gnu.org/index.html
  17. mailto:gcc@gcc.gnu.org
  18. http://gcc.gnu.org/mirrors.html
  19. http://gcc.gnu.org/svn.html
  20. https://gcc.gnu.org/onlinedocs/
  21. mailto:gcc-help@gcc.gnu.org
  22. mailto:gcc@gcc.gnu.org
  23. https://gcc.gnu.org/lists.html
  24. http://www.fsf.org/
  25. https://gcc.gnu.org/about.html
  26. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-4.8/changes.html

                             GCC 4.8 Release Series
                        Changes, New Features, and Fixes

Caveats

   GCC now uses C++ as its implementation language. This means that to
   build GCC from sources, you will need a C++ compiler that understands
   C++ 2003. For more details on the rationale and specific changes,
   please refer to the [1]C++ conversion page.

   To enable the Graphite framework for loop optimizations you now need
   CLooG version 0.18.0 and ISL version 0.11.1. Both can be obtained from
   the [2]GCC infrastructure directory. The installation manual contains
   more information about requirements to build GCC.

   GCC now uses a more aggressive analysis to derive an upper bound for
   the number of iterations of loops using constraints imposed by language
   standards. This may cause non-conforming programs to no longer work as
   expected, such as SPEC CPU 2006 464.h264ref and 416.gamess. A new
   option, -fno-aggressive-loop-optimizations, was added to disable this
   aggressive analysis. In some loops that have known constant number of
   iterations, but undefined behavior is known to occur in the loop before
   reaching or during the last iteration, GCC will warn about the
   undefined behavior in the loop instead of deriving lower upper bound of
   the number of iterations for the loop. The warning can be disabled with
   -Wno-aggressive-loop-optimizations.

   On ARM, a bug has been fixed in GCC's implementation of the AAPCS rules
   for the layout of vectors that could lead to wrong code being
   generated. Vectors larger than 8 bytes in size are now by default
   aligned to an 8-byte boundary. This is an ABI change: code that makes
   explicit use of vector types may be incompatible with binary objects
   built with older versions of GCC. Auto-vectorized code is not affected
   by this change.

   On AVR, support has been removed for the command-line option
   -mshort-calls deprecated in GCC 4.7.

   On AVR, the configure option --with-avrlibc supported since GCC 4.7.2
   is turned on per default for all non-RTEMS configurations. This option
   arranges for a better integration of [3]AVR Libc with avr-gcc. For
   technical details, see [4]PR54461. To turn off the option in non-RTEMS
   configurations, use --with-avrlibc=no. If the compiler is configured
   for RTEMS, the option is always turned off.

   More information on porting to GCC 4.8 from previous versions of GCC
   can be found in the [5]porting guide for this release.

General Optimizer Improvements (and Changes)

     * DWARF4 is now the default when generating DWARF debug information.
       When -g is used on a platform that uses DWARF debugging
       information, GCC will now default to -gdwarf-4
       -fno-debug-types-section.
       GDB 7.5, Valgrind 3.8.0 and elfutils 0.154 debug information
       consumers support DWARF4 by default. Before GCC 4.8 the default
       version used was DWARF2. To make GCC 4.8 generate an older DWARF
       version use -g together with -gdwarf-2 or -gdwarf-3. The default
       for Darwin and VxWorks is still -gdwarf-2 -gstrict-dwarf.
     * A new general optimization level, -Og, has been introduced. It
       addresses the need for fast compilation and a superior debugging
       experience while providing a reasonable level of run-time
       performance. Overall experience for development should be better
       than the default optimization level -O0.
     * A new option -ftree-partial-pre was added to control the partial
       redundancy elimination (PRE) optimization. This option is enabled
       by default at the -O3 optimization level, and it makes PRE more
       aggressive.
     * The option -fconserve-space has been removed; it was no longer
       useful on most targets since GCC supports putting variables into
       BSS without making them common.
     * The struct reorg and matrix reorg optimizations (command-line
       options -fipa-struct-reorg and -fipa-matrix-reorg) have been
       removed. They did not always work correctly, nor did they work with
       link-time optimization (LTO), hence were only applicable to
       programs consisting of a single translation unit.
     * Several scalability bottle-necks have been removed from GCC's
       optimization passes. Compilation of extremely large functions, e.g.
       due to the use of the flatten attribute in the "Eigen" C++ linear
       algebra templates library, is significantly faster than previous
       releases of GCC.
     * Link-time optimization (LTO) improvements:
          + LTO partitioning has been rewritten for better reliability and
            maintanibility. Several important bugs leading to link
            failures have been fixed.
     * Interprocedural optimization improvements:
          + A new symbol table has been implemented. It builds on existing
            callgraph and varpool modules and provide a new API. Unusual
            symbol visibilities and aliases are handled more consistently
            leading to, for example, more aggressive unreachable code
            removal with LTO.
          + The inline heuristic can now bypass limits on the size of of
            inlined functions when the inlining is particularly
            profitable. This happens, for example, when loop bounds or
            array strides get propagated.
          + Values passed through aggregates (either by value or
            reference) are now propagated at the inter-procedural level
            leading to better inlining decisions (for example in the case
            of Fortran array descriptors) and devirtualization.
     * [6]AddressSanitizer , a fast memory error detector, has been added
       and can be enabled via -fsanitize=address. Memory access
       instructions will be instrumented to detect heap-, stack-, and
       global-buffer overflow as well as use-after-free bugs. To get nicer
       stacktraces, use -fno-omit-frame-pointer. The AddressSanitizer is
       available on IA-32/x86-64/x32/PowerPC/PowerPC64 GNU/Linux and on
       x86-64 Darwin.
     * [7]ThreadSanitizer has been added and can be enabled via
       -fsanitize=thread. Instructions will be instrumented to detect data
       races. The ThreadSanitizer is available on x86-64 GNU/Linux.
     * A new local register allocator (LRA) has been implemented, which
       replaces the 26 year old reload pass and improves generated code
       quality. For now it is active on the IA-32 and x86-64 targets.
     * Support for transactional memory has been implemented on the
       following architectures: IA-32/x86-64, ARM, PowerPC, SH, SPARC, and
       Alpha.

New Languages and Language specific improvements

  C family

     * Each diagnostic emitted now includes the original source line and a
       caret '^' indicating the column. The option
       -fno-diagnostics-show-caret suppresses this information.
     * The option -ftrack-macro-expansion=2 is now enabled by default.
       This allows the compiler to display the macro expansion stack in
       diagnostics. Combined with the caret information, an example
       diagnostic showing these two features is:

t.c:1:94: error: invalid operands to binary < (have `struct mystruct' and `float
')
 #define MYMAX(A,B)    __extension__ ({ __typeof__(A) __a = (A); __typeof__(B) _
_b = (B); __a < __b ? __b : __a; })

              ^
t.c:7:7: note: in expansion of macro 'MYMAX'
   X = MYMAX(P, F);
       ^

     * A new -Wsizeof-pointer-memaccess warning has been added (also
       enabled by -Wall) to warn about suspicious length parameters to
       certain string and memory built-in functions if the argument uses
       sizeof. This warning warns e.g. about memset (ptr, 0, sizeof
       (ptr)); if ptr is not an array, but a pointer, and suggests a
       possible fix, or about memcpy (&foo, ptr, sizeof (&foo));.
     * The new option -Wpedantic is an alias for -pedantic, which is now
       deprecated. The forms -Wno-pedantic, -Werror=pedantic, and
       -Wno-error=pedantic work in the same way as for any other -W
       option. One caveat is that -Werror=pedantic is not equivalent to
       -pedantic-errors, since the latter makes into errors some warnings
       that are not controlled by -Wpedantic, and the former only affects
       diagnostics that are disabled when using -Wno-pedantic.
     * The option -Wshadow no longer warns if a declaration shadows a
       function declaration, unless the former declares a function or
       pointer to function, because this is [8]a common and valid case in
       real-world code.

  C++

     * G++ now implements the [9]C++11 thread_local keyword; this differs
       from the GNU __thread keyword primarily in that it allows dynamic
       initialization and destruction semantics. Unfortunately, this
       support requires a run-time penalty for references to
       non-function-local thread_local variables defined in a different
       translation unit even if they don't need dynamic initialization, so
       users may want to continue to use __thread for TLS variables with
       static initialization semantics.
       If the programmer can be sure that no use of the variable in a
       non-defining TU needs to trigger dynamic initialization (either
       because the variable is statically initialized, or a use of the
       variable in the defining TU will be executed before any uses in
       another TU), they can avoid this overhead with the
       -fno-extern-tls-init option.
       OpenMP threadprivate variables now also support dynamic
       initialization and destruction by the same mechanism.
     * G++ now implements the [10]C++11 attribute syntax, e.g.

[[noreturn]] void f();

       and also the alignment specifier, e.g.

alignas(double) int i;

     * G++ now implements [11]C++11 inheriting constructors, e.g.

struct A { A(int); };
struct B: A { using A::A; }; // defines B::B(int)
B b(42); // OK

     * As of GCC 4.8.1, G++ implements the change to decltype semantics
       from [12]N3276.

struct A f();
decltype(f()) g();    // OK, return type of f() is not required to be complete.

     * As of GCC 4.8.1, G++ implements [13]C++11 ref-qualifiers, e.g.

struct A { int f() &; };
int i = A().f();  // error, f() requires an lvalue object

     * G++ now supports a -std=c++1y option for experimentation with
       features proposed for the next revision of the standard, expected
       around 2014. Currently the only difference from -std=c++11 is
       support for return type deduction in normal functions, as proposed
       in [14]N3386. Status of C++1y features in GCC 4.8 can be found
       [15]here.
     * The G++ namespace association extension, __attribute ((strong)),
       has been deprecated. Inline namespaces should be used instead.
     * G++ now supports a -fext-numeric-literal option to control whether
       GNU numeric literal suffixes are accepted as extensions or
       processed as C++11 user-defined numeric literal suffixes. The flag
       is on (use suffixes for GNU literals) by default for -std=gnu++*,
       and -std=c++98. The flag is off (use suffixes for user-defined
       literals) by default for -std=c++11 and later.

    Runtime Library (libstdc++)

     * [16]Improved experimental support for the new ISO C++ standard,
       C++11, including:
          + forward_list meets the allocator-aware container requirements;
          + this_thread::sleep_for(), this_thread::sleep_until() and
            this_thread::yield() are defined without requiring the
            configure option --enable-libstdcxx-time;
     * Improvements to <random>:
          + SSE optimized normal_distribution.
          + Use of hardware RNG instruction for random_device on new x86
            processors (requires the assembler to support the
            instruction.)
       and <ext/random>:
          + New random number engine simd_fast_mersenne_twister_engine
            with an optimized SSE implementation.
          + New random number distributions beta_distribution,
            normal_mv_distribution, rice_distribution,
            nakagami_distribution, pareto_distribution, k_distribution,
            arcsine_distribution, hoyt_distribution.
     * Added --disable-libstdcxx-verbose configure option to disable
       diagnostic messages issued when a process terminates abnormally.
       This may be useful for embedded systems to reduce the size of
       executables that link statically to the library.

  Fortran

     * Compatibility notice:
          + Module files: The version of module files (.mod) has been
            incremented. Fortran MODULEs compiled by earlier GCC versions
            have to be recompiled, when they are USEd by files compiled
            with GCC 4.8. GCC 4.8 is not able to read .mod files created
            by earlier versions; attempting to do so gives an error
            message.
            Note: The ABI of the produced assembler data itself has not
            changed; object files and libraries are fully compatible with
            older versions except as noted below.
          + ABI: Some internal names (used in the assembler/object file)
            have changed for symbols declared in the specification part of
            a module. If an affected module - or a file using it via use
            association - is recompiled, the module and all files which
            directly use such symbols have to be recompiled as well. This
            change only affects the following kind of module symbols:
               o Procedure pointers. Note: C-interoperable function
                 pointers (type(c_funptr)) are not affected nor are
                 procedure-pointer components.
               o Deferred-length character strings.
     * The [17]BACKTRACE intrinsic subroutine has been added. It shows a
       backtrace at an arbitrary place in user code; program execution
       continues normally afterwards.
     * The [18]-Wc-binding-type warning option has been added (disabled by
       default). It warns if the a variable might not be C interoperable;
       in particular, if the variable has been declared using an intrinsic
       type with default kind instead of using a kind parameter defined
       for C interoperability in the intrinsic ISO_C_Binding module.
       Before, this warning was always printed. The -Wc-binding-type
       option is enabled by -Wall.
     * The [19]-Wrealloc-lhs and -Wrealloc-lhs-all warning command-line
       options have been added, which diagnose when code is inserted for
       automatic (re)allocation of a variable during assignment. This
       option can be used to decide whether it is safe to use
       [20]-fno-realloc-lhs. Additionally, it can be used to find
       automatic (re)allocation in hot loops. (For arrays, replacing
       "var=" by "var(:)=" disables the automatic reallocation.)
     * The [21]-Wcompare-reals command-line option has been added. When
       this is set, warnings are issued when comparing REAL or COMPLEX
       types for equality and inequality; consider replacing a == b by
       abs(a-b) < eps with a suitable eps. -Wcompare-reals is enabled by
       -Wextra.
     * The [22]-Wtarget-lifetime command-line option has been added
       (enabled with -Wall), which warns if the pointer in a pointer
       assignment might outlive its target.
     * Reading floating point numbers which use "q" for the exponential
       (such as 4.0q0) is now supported as vendor extension for better
       compatibility with old data files. It is strongly recommended to
       use for I/O the equivalent but standard conforming "e" (such as
       4.0e0).
       (For Fortran source code, consider replacing the "q" in
       floating-point literals by a kind parameter (e.g. 4.0e0_qp with a
       suitable qp). Note that - in Fortran source code - replacing "q" by
       a simple "e" is not equivalent.)
     * The GFORTRAN_TMPDIR environment variable for specifying a
       non-default directory for files opened with STATUS="SCRATCH", is
       not used anymore. Instead gfortran checks the POSIX/GNU standard
       TMPDIR environment variable. If TMPDIR is not defined, gfortran
       falls back to other methods to determine the directory for
       temporary files as documented in the [23]user manual.
     * [24]Fortran 2003:
          + Support for unlimited polymorphic variables (CLASS(*)) has
            been added. Nonconstant character lengths are not yet
            supported.
     * [25]TS 29113:
          + Assumed types (TYPE(*)) are now supported.
          + Experimental support for assumed-rank arrays (dimension(..))
            has been added. Note that currently gfortran's own array
            descriptor is used, which is different from the one defined in
            TS29113, see [26]gfortran's header file or use the [27]Chasm
            Language Interoperability Tools.

  Go

     * GCC 4.8.2 provides a complete implementation of the Go 1.1.2
       release.
     * GCC 4.8.0 and 4.8.1 implement a preliminary version of the Go 1.1
       release. The library support is not quite complete.
     * Go has been tested on GNU/Linux and Solaris platforms for various
       processors including x86, x86_64, PowerPC, SPARC, and Alpha. It may
       work on other platforms as well.

New Targets and Target Specific Improvements

  AArch64

     * A new port has been added to support AArch64, the new 64-bit
       architecture from ARM. Note that this is a separate port from the
       existing 32-bit ARM port.
     * The port provides initial support for the Cortex-A53 and the
       Cortex-A57 processors with the command line options
       -mcpu=cortex-a53 and -mcpu=cortex-a57.
     * As of GCC 4.8.4 a workaround for the ARM Cortex-A53 erratum 835769
       has been added and can be enabled by giving the
       -mfix-cortex-a53-835769 option. Alternatively it can be enabled by
       default by configuring GCC with the --enable-fix-cortex-a53-835769
       option.

  ARM

     * Initial support has been added for the AArch32 extensions defined
       in the ARMv8 architecture.
     * Code generation improvements for the Cortex-A7 and Cortex-A15 CPUs.
     * A new option, -mcpu=marvell-pj4, has been added to generate code
       for the Marvell PJ4 processor.
     * The compiler can now automatically generate the VFMA, VFMS, REVSH
       and REV16 instructions.
     * A new vectorizer cost model for Advanced SIMD configurations to
       improve the auto-vectorization strategies used.
     * The scheduler now takes into account the number of live registers
       to reduce the amount of spilling that can occur. This should
       improve code performance in large functions. The limit can be
       removed by using the option -fno-sched-pressure.
     * Improvements have been made to the Marvell iWMMX code generation
       and support for the iWMMX2 SIMD unit has been added. The option
       -mcpu=iwmmxt2 can be used to enable code generation for the latter.
     * A number of code generation improvements for Thumb2 to reduce code
       size when compiling for the M-profile processors.
     * The RTEMS (arm-rtems) port has been updated to use the EABI.
     * Code generation support for the old FPA and Maverick floating-point
       architectures has been removed. Ports that previously relied on
       these features have also been removed. This includes the targets:
          + arm*-*-linux-gnu (use arm*-*-linux-gnueabi)
          + arm*-*-elf (use arm*-*-eabi)
          + arm*-*-uclinux* (use arm*-*-uclinux*eabi)
          + arm*-*-ecos-elf (no alternative)
          + arm*-*-freebsd (no alternative)
          + arm*-wince-pe* (no alternative).

  AVR

     * Support for the "Embedded C" fixed-point has been added. For
       details, see the [28]GCC wiki and the [29]user manual. The support
       is not complete.
     * A new print modifier %r for register operands in inline assembler
       is supported. It will print the raw register number without the
       register prefix 'r':
    /* Return the most significant byte of 'val', a 64-bit value.  */

    unsigned char msb (long long val)
    {
      unsigned char c;
      __asm__ ("mov %0, %r1+7" : "=r" (c) : "r" (val));
      return c;
    }
       The inline assembler in this example will generate code like
    mov r24, 8+7
       provided c is allocated to R24 and val is allocated to R8...R15.
       This works because the GNU assembler accepts plain register numbers
       without register prefix.
     * Static initializers with 3-byte symbols are supported now:
    extern const __memx char foo;
    const __memx void *pfoo = &foo;
       This requires at least Binutils 2.23.

  IA-32/x86-64

     * Allow -mpreferred-stack-boundary=3 for the x86-64 architecture with
       SSE extensions disabled. Since the x86-64 ABI requires 16 byte
       stack alignment, this is ABI incompatible and intended to be used
       in controlled environments where stack space is an important
       limitation. This option will lead to wrong code when functions
       compiled with 16 byte stack alignment (such as functions from a
       standard library) are called with misaligned stack. In this case,
       SSE instructions may lead to misaligned memory access traps. In
       addition, variable arguments will be handled incorrectly for 16
       byte aligned objects (including x87 long double and __int128),
       leading to wrong results. You must build all modules with
       -mpreferred-stack-boundary=3, including any libraries. This
       includes the system libraries and startup modules.
     * Support for the new Intel processor codename Broadwell with RDSEED,
       ADCX, ADOX, PREFETCHW is available through -madx, -mprfchw,
       -mrdseed command-line options.
     * Support for the Intel RTM and HLE intrinsics, built-in functions
       and code generation is available via -mrtm and -mhle.
     * Support for the Intel FXSR, XSAVE and XSAVEOPT instruction sets.
       Intrinsics and built-in functions are available via -mfxsr, -mxsave
       and -mxsaveopt respectively.
     * New -maddress-mode=[short|long] options for x32.
       -maddress-mode=short overrides default 64-bit addresses to 32-bit
       by emitting the 0x67 address-size override prefix. This is the
       default address mode for x32.
     * New built-in functions to detect run-time CPU type and ISA:
          + A built-in function __builtin_cpu_is has been added to detect
            if the run-time CPU is of a particular type. It returns a
            positive integer on a match and zero otherwise. It accepts one
            string literal argument, the CPU name. For example,
            __builtin_cpu_is("westmere") returns a positive integer if the
            run-time CPU is an Intel Core i7 Westmere processor. Please
            refer to the [30]user manual for the list of valid CPU names
            recognized.
          + A built-in function __builtin_cpu_supports has been added to
            detect if the run-time CPU supports a particular ISA feature.
            It returns a positive integer on a match and zero otherwise.
            It accepts one string literal argument, the ISA feature. For
            example, __builtin_cpu_supports("ssse3") returns a positive
            integer if the run-time CPU supports SSSE3 instructions.
            Please refer to the [31]user manual for the list of valid ISA
            names recognized.
       Caveat: If these built-in functions are called before any static
       constructors are invoked, like during IFUNC initialization, then
       the CPU detection initialization must be explicitly run using this
       newly provided built-in function, __builtin_cpu_init. The
       initialization needs to be done only once. For example, this is how
       the invocation would look like inside an IFUNC initializer:
    static void (*some_ifunc_resolver(void))(void)
    {
      __builtin_cpu_init();
      if (__builtin_cpu_is("amdfam10h") ...
      if (__builtin_cpu_supports("popcnt") ...
    }

     * Function Multiversioning Support with G++:
       It is now possible to create multiple function versions each
       targeting a specific processor and/or ISA. Function versions have
       the same signature but different target attributes. For example,
       here is a program with function versions:
    __attribute__ ((target ("default")))
    int foo(void)
    {
      return 1;
    }

    __attribute__ ((target ("sse4.2")))
    int foo(void)
    {
      return 2;
    }

    int main (void)
    {
      int (*p) = &foo;
      assert ((*p)() == foo());
      return 0;
    }

       Please refer to this [32]wiki for more information.
     * The x86 back end has been improved to allow option -fschedule-insns
       to work reliably. This option can be used to schedule instructions
       better and leads to improved performace in certain cases.
     * Windows MinGW-w64 targets (*-w64-mingw*) require at least r5437
       from the Mingw-w64 trunk.
     * Support for new AMD family 15h processors (Steamroller core) is now
       available through the -march=bdver3 and -mtune=bdver3 options.
     * Support for new AMD family 16h processors (Jaguar core) is now
       available through the -march=btver2 and -mtune=btver2 options.

  FRV

     * This target now supports the -fstack-usage command-line option.

  MIPS

     * GCC can now generate code specifically for the R4700, Broadcom XLP
       and MIPS 34kn processors. The associated -march options are
       -march=r4700, -march=xlp and -march=34kn respectively.
     * GCC now generates better DSP code for MIPS 74k cores thanks to
       further scheduling optimizations.
     * The MIPS port now supports the -fstack-check option.
     * GCC now passes the -mmcu and -mno-mcu options to the assembler.
     * Previous versions of GCC would silently accept -fpic and -fPIC for
       -mno-abicalls targets like mips*-elf. This combination was not
       intended or supported, and did not generate position-independent
       code. GCC 4.8 now reports an error when this combination is used.

  PowerPC / PowerPC64 / RS6000

     * SVR4 configurations (GNU/Linux, FreeBSD, NetBSD) no longer save,
       restore or update the VRSAVE register by default. The respective
       operating systems manage the VRSAVE register directly.
     * Large TOC support has been added for AIX through the command line
       option -mcmodel=large.
     * Native Thread-Local Storage support has been added for AIX.
     * VMX (Altivec) and VSX instruction sets now are enabled implicitly
       when targetting processors that support those hardware features on
       AIX 6.1 and above.

  RX

     * This target will now issue a warning message whenever multiple fast
       interrupt handlers are found in the same compilation unit. This
       feature can be turned off by the new
       -mno-warn-multiple-fast-interrupts command-line option.

  S/390, System z

     * Support for the IBM zEnterprise zEC12 processor has been added.
       When using the -march=zEC12 option, the compiler will generate code
       making use of the following new instructions:
          + load and trap instructions
          + 2 new compare and trap instructions
          + rotate and insert selected bits - without CC clobber
       The -mtune=zEC12 option enables zEC12 specific instruction
       scheduling without making use of new instructions.
     * Register pressure sensitive instruction scheduling is enabled by
       default.
     * The ifunc function attribute is enabled by default.
     * memcpy and memcmp invokations on big memory chunks or with run time
       lengths are not generated inline anymore when tuning for z10 or
       higher. The purpose is to make use of the IFUNC optimized versions
       in Glibc.

  SH

     * The default alignment settings have been reduced to be less
       aggressive. This results in more compact code for optimization
       levels other than -Os.
     * Improved support for the __atomic built-in functions:
          + A new option -matomic-model=model selects the model for the
            generated atomic sequences. The following models are
            supported:

              soft-gusa
                      Software gUSA sequences (SH3* and SH4* only). On
                      SH4A targets this will now also partially utilize
                      the movco.l and movli.l instructions. This is the
                      default when the target is sh3*-*-linux* or
                      sh4*-*-linux*.

              hard-llcs
                      Hardware movco.l / movli.l sequences (SH4A only).

              soft-tcb
                      Software thread control block sequences.

              soft-imask
                      Software interrupt flipping sequences (privileged
                      mode only). This is the default when the target is
                      sh1*-*-linux* or sh2*-*-linux*.

              none
                      Generates function calls to the respective __atomic
                      built-in functions. This is the default for SH64
                      targets or when the target is not sh*-*-linux*.

          + The option -msoft-atomic has been deprecated. It is now an
            alias for -matomic-model=soft-gusa.
          + A new option -mtas makes the compiler generate the tas.b
            instruction for the __atomic_test_and_set built-in function
            regardless of the selected atomic model.
          + The __sync functions in libgcc now reflect the selected atomic
            model when building the toolchain.
     * Added support for the mov.b and mov.w instructions with
       displacement addressing.
     * Added support for the SH2A instructions movu.b and movu.w.
     * Various improvements to code generated for integer arithmetic.
     * Improvements to conditional branches and code that involves the T
       bit. A new option -mzdcbranch tells the compiler to favor
       zero-displacement branches. This is enabled by default for SH4*
       targets.
     * The pref instruction will now be emitted by the __builtin_prefetch
       built-in function for SH3* targets.
     * The fmac instruction will now be emitted by the fmaf standard
       function and the __builtin_fmaf built-in function.
     * The -mfused-madd option has been deprecated in favor of the
       machine-independent -ffp-contract option. Notice that the fmac
       instruction will now be generated by default for expressions like a
       * b + c. This is due to the compiler default setting
       -ffp-contract=fast.
     * Added new options -mfsrra and -mfsca to allow the compiler using
       the fsrra and fsca instructions on targets other than SH4A (where
       they are already enabled by default).
     * Added support for the __builtin_bswap32 built-in function. It is
       now expanded as a sequence of swap.b and swap.w instructions
       instead of a library function call.
     * The behavior of the -mieee option has been fixed and the negative
       form -mno-ieee has been added to control the IEEE conformance of
       floating point comparisons. By default -mieee is now enabled and
       the option -ffinite-math-only implicitly sets -mno-ieee.
     * Added support for the built-in functions __builtin_thread_pointer
       and __builtin_set_thread_pointer. This assumes that GBR is used to
       hold the thread pointer of the current thread. Memory loads and
       stores relative to the address returned by __builtin_thread_pointer
       will now also utilize GBR based displacement address modes.
     * The -mdiv= option for targets other than SHmedia has been fixed and
       documented.

  SPARC

     * Added optimized instruction scheduling for Niagara4.

  TILE-Gx

     * Added support for the -mcmodel=MODEL command-line option. The
       models supported are small and large.

  V850

     * This target now supports the E3V5 architecture via the use of the
       new -mv850e3v5 command-line option. It also has experimental
       support for the e3v5 LOOP instruction which can be enabled via the
       new -mloop command-line option.

  XStormy16

     * This target now supports the -fstack-usage command-line option.

Operating Systems

  OpenBSD

     * Support for OpenBSD/amd64 (x86_64-*-openbsd*) has been added and
       support for OpenBSD/i386 (i386-*-openbsd*) has been rejuvenated.

  Windows (Cygwin)

     * Executables are now linked against shared libgcc by default. The
       previous default was to link statically, which can still be done by
       explicitly specifying -static or static-libgcc on the command line.
       However it is strongly advised against, as it will cause problems
       for any application that makes use of DLLs compiled by GCC. It
       should be alright for a monolithic stand-alone application that
       only links against the Windows DLLs, but offers little or no
       benefit.

GCC 4.8.1

   This is the [33]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.8.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

   The C++11 <chrono> std::chrono::system_clock and
   std::chrono::steady_clock classes have changed ABI in GCC 4.8.1, they
   both are now separate (never typedefs of each other), both use
   std::chrono::nanoseconds resolution, on most GNU/Linux configurations
   std::chrono::steady_clock is now finally monotonic, and both classes
   are mangled differently than in the previous GCC releases.
   std::chrono::system_clock::now() with std::chrono::microseconds resp.
   std::chrono::seconds resolution is still exported for backwards
   compatibility with default configured libstdc++. Note that libstdc++
   configured with --enable-libstdcxx-time= used to be ABI incompatible
   with default configured libstdc++ for those two classes and no ABI
   compatibility can be offered for those configurations, so any C++11
   code that uses those classes and has been compiled and linked against
   libstdc++ configured with the non-default --enable-libstdcxx-time=
   configuration option needs to be recompiled.

GCC 4.8.2

   This is the [34]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.8.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 4.8.3

   This is the [35]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.8.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

   Support for the new powerpc64le-linux platform has been added. It
   defaults to generating code that conforms to the ELFV2 ABI.

GCC 4.8.4

   This is the [36]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.8.4 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 4.8.5

   This is the [37]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.8.5 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).


    For questions related to the use of GCC, please consult these web
    pages and the [38]GCC manuals. If that fails, the
    [39]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [40]gcc@gcc.gnu.org. All of [41]our lists have public
    archives.

   Copyright (C) [42]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [43]maintained by the GCC team. Last modified
   2017-02-27[44].

References

   1. https://gcc.gnu.org/wiki/cxx-conversion
   2. ftp://gcc.gnu.org/pub/gcc/infrastructure/
   3. http://www.nongnu.org/avr-libc/
   4. https://gcc.gnu.org/PR54461
   5. https://gcc.gnu.org/gcc-4.8/porting_to.html
   6. https://github.com/google/sanitizers
   7. https://code.google.com/archive/p/data-race-test/wikis/ThreadSanitizer.wiki
   8. https://lkml.org/lkml/2006/11/28/239
   9. http://gcc.gnu.org/gcc-4.8/cxx0x_status.html
  10. http://gcc.gnu.org/gcc-4.8/cxx0x_status.html
  11. http://gcc.gnu.org/gcc-4.8/cxx0x_status.html
  12. http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2011/n3276.pdf
  13. http://gcc.gnu.org/gcc-4.8/cxx0x_status.html
  14. http://www.open-std.org/JTC1/SC22/WG21/docs/papers/2012/n3386.html
  15. http://gcc.gnu.org/projects/cxx1y.html
  16. https://gcc.gnu.org/onlinedocs/gcc-4.8.4/libstdc++/manual/manual/status.html#status.iso.2011
  17. https://gcc.gnu.org/onlinedocs/gfortran/BACKTRACE.html
  18. https://gcc.gnu.org/onlinedocs/gfortran/Error-and-Warning-Options.html
  19. https://gcc.gnu.org/onlinedocs/gfortran/Error-and-Warning-Options.html
  20. https://gcc.gnu.org/onlinedocs/gfortran/Code-Gen-Options.html
  21. https://gcc.gnu.org/onlinedocs/gfortran/Error-and-Warning-Options.html
  22. https://gcc.gnu.org/onlinedocs/gfortran/Error-and-Warning-Options.html
  23. https://gcc.gnu.org/onlinedocs/gfortran/TMPDIR.html
  24. https://gcc.gnu.org/wiki/Fortran2003Status
  25. https://gcc.gnu.org/wiki/TS29113Status
  26. https://gcc.gnu.org/viewcvs/trunk/libgfortran/libgfortran.h?content-type=text%2Fplain&view=co
  27. http://chasm-interop.sourceforge.net/
  28. https://gcc.gnu.org/wiki/avr-gcc#Fixed-Point_Support
  29. https://gcc.gnu.org/onlinedocs/gcc/Fixed-Point.html
  30. https://gcc.gnu.org/onlinedocs/gcc/x86-Built-in-Functions.html
  31. https://gcc.gnu.org/onlinedocs/gcc/x86-Built-in-Functions.html
  32. https://gcc.gnu.org/wiki/FunctionMultiVersioning
  33. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.8.1
  34. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.8.2
  35. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.8.3
  36. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.8.4
  37. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.8.5
  38. https://gcc.gnu.org/onlinedocs/
  39. mailto:gcc-help@gcc.gnu.org
  40. mailto:gcc@gcc.gnu.org
  41. https://gcc.gnu.org/lists.html
  42. http://www.fsf.org/
  43. https://gcc.gnu.org/about.html
  44. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-4.7/index.html

                             GCC 4.7 Release Series

   June 12, 2014

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 4.7.4.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 4.7.3 relative to previous releases of GCC.

   This release series is no longer maintained.

Release History

   GCC 4.7.4
          June 12, 2014 ([2]changes, [3]documentation)

   GCC 4.7.3
          April 11, 2013 ([4]changes, [5]documentation)

   GCC 4.7.2
          September 20, 2012 ([6]changes, [7]documentation)

   GCC 4.7.1
          June 14, 2012 ([8]changes, [9]documentation)

   GCC 4.7.0
          March 22, 2012 ([10]changes, [11]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [12]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [13]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [14]GCC
   project web site or contact the [15]GCC development mailing list.

   To obtain GCC please use [16]our mirror sites or [17]our SVN server.


    For questions related to the use of GCC, please consult these web
    pages and the [18]GCC manuals. If that fails, the
    [19]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [20]gcc@gcc.gnu.org. All of [21]our lists have public
    archives.

   Copyright (C) [22]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [23]maintained by the GCC team. Last modified
   2016-09-30[24].

References

   1. http://www.gnu.org/
   2. http://gcc.gnu.org/gcc-4.7/changes.html
   3. https://gcc.gnu.org/onlinedocs/4.7.4/
   4. http://gcc.gnu.org/gcc-4.7/changes.html
   5. https://gcc.gnu.org/onlinedocs/4.7.3/
   6. http://gcc.gnu.org/gcc-4.7/changes.html
   7. https://gcc.gnu.org/onlinedocs/4.7.2/
   8. http://gcc.gnu.org/gcc-4.7/changes.html
   9. https://gcc.gnu.org/onlinedocs/4.7.1/
  10. http://gcc.gnu.org/gcc-4.7/changes.html
  11. https://gcc.gnu.org/onlinedocs/4.7.0/
  12. http://gcc.gnu.org/gcc-4.7/buildstat.html
  13. https://gcc.gnu.org/onlinedocs/gcc/Contributors.html
  14. http://gcc.gnu.org/index.html
  15. mailto:gcc@gcc.gnu.org
  16. http://gcc.gnu.org/mirrors.html
  17. http://gcc.gnu.org/svn.html
  18. https://gcc.gnu.org/onlinedocs/
  19. mailto:gcc-help@gcc.gnu.org
  20. mailto:gcc@gcc.gnu.org
  21. https://gcc.gnu.org/lists.html
  22. http://www.fsf.org/
  23. https://gcc.gnu.org/about.html
  24. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-4.7/changes.html

                             GCC 4.7 Release Series
                        Changes, New Features, and Fixes

Caveats

     * The -fconserve-space flag has been deprecated. The flag had no
       effect for most targets: only targets without a global .bss section
       and without support for switchable sections. Furthermore, the flag
       only had an effect for G++, where it could result in wrong
       semantics (please refer to the GCC manual for further details). The
       flag will be removed in GCC 4.8
     * Support for a number of older systems and recently unmaintained or
       untested target ports of GCC has been declared obsolete in GCC 4.7.
       Unless there is activity to revive them, the next release of GCC
       will have their sources permanently removed.
       All GCC ports for the following processor architectures have been
       declared obsolete:
          + picoChip (picochip-*)
       The following ports for individual systems on particular
       architectures have been obsoleted:
          + IRIX 6.5 (mips-sgi-irix6.5)
          + MIPS OpenBSD (mips*-*-openbsd*)
          + Solaris 8 (*-*-solaris2.8). Details can be found in the
            [1]announcement.
          + Tru64 UNIX V5.1 (alpha*-dec-osf5.1*)
     * On ARM, when compiling for ARMv6 (but not ARMv6-M), ARMv7-A,
       ARMv7-R, or ARMv7-M, the new option -munaligned-access is active by
       default, which for some sources generates code that accesses memory
       on unaligned addresses. This requires the kernel of those systems
       to enable such accesses (controlled by CP15 register c1, refer to
       ARM documentation). Alternatively, or for compatibility with
       kernels where unaligned accesses are not supported, all code has to
       be compiled with -mno-unaligned-access. Upstream Linux kernel
       releases have automatically and unconditionally supported unaligned
       accesses as emitted by GCC due to this option being active since
       version 2.6.28.
     * Support on ARM for the legacy floating-point accelerator (FPA) and
       the mixed-endian floating-point format that it used has been
       obsoleted. The ports that still use this format have been obsoleted
       as well. Many legacy ARM ports already provide an alternative that
       uses the VFP floating-point format. The obsolete ports will be
       deleted in the next release.
       The obsolete ports with alternatives are:
          + arm*-*-rtems (use arm*-*-rtemseabi)
          + arm*-*-linux-gnu (use arm*-*-linux-gnueabi)
          + arm*-*-elf (use arm*-*-eabi)
          + arm*-*-uclinux* (use arm*-*-uclinux*eabi)
       Note, however, that these alternatives are not binary compatible
       with their legacy counterparts (although some can support running
       legacy applications).
       The obsolete ports that currently lack a modern alternative are:
          + arm*-*-ecos-elf
          + arm*-*-freebsd
          + arm*-wince-pe*
       New ports that support more recent versions of the architecture are
       welcome.
     * Support for the Maverick co-processor on ARM has been obsoleted.
       Code to support it will be deleted in the next release.
     * Support has been removed for Unix International threads on Solaris
       2, so the --enable-threads=solaris configure option and the
       -threads compiler option don't work any longer.
     * Support has been removed for the Solaris BSD Compatibility Package,
       which lives in /usr/ucbinclude and /usr/ucblib. It has been removed
       from Solaris 11, and was only intended as a migration aid from
       SunOS 4 to SunOS 5. The -compat-bsd compiler option is not
       recognized any longer.
     * The AVR port's libgcc has been improved and its multilib structure
       has been enhanced. As a result, all objects contributing to an
       application must either be compiled with GCC versions up to 4.6.x
       or with GCC versions 4.7.1 or later. If the compiler is used with
       AVR Libc, you need a version that supports the new layout, i.e.
       implements [2]#35407.
     * The AVR port's -mshort-calls command-line option has been
       deprecated. It will be removed in the GCC 4.8 release. See -mrelax
       for a replacement.
     * The AVR port only references startup code that clears .bss and the
       common section resp. initializes the .data and .rodata section
       provided respective sections (or subsections thereof) are not
       empty, see [3]PR18145. Applications that put all static storage
       objects into non-standard sections and / or define all static
       storage objects in assembler modules, must reference __do_clear_bss
       resp. __do_copy_data by hand or undefine the symbol(s) by means of
       -Wl,-u,__do_clear_bss resp. -Wl,-u,__do_copy_data.
     * The ARM port's -mwords-little-endian option has been deprecated. It
       will be removed in a future release.
     * Support has been removed for the NetWare x86 configuration
       obsoleted in GCC 4.6.
     * It is no longer possible to use the "l" constraint in MIPS16 asm
       statements.
     * GCC versions 4.7.0 and 4.7.1 had changes to the C++ standard
       library which affected the ABI in C++11 mode: a data member was
       added to std::list changing its size and altering the definitions
       of some member functions, and std::pair's move constructor was
       non-trivial which altered the calling convention for functions with
       std::pair arguments or return types. The ABI incompatibilities have
       been fixed for GCC version 4.7.2 but as a result C++11 code
       compiled with GCC 4.7.0 or 4.7.1 may be incompatible with C++11
       code compiled with different GCC versions and with C++98/C++03 code
       compiled with any version.
     * On ARM, a bug has been fixed in GCC's implementation of the AAPCS
       rules for the layout of vectors that could lead to wrong code being
       generated. Vectors larger than 8 bytes in size are now by default
       aligned to an 8-byte boundary. This is an ABI change: code that
       makes explicit use of vector types may be incompatible with binary
       objects built with older versions of GCC. Auto-vectorized code is
       not affected by this change. (This change affects GCC versions
       4.7.2 and later.)
     * More information on porting to GCC 4.7 from previous versions of
       GCC can be found in the [4]porting guide for this release.

General Optimizer Improvements

     * Support for a new parameter --param case-values-threshold=n was
       added to allow users to control the cutoff between doing switch
       statements as a series of if statements and using a jump table.
     * Link-time optimization (LTO) improvements:
          + Improved scalability and reduced memory usage. Link time
            optimization of Firefox now requires 3GB of RAM on a 64-bit
            system, while over 8GB was needed previously. Linking time has
            been improved, too. The serial stage of linking Firefox has
            been sped up by about a factor of 10.
          + Reduced size of object files and temporary storage used during
            linking.
          + Streaming performance (both outbound and inbound) has been
            improved.
          + ld -r is now supported with LTO.
          + Several bug fixes, especially in symbol table handling and
            merging.
     * Interprocedural optimization improvements:
          + Heuristics now take into account that after inlining code will
            be optimized out because of known values (or properties) of
            function parameters. For example:
void foo(int a)
{
  if (a > 10)
    ... huge code ...
}
void bar (void)
{
  foo (0);
}

            The call of foo will be inlined into bar even when optimizing
            for code size. Constructs based on __builtin_constant_p are
            now understood by the inliner and code size estimates are
            evaluated a lot more realistically.
          + The representation of C++ virtual thunks and aliases (both
            implicit and defined via the alias attribute) has been
            re-engineered. Aliases no longer pose optimization barriers
            and calls to an alias can be inlined and otherwise optimized.
          + The inter-procedural constant propagation pass has been
            rewritten. It now performs generic function specialization.
            For example when compiling the following:
void foo(bool flag)
{
  if (flag)
    ... do something ...
  else
    ... do something else ...
}
void bar (void)
{
  foo (false);
  foo (true);
  foo (false);
  foo (true);
  foo (false);
  foo (true);
}

            GCC will now produce two copies of foo. One with flag being
            true, while other with flag being false. This leads to
            performance improvements previously possible only by inlining
            all calls. Cloning causes a lot less code size growth.
     * A string length optimization pass has been added. It attempts to
       track string lengths and optimize various standard C string
       functions like strlen, strchr, strcpy, strcat, stpcpy and their
       _FORTIFY_SOURCE counterparts into faster alternatives. This pass is
       enabled by default at -O2 or above, unless optimizing for size, and
       can be disabled by the -fno-optimize-strlen option. The pass can
       e.g. optimize
char *bar (const char *a)
{
  size_t l = strlen (a) + 2;
  char *p = malloc (l); if (p == NULL) return p;
  strcpy (p, a); strcat (p, "/"); return p;
}

       into:
char *bar (const char *a)
{
  size_t tmp = strlen (a);
  char *p = malloc (tmp + 2); if (p == NULL) return p;
  memcpy (p, a, tmp); memcpy (p + tmp, "/", 2); return p;
}

       or for hosted compilations where stpcpy is available in the runtime
       and headers provide its prototype, e.g.
void foo (char *a, const char *b, const char *c, const char *d)
{
  strcpy (a, b); strcat (a, c); strcat (a, d);
}

       can be optimized into:
void foo (char *a, const char *b, const char *c, const char *d)
{
  strcpy (stpcpy (stpcpy (a, b), c), d);
}

New Languages and Language specific improvements

     * Version 3.1 of the [5]OpenMP specification is now supported for the
       C, C++, and Fortran compilers.

  Ada

     * The command-line option -feliminate-unused-debug-types has been
       re-enabled by default, as it is for the other languages, leading to
       a reduction in debug info size of 12.5% and more for relevant
       cases, as well as to a small compilation speedup.

  C family

     * A new built-in, __builtin_assume_aligned, has been added, through
       which the compiler can be hinted about pointer alignment and can
       use it to improve generated code.
     * A new warning option -Wunused-local-typedefs was added for C, C++,
       Objective-C and Objective-C++. This warning diagnoses typedefs
       locally defined in a function, and otherwise not used.
     * A new experimental command-line option -ftrack-macro-expansion was
       added for C, C++, Objective-C, Objective-C++ and Fortran. It allows
       the compiler to emit diagnostic about the current macro expansion
       stack when a compilation error occurs in a macro expansion.
     * Experimental support for transactional memory has been added. It
       includes support in the compiler, as well as a supporting runtime
       library called libitm. To compile code with transactional memory
       constructs, use the -fgnu-tm option.
       Support is currently available for Alpha, ARM, PowerPC, SH, SPARC,
       and 32-bit/64-bit x86 platforms.
       For more details on transactional memory see [6]the GCC WiKi.
     * Support for atomic operations specifying the C++11/C11 memory model
       has been added. These new __atomic routines replace the existing
       __sync built-in routines.
       Atomic support is also available for memory blocks. Lock-free
       instructions will be used if a memory block is the same size and
       alignment as a supported integer type. Atomic operations which do
       not have lock-free support are left as function calls. A set of
       library functions is available on the GCC atomic wiki in the
       "External Atomics Library" section.
       For more details on the memory models and features, see the
       [7]atomic wiki.
     * When a binary operation is performed on vector types and one of the
       operands is a uniform vector, it is possible to replace the vector
       with the generating element. For example:
typedef int v4si __attribute__ ((vector_size (16)));
v4si res, a = {1,2,3,4};
int x;

res = 2 + a;  /* means {2,2,2,2} + a  */
res = a - x;  /* means a - {x,x,x,x}  */

  C

     * There is support for some more features from the C11 revision of
       the ISO C standard. GCC now accepts the options -std=c11 and
       -std=gnu11, in addition to the previous -std=c1x and -std=gnu1x.
          + Unicode strings (previously supported only with options such
            as -std=gnu11, now supported with -std=c11), and the
            predefined macros __STDC_UTF_16__ and __STDC_UTF_32__.
          + Nonreturning functions (_Noreturn and <stdnoreturn.h>).
          + Alignment support (_Alignas, _Alignof, max_align_t,
            <stdalign.h>).
          + A built-in function __builtin_complex is provided to support C
            library implementation of the CMPLX family of macros.

  C++

     * G++ now accepts the -std=c++11, -std=gnu++11, and -Wc++11-compat
       options, which are equivalent to -std=c++0x, -std=gnu++0x, and
       -Wc++0x-compat, respectively.
     * G++ now implements [8]C++11 extended friend syntax:

template<class W>
class Q
{
  static const int I = 2;
public:
  friend W;
};

struct B
{
  int ar[Q<B>::I];
};

     * Thanks to Ville Voutilainen, G++ now implements [9]C++11 explicit
       override control.

struct B {
  virtual void f() const final;
  virtual void f(int);
};

struct D : B {
  void f() const;            // error: D::f attempts to override final B::f
  void f(long) override;     // error: doesn't override anything
  void f(int) override;      // ok
};

struct E final { };
struct F: E { }; // error: deriving from final class

     * G++ now implements [10]C++11 non-static data member initializers.

struct A {
  int i = 42;
} a; // initializes a.i to 42

     * Thanks to Ed Smith-Rowland, G++ now implements [11]C++11
       user-defined literals.

// Not actually a good approximation.  :)
constexpr long double operator"" _degrees (long double d) { return d * 0.0175; }
long double pi = 180.0_degrees;

     * G++ now implements [12]C++11 alias-declarations.

template <class T> using Ptr = T*;
Ptr<int> ip;  // decltype(ip) is int*

     * Thanks to Ville Voutilainen and Pedro Lamarao, G++ now implements
       [13]C++11 delegating constructors.

struct A {
  A(int);
  A(): A(42) { } // delegate to the A(int) constructor
};

     * G++ now fully implements C++11 atomic classes rather than just
       integer derived classes.

class POD {
  int a;
  int b;
};
std::atomic<POD> my_atomic_POD;

     * G++ now sets the predefined macro __cplusplus to the correct value,
       199711L for C++98/03, and 201103L for C++11.
     * G++ now correctly implements the two-phase lookup rules such that
       an unqualified name used in a template must have an appropriate
       declaration found either in scope at the point of definition of the
       template or by argument-dependent lookup at the point of
       instantiation. As a result, code that relies on a second
       unqualified lookup at the point of instantiation to find functions
       declared after the template or in dependent bases will be rejected.
       The compiler will suggest ways to fix affected code, and using the
       -fpermissive compiler flag will allow the code to compile with a
       warning.

template <class T>
void f() { g(T()); } // error, g(int) not found by argument-dependent lookup
void g(int) { } // fix by moving this declaration before the declaration of f

template <class T>
struct A: T {
  // error, B::g(B) not found by argument-dependent lookup
  void f() { g(T()); } // fix by using this->g or A::g
};

struct B { void g(B); };

int main()
{
  f<int>();
  A<B>().f();
}

     * G++ now properly re-uses stack space allocated for temporary
       objects when their lifetime ends, which can significantly lower
       stack consumption for some C++ functions. As a result of this, some
       code with undefined behavior will now break:

const int &f(const int &i) { return i; }
....
const int &x = f(1);
const int &y = f(2);

       Here, x refers to the temporary allocated to hold the 1 argument,
       which only lives until the end of the initialization; it
       immediately becomes a dangling reference. So the next statement
       re-uses the stack slot to hold the 2 argument, and users of x get
       that value instead.
       Note that this should not cause any change of behavior for
       temporaries of types with non-trivial destructors, as they are
       already destroyed at end of full-expression; the change is that now
       the storage is released as well.
     * A new command-line option -Wdelete-non-virtual-dtor has been added
       to warn when delete is used to destroy an instance of a class which
       has virtual functions and non-virtual destructor. It is unsafe to
       delete an instance of a derived class through a pointer to a base
       class if the base class does not have a virtual destructor. This
       warning is enabled by -Wall.
     * A new command-line option -Wzero-as-null-pointer-constant has been
       added to warn when a literal '0' is used as null pointer constant.
       It can be useful to facilitate the conversion to nullptr in C++11.
     * As per C++98, access-declarations are now deprecated by G++.
       Using-declarations are to be used instead. Furthermore, some
       efforts have been made to improve the support of class scope
       using-declarations. In particular, using-declarations referring to
       a dependent type now work as expected ([14]bug c++/14258).
     * The ELF symbol visibility of a template instantiation is now
       properly constrained by the visibility of its template arguments
       ([15]bug c++/35688).

    Runtime Library (libstdc++)

     * [16]Improved experimental support for the new ISO C++ standard,
       C++11, including:
          + using noexcept in most of the library;
          + implementations of pointer_traits, allocator_traits and
            scoped_allocator_adaptor;
          + uses-allocator construction for tuple;
          + vector meets the allocator-aware container requirements;
          + replacing monotonic_clock with steady_clock;
          + enabling the thread support library on most POSIX targets;
          + many small improvements to conform to the FDIS.
     * Added --enable-clocale=newlib configure option.
     * Debug Mode iterators for unordered associative containers.
     * Avoid polluting the global namespace and do not include <unistd.h>.

  Fortran

     * The compile flag [17]-fstack-arrays has been added, which causes
       all local arrays to be put on stack memory. For some programs this
       will improve the performance significantly. If your program uses
       very large local arrays, it is possible that you will have to
       extend your runtime limits for stack memory.
     * The [18]-Ofast flag now also implies [19]-fno-protect-parens and
       [20]-fstack-arrays.
     * Front-end optimizations can now be selected by the
       [21]-ffrontend-optimize option and deselected by the
       -fno-frontend-optimize option.
     * When front-end optimization removes a function call,
       [22]-Wfunction-elimination warns about that.
     * When performing front-end-optimization, the
       [23]-faggressive-function-elimination option allows the removal of
       duplicate function calls even for impure functions.
     * The flag [24]-Wreal-q-constant has been added, which warns if
       floating-point literals have been specified using q (such as
       1.0q0); the q marker is now supported as a vendor extension to
       denote quad precision (REAL(16) or, if not available, REAL(10)).
       Consider using a kind parameter (such as in 1.0_qp) instead, which
       can be obtained via [25]SELECTED_REAL_KIND.
     * The GFORTRAN_USE_STDERR environment variable has been removed. GNU
       Fortran now always prints error messages to standard error. If you
       wish to redirect standard error, please consult the manual for your
       OS, shell, batch environment etc. as appropriate.
     * The -fdump-core option and GFORTRAN_ERROR_DUMPCORE environment
       variable have been removed. When encountering a serious error,
       gfortran will now always abort the program. Whether a core dump is
       generated depends on the user environment settings; see the ulimit
       -c setting for POSIX shells, limit coredumpsize for C shells, and
       the [26]WER user-mode dumps settings on Windows.
     * The [27]-fbacktrace option is now enabled by default. When
       encountering a fatal error, gfortran will attempt to print a
       backtrace to standard error before aborting. It can be disabled
       with -fno-backtrace. Note: On POSIX targets with the addr2line
       utility from GNU binutils, GNU Fortran can print a backtrace with
       function name, file name, line number information in addition to
       the addresses; otherwise only the addresses are printed.
     * [28]Fortran 2003:
          + Generic interface names which have the same name as derived
            types are now supported, which allows to write constructor
            functions. Note that Fortran does not support static
            constructor functions; only default initialization or an
            explicit structure-constructor initialization are available.
          + [29]Polymorphic (class) arrays are now supported.
     * [30]Fortran 2008:
          + Support for the DO CONCURRENT construct has been added, which
            allows the user to specify that individual loop iterations
            have no interdependencies.
          + [31]Coarrays: Full single-image support except for polymorphic
            coarrays. Additionally, preliminary support for multiple
            images via an MPI-based [32]coarray communication library has
            been added. Note: The library version is not yet usable as
            remote coarray access is not yet possible.
     * [33]TS 29113:
          + New flag [34]-std=f2008ts permits programs that are expected
            to conform to the Fortran 2008 standard and the draft
            Technical Specification (TS) 29113 on Further Interoperability
            of Fortran with C.
          + The OPTIONAL attribute is now allowed for dummy arguments of
            BIND(C) procedures.
          + The RANK intrinsic has been added.
          + The implementation of the ASYNCHRONOUS attribute in GCC is
            compatible with the candidate draft of TS 29113 (since GCC
            4.6).

  Go

     * GCC 4.7 implements the [35]Go 1 language standard. The library
       support in 4.7.0 is not quite complete, due to release timing.
       Release 4.7.1 includes complete support for Go 1. The Go library is
       from the Go 1.0.1 release.
     * Go has been tested on GNU/Linux and Solaris platforms. It may work
       on other platforms as well.

New Targets and Target Specific Improvements

  ARM

     * GCC now supports the Cortex-A7 processor implementing the v7-a
       version of the architecture using the option -mcpu=cortex-a7.
     * The default vector size in auto-vectorization for NEON is now 128
       bits. If vectorization fails thusly, the vectorizer tries again
       with 64-bit vectors.
     * A new option -mvectorize-with-neon-double was added to allow users
       to change the vector size to 64 bits.

  AVR

     * GCC now supports the XMEGA architecture. This requires GNU binutils
       2.22 or later.
     * Support for the [36]named address spaces __flash, __flash1, ...,
       __flash5 and __memx has been added. These address spaces locate
       read-only data in flash memory and allow reading from flash memory
       by means of ordinary C code, i.e. without the need of (inline)
       assembler code:

const __flash int values[] = { 42, 31 };

int add_values (const __flash int *p, int i)
{
    return values[i] + *p;
}

     * Support has been added for the AVR-specific configure option
       --with-avrlibc=yes in order to arrange for better integration of
       [37]AVR-Libc. This configure option is supported in avr-gcc 4.7.2
       and newer and will only take effect in non-RTEMS configurations. If
       avr-gcc is configured for RTEMS, the option will be ignored which
       is the same as specifying --with-avrlibc=no. See [38]PR54461 for
       more technical details.
     * Support for AVR-specific [39]built-in functions has been added.
     * Support has been added for the signed and unsigned 24-bit scalar
       integer types __int24 and __uint24.
     * New command-line options -maccumulate-args, -mbranch-cost=cost and
       -mstrict-X were added to allow better fine-tuning of code
       optimization.
     * The command-line option -fdata-sections now also takes affect on
       the section names of variables with the progmem attribute.
     * A new inline assembler print modifier %i to print a RAM address as
       I/O address has been added:

#include <avr/io.h> /* Port Definitions from AVR-LibC */

void set_portb (uint8_t value)
{
    asm volatile ("out %i0, %1" :: "n" (&PORTB), "r" (value) : "memory");
}

       The offset between an I/O address and the RAM address for that I/O
       location is device-specific. This offset is taken into account when
       printing a RAM address with the %i modifier so that the address is
       suitable to be used as operand in an I/O command. The address must
       be a constant integer known at compile time.
     * The inline assembler constraint "R" to represent integers in the
       range -6 ... 5 has been removed without replacement.
     * Many optimizations to:
          + 64-bit integer arithmetic
          + Widening multiplication
          + Integer division by a constant
          + Avoid constant reloading in multi-byte instructions.
          + Micro-optimizations for special instruction sequences.
          + Generic built-in functions like __builtin_ffs*,
            __builtin_clz*, etc.
          + If-else decision trees generated by switch instructions
          + Merging of data located in flash memory
          + New libgcc variants for devices with 8-bit wide stack pointer
          + ...
     * Better documentation:
          + Handling of EIND and indirect jumps on devices with more than
            128 KiB of program memory.
          + Handling of the RAMPD, RAMPX, RAMPY and RAMPZ special function
            registers.
          + Function attributes OS_main and OS_task.
          + AVR-specific built-in macros.

  C6X

     * Support has been added for the Texas Instruments C6X family of
       processors.

  CR16

     * Support has been added for National Semiconductor's CR16
       architecture.

  Epiphany

     * Support has been added for Adapteva's Epiphany architecture.

  IA-32/x86-64

     * Support for Intel AVX2 intrinsics, built-in functions and code
       generation is available via -mavx2.
     * Support for Intel BMI2 intrinsics, built-in functions and code
       generation is available via -mbmi2.
     * Implementation and automatic generation of __builtin_clz* using the
       lzcnt instruction is available via -mlzcnt.
     * Support for Intel FMA3 intrinsics and code generation is available
       via -mfma.
     * A new -mfsgsbase command-line option is available that makes GCC
       generate new segment register read/write instructions through
       dedicated built-ins.
     * Support for the new Intel rdrnd instruction is available via
       -mrdrnd.
     * Two additional AVX vector conversion instructions are available via
       -mf16c.
     * Support for new Intel processor codename IvyBridge with RDRND,
       FSGSBASE and F16C is available through -march=core-avx-i.
     * Support for the new Intel processor codename Haswell with AVX2,
       FMA, BMI, BMI2, LZCNT is available through -march=core-avx2.
     * Support for new AMD family 15h processors (Piledriver core) is now
       available through -march=bdver2 and -mtune=bdver2 options.
     * Support for [40]the x32 psABI is now available through the -mx32
       option.
     * Windows mingw targets are using the -mms-bitfields option by
       default.
     * Windows x86 targets are using the __thiscall calling convention for
       C++ class-member functions.
     * Support for the configure option --with-threads=posix for Windows
       mingw targets.

  MIPS

     * GCC now supports thread-local storage (TLS) for MIPS16. This
       requires GNU binutils 2.22 or later.
     * GCC can now generate code specifically for the Cavium Octeon+ and
       Octeon2 processors. The associated command-line options are
       -march=octeon+ and -march=octeon2 respectively. Both options
       require GNU binutils 2.22 or later.
     * GCC can now work around certain 24k errata, under the control of
       the command-line option -mfix-24k. These workarounds require GNU
       binutils 2.20 or later.
     * 32-bit MIPS GNU/Linux targets such as mips-linux-gnu can now build
       n32 and n64 multilibs. The result is effectively a 64-bit GNU/Linux
       toolchain that generates 32-bit code by default. Use the
       configure-time option --enable-targets=all to select these extra
       multilibs.
     * Passing -fno-delayed-branch now also stops the assembler from
       automatically filling delay slots.

  PowerPC/PowerPC64

     * Vectors of type vector long long or vector long are passed and
       returned using the same method as other vectors with the VSX
       instruction set. Previously GCC did not adhere to the ABI for
       128-bit vectors with 64-bit integer base types (PR 48857). This
       will also be fixed in the GCC 4.6.1 and 4.5.4 releases.
     * A new option -mno-pointers-to-nested-functions was added to allow
       AIX 32-bit/64-bit and GNU/Linux 64-bit PowerPC users to specify
       that the compiler should not load up the chain register (r11)
       before calling a function through a pointer. If you use this
       option, you cannot call nested functions through a pointer, or call
       other languages that might use the static chain.
     * A new option msave-toc-indirect was added to allow AIX
       32-bit/64-bit and GNU/Linux 64-bit PowerPC users control whether we
       save the TOC in the prologue for indirect calls or generate the
       save inline. This can speed up some programs that call through a
       function pointer a lot, but it can slow down other functions that
       only call through a function pointer in exceptional cases.
     * The PowerPC port will now enable machine-specific built-in
       functions when the user switches the target machine using the
       #pragma GCC target or __attribute__ ((__target__ ("target"))) code
       sequences. In addition, the target macros are updated. However, due
       to the way the -save-temps switch is implemented, you won't see the
       effect of these additional macros being defined in preprocessor
       output.

  SH

     * A new option -msoft-atomic has been added. When it is specified,
       GCC will generate GNU/Linux-compatible gUSA atomic sequences for
       the new __atomic routines.
     * Since it is neither supported by GAS nor officially documented,
       code generation for little endian SH2A has been disabled.
       Specifying -ml with -m2a* will now result in a compiler error.
     * The defunct -mbranch-cost option has been fixed.
     * Some improvements to the generated code of:
          + Utilization of the tst #imm,R0 instruction.
          + Dynamic shift instructions on SH2A.
          + Integer absolute value calculations.
     * The -mdiv= option for targets other than SHmedia has been fixed and
       documented.

  SPARC

     * The option -mflat has been reinstated. When it is specified, the
       compiler will generate code for a single register window model.
       This is essentially a new implementation and the corresponding
       debugger support has been added to GDB 7.4.
     * Support for the options -mtune=native and -mcpu=native has been
       added on selected native platforms (GNU/Linux and Solaris).
     * Support for the SPARC T3 (Niagara 3) processor has been added.
     * VIS:
          + An intrinsics header visintrin.h has been added.
          + Builtin intrinsics for the VIS 1.0 edge handling and pixel
            compare instructions have been added.
          + The little-endian version of alignaddr is now supported.
          + When possible, VIS builtins are marked const, which should
            increase the compiler's ability to optimize VIS operations.
          + The compiler now properly tracks the %gsr register and how it
            behaves as an input for various VIS instructions.
          + Akin to fzero, the compiler can now generate fone instructions
            in order to set all of the bits of a floating-point register
            to 1.
          + The documentation for the VIS intrinsics in the GCC manual has
            been brought up to date and many inaccuracies were fixed.
          + Intrinsics for the VIS 2.0 bmask, bshuffle, and
            non-condition-code setting edge instructions have been added.
            Their availability is controlled by the new -mvis2 and
            -mno-vis2 options. They are enabled by default on
            UltraSPARC-III and later CPUs.
     * Support for UltraSPARC Fused Multiply-Add floating-point extensions
       has been added. These instructions are enabled by default on SPARC
       T3 (Niagara 3) and later CPUs.

  TILE-Gx/TILEPro

     * Support has been added for the Tilera TILE-Gx and TILEPro families
       of processors.

Other significant improvements

     * A new option (-grecord-gcc-switches) was added that appends
       compiler command-line options that might affect code generation to
       the DW_AT_producer attribute string in the DWARF debugging
       information.
     * GCC now supports various new GNU extensions to the DWARF debugging
       information format, like [41]entry value and [42]call site
       information, [43]typed DWARF stack or [44]a more compact macro
       representation. Support for these extensions has been added to GDB
       7.4. They can be disabled through the -gstrict-dwarf command-line
       option.

GCC 4.7.1

   This is the [45]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.7.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

   The Go frontend in the 4.7.1 release fully supports the [46]Go 1
   language standard.

GCC 4.7.2

   This is the [47]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.7.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 4.7.3

   This is the [48]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.7.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 4.7.4

   This is the [49]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.7.4 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).


    For questions related to the use of GCC, please consult these web
    pages and the [50]GCC manuals. If that fails, the
    [51]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [52]gcc@gcc.gnu.org. All of [53]our lists have public
    archives.

   Copyright (C) [54]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [55]maintained by the GCC team. Last modified
   2017-03-03[56].

References

   1. https://gcc.gnu.org/ml/gcc-patches/2011-03/msg01263.html
   2. http://savannah.nongnu.org/bugs/?35407
   3. https://gcc.gnu.org/PR18145
   4. https://gcc.gnu.org/gcc-4.7/porting_to.html
   5. http://www.openmp.org/specifications/
   6. https://gcc.gnu.org/wiki/TransactionalMemory
   7. https://gcc.gnu.org/wiki/Atomic/GCCMM
   8. http://gcc.gnu.org/gcc-4.7/cxx0x_status.html
   9. http://gcc.gnu.org/gcc-4.7/cxx0x_status.html
  10. http://gcc.gnu.org/gcc-4.7/cxx0x_status.html
  11. http://gcc.gnu.org/gcc-4.7/cxx0x_status.html
  12. http://gcc.gnu.org/gcc-4.7/cxx0x_status.html
  13. http://gcc.gnu.org/gcc-4.7/cxx0x_status.html
  14. https://gcc.gnu.org/PR14258
  15. https://gcc.gnu.org/PR35688
  16. https://gcc.gnu.org/onlinedocs/gcc-4.7.4/libstdc++/manual/manual/status.html#status.iso.2011
  17. https://gcc.gnu.org/onlinedocs/gcc-4.7.1/gfortran/Code-Gen-Options.html#index-g_t_0040code_007bfstack-arrays_007d-254
  18. https://gcc.gnu.org/onlinedocs/gcc-4.7.1/gcc/Optimize-Options.html#index-Ofast-689
  19. https://gcc.gnu.org/onlinedocs/gcc-4.7.1/gfortran/Code-Gen-Options.html#index-g_t_0040code_007bfno-protect-parens_007d-270
  20. https://gcc.gnu.org/onlinedocs/gcc-4.7.1/gfortran/Code-Gen-Options.html#index-g_t_0040code_007bfstack-arrays_007d-254
  21. https://gcc.gnu.org/onlinedocs/gcc-4.7.1/gfortran/Code-Gen-Options.html#index-g_t_0040code_007bfrontend-optimize_007d-275
  22. https://gcc.gnu.org/onlinedocs/gcc-4.7.1/gfortran/Error-and-Warning-Options.html#index-g_t_0040code_007bWfunction-elimination_007d-170
  23. https://gcc.gnu.org/onlinedocs/gcc-4.7.1/gfortran/Code-Gen-Options.html#index-g_t_0040code_007bfaggressive-function-elimination_007d-270
  24. https://gcc.gnu.org/onlinedocs/gcc-4.7.1/gfortran/Error-and-Warning-Options.html#index-g_t_0040code_007bWreal-q-constant_007d-149
  25. https://gcc.gnu.org/onlinedocs/gcc-4.7.1/gfortran/SELECTED_005fREAL_005fKIND.html
  26. https://msdn.microsoft.com/en-us/library/bb787181%28v=vs.85%29.aspx
  27. https://gcc.gnu.org/onlinedocs/gcc-4.7.1/gfortran/Debugging-Options.html#index-g_t_0040code_007bfno-backtrace_007d-183
  28. https://gcc.gnu.org/wiki/Fortran2003Status
  29. https://gcc.gnu.org/wiki/OOP
  30. https://gcc.gnu.org/wiki/Fortran2008Status
  31. https://gcc.gnu.org/wiki/Coarray
  32. https://gcc.gnu.org/wiki/CoarrayLib
  33. https://gcc.gnu.org/wiki/TS29113Status
  34. https://gcc.gnu.org/onlinedocs/gcc-4.7.1/gfortran/Fortran-Dialect-Options.html#index-g_t_0040code_007bstd_003d_007d_0040var_007bstd_007d-option-53
  35. https://golang.org/doc/go1
  36. https://gcc.gnu.org/onlinedocs/gcc-4.7.1/gcc/Named-Address-Spaces.html
  37. http://nongnu.org/avr-libc/
  38. https://gcc.gnu.org/PR54461
  39. https://gcc.gnu.org/onlinedocs/gcc-4.7.1/gcc/AVR-Built%5f002din-Functions.html
  40. https://sites.google.com/site/x32abi/
  41. http://www.dwarfstd.org/ShowIssue.php?issue=100909.1
  42. http://www.dwarfstd.org/ShowIssue.php?issue=100909.2
  43. http://www.dwarfstd.org/ShowIssue.php?issue=140425.1
  44. http://www.dwarfstd.org/ShowIssue.php?issue=110722.1
  45. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.7.1
  46. https://golang.org/doc/go1
  47. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.7.2
  48. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.7.3
  49. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.7.4
  50. https://gcc.gnu.org/onlinedocs/
  51. mailto:gcc-help@gcc.gnu.org
  52. mailto:gcc@gcc.gnu.org
  53. https://gcc.gnu.org/lists.html
  54. http://www.fsf.org/
  55. https://gcc.gnu.org/about.html
  56. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-4.6/index.html

                             GCC 4.6 Release Series

   April 12, 2013

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 4.6.4.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 4.6.3 relative to previous releases of GCC.

   This release series is no longer maintained.

Release History

   GCC 4.6.4
          April 12, 2013 ([2]changes, [3]documentation)

   GCC 4.6.3
          March 1, 2012 ([4]changes, [5]documentation)

   GCC 4.6.2
          October 26, 2011 ([6]changes, [7]documentation)

   GCC 4.6.1
          June 27, 2011 ([8]changes, [9]documentation)

   GCC 4.6.0
          March 25, 2011 ([10]changes, [11]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [12]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [13]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [14]GCC
   project web site or contact the [15]GCC development mailing list.

   To obtain GCC please use [16]our mirror sites or [17]our SVN server.


    For questions related to the use of GCC, please consult these web
    pages and the [18]GCC manuals. If that fails, the
    [19]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [20]gcc@gcc.gnu.org. All of [21]our lists have public
    archives.

   Copyright (C) [22]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [23]maintained by the GCC team. Last modified
   2016-09-30[24].

References

   1. http://www.gnu.org/
   2. http://gcc.gnu.org/gcc-4.6/changes.html
   3. https://gcc.gnu.org/onlinedocs/4.6.4/
   4. http://gcc.gnu.org/gcc-4.6/changes.html
   5. https://gcc.gnu.org/onlinedocs/4.6.3/
   6. http://gcc.gnu.org/gcc-4.6/changes.html
   7. https://gcc.gnu.org/onlinedocs/4.6.2/
   8. http://gcc.gnu.org/gcc-4.6/changes.html
   9. https://gcc.gnu.org/onlinedocs/4.6.1/
  10. http://gcc.gnu.org/gcc-4.6/changes.html
  11. https://gcc.gnu.org/onlinedocs/4.6.0/
  12. http://gcc.gnu.org/gcc-4.6/buildstat.html
  13. https://gcc.gnu.org/onlinedocs/gcc/Contributors.html
  14. http://gcc.gnu.org/index.html
  15. mailto:gcc@gcc.gnu.org
  16. http://gcc.gnu.org/mirrors.html
  17. http://gcc.gnu.org/svn.html
  18. https://gcc.gnu.org/onlinedocs/
  19. mailto:gcc-help@gcc.gnu.org
  20. mailto:gcc@gcc.gnu.org
  21. https://gcc.gnu.org/lists.html
  22. http://www.fsf.org/
  23. https://gcc.gnu.org/about.html
  24. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-4.6/changes.html

                             GCC 4.6 Release Series
                        Changes, New Features, and Fixes

Caveats

     * The options -b <machine> and -V <version> have been removed because
       they were unreliable. Instead, users should directly run
       <machine>-gcc when cross-compiling, or <machine>-gcc-<version> to
       run a different version of gcc.
     * GCC now has stricter checks for invalid command-line options. In
       particular, when gcc was called to link object files rather than
       compile source code, it would previously accept and ignore all
       options starting with --, including linker options such as
       --as-needed and --export-dynamic, although such options would
       result in errors if any source code was compiled. Such options, if
       unknown to the compiler, are now rejected in all cases; if the
       intent was to pass them to the linker, options such as
       -Wl,--as-needed should be used.
     * Versions of the GNU C library up to and including 2.11.1 included
       an [1]incorrect implementation of the cproj function. GCC optimizes
       its builtin cproj according to the behavior specified and allowed
       by the ISO C99 standard. If you want to avoid discrepancies between
       the C library and GCC's builtin transformations when using cproj in
       your code, use GLIBC 2.12 or later. If you are using an older GLIBC
       and actually rely on the incorrect behavior of cproj, then you can
       disable GCC's transformations using -fno-builtin-cproj.
     * The C-only intermodule optimization framework (IMA, enabled by
       -combine) has been removed in favor of the new generic link-time
       optimization framework (LTO) introduced in [2]GCC 4.5.0.
     * GCC now ships with the LGPL-licensed libquadmath library, which
       provides quad-precision mathematical functions for targets with a
       __float128 datatype. __float128 is available for targets on 32-bit
       x86, x86-64 and Itanium architectures. The libquadmath library is
       automatically built on such targets when building the Fortran
       compiler.
     * New -Wunused-but-set-variable and -Wunused-but-set-parameter
       warnings were added for C, C++, Objective-C and Objective-C++.
       These warnings diagnose variables respective parameters which are
       only set in the code and never otherwise used. Usually such
       variables are useless and often even the value assigned to them is
       computed needlessly, sometimes expensively. The
       -Wunused-but-set-variable warning is enabled by default by -Wall
       flag and -Wunused-but-set-parameter by -Wall -Wextra flags.
     * On ARM, a bug has been fixed in GCC's implementation of the AAPCS
       rules for the layout of vectors that could lead to wrong code being
       generated. Vectors larger than 8 bytes in size are now by default
       aligned to an 8-byte boundary. This is an ABI change: code that
       makes explicit use of vector types may be incompatible with binary
       objects built with older versions of GCC. Auto-vectorized code is
       not affected by this change. (This change affects GCC versions
       4.6.4 and later, with the exception of versions 4.7.0 and 4.7.1.)
     * On AVR, variables with the progmem attribute to locate data in
       flash memory must be qualified as const.
     * Support for a number of older systems and recently unmaintained or
       untested target ports of GCC has been declared obsolete in GCC 4.6.
       Unless there is activity to revive them, the next release of GCC
       will have their sources permanently removed.
       All GCC ports for the following processor architectures have been
       declared obsolete:
          + Argonaut ARC (arc-*)
          + National Semiconductor CRX (crx-*)
          + Motorola 68HC11 and 68HC12 (m68hc11-*-*, m6811-*-*,
            m68hc12-*-*, m6812-*-*)
          + Sunplus S+core (score-*)
       The following ports for individual systems on particular
       architectures have been obsoleted:
          + Interix (i[34567]86-*-interix3*)
          + NetWare x86 (i[3456x]86-*-netware*)
          + Generic ARM PE (arm-*-pe* other than arm*-wince-pe*)
          + MCore PE (mcore-*-pe*)
          + SH SymbianOS (sh*-*-symbianelf*)
          + GNU Hurd on Alpha and PowerPC (alpha*-*-gnu*, powerpc*-*-gnu*)
          + M68K uClinux old ABI (m68k-*-uclinuxoldabi*)
          + a.out NetBSD (arm*-*-netbsd*, i[34567]86-*-netbsd*,
            vax-*-netbsd*, but not *-*-netbsdelf*)
       The i[34567]86-*-pe alias for Cygwin targets has also been
       obsoleted; users should configure for i[34567]86-*-cygwin* instead.
       Certain configure options to control the set of libraries built
       with GCC on some targets have been obsoleted. On ARM targets, the
       options --disable-fpu, --disable-26bit, --disable-underscore,
       --disable-interwork, --disable-biendian and --disable-nofmult have
       been obsoleted. On MIPS targets, the options
       --disable-single-float, --disable-biendian and --disable-softfloat
       have been obsoleted.
     * Support has been removed for all the [3]configurations obsoleted in
       GCC 4.5.
     * More information on porting to GCC 4.6 from previous versions of
       GCC can be found in the [4]porting guide for this release.

General Optimizer Improvements

     * A new general optimization level, -Ofast, has been introduced. It
       combines the existing optimization level -O3 with options that can
       affect standards compliance but result in better optimized code.
       For example, -Ofast enables -ffast-math.
     * Link-time optimization improvements:
          + The [5]Scalable Whole Program Optimizer (WHOPR) project has
            stabilized to the point of being usable. It has become the
            default mode when using the LTO optimization model. Link time
            optimization can now split itself into multiple parallel
            compilations. Parallelism is controlled with -flto=n (where n
            specifies the number of compilations to execute in parallel).
            GCC can also cooperate with a GNU make job server by
            specifying the -flto=jobserver option and adding + to the
            beginning of the Makefile rule executing the linker.
            Classical LTO mode can be enforced by -flto-partition=none.
            This may result in small code quality improvements.
          + A large number of bugs were fixed. GCC itself, Mozilla Firefox
            and other large applications can be built with LTO enabled.
          + The linker plugin support improvements
               o Linker plugin is now enabled by default when the linker
                 is detected to have plugin support. This is the case for
                 GNU ld 2.21.51 or newer (on ELF and Cygwin targets) and
                 the Gold linker on ELF targets. Plugin support of the
                 Apple linker on Darwin is not compatible with GCC. The
                 linker plugin can also be controlled by the
                 -fuse-linker-plugin command-line option.
               o Resolution information from the linker plugin is used to
                 drive whole program assumptions. Use of the linker plugin
                 results in more aggressive optimization on binaries and
                 on shared libraries that use the hidden visibility
                 attribute. Consequently the use of -fwhole-program is not
                 necessary in addition to LTO.
          + Hidden symbols used from non-LTO objects now have to be
            explicitly annotated with externally_visible when the linker
            plugin is not used.
          + C++ inline functions and virtual tables are now privatized
            more aggressively, leading to better inter-procedural
            optimization and faster dynamic linking.
          + Memory usage and intermediate language streaming performance
            have been improved.
          + Static constructors and destructors from individual units are
            inlined into a single function. This can significantly improve
            startup times of large C++ applications where static
            constructors are very common. For example, static constructors
            are used when including the iostream header.
          + Support for the Ada language has been added.
     * Interprocedural optimization improvements
          + The interprocedural framework was re-tuned for link time
            optimization. Several scalability issues were resolved.
          + Improved auto-detection of const and pure functions. Newly,
            noreturn functions are auto-detected.
            The [6]-Wsuggest-attribute=[const|pure|noreturn] flag is
            available that informs users when adding attributes to headers
            might improve code generation.
          + A number of inlining heuristic improvements. In particular:
               o Partial inlining is now supported and enabled by default
                 at -O2 and greater. The feature can be controlled via
                 -fpartial-inlining.
                 Partial inlining splits functions with short hot path to
                 return. This allows more aggressive inlining of the hot
                 path leading to better performance and often to code size
                 reductions (because cold parts of functions are not
                 duplicated).
               o Scalability for large compilation units was improved
                 significantly.
               o Inlining of callbacks is now more aggressive.
               o Virtual methods are considered for inlining when the
                 caller is inlined and devirtualization is then possible.
               o Inlining when optimizing for size (either in cold regions
                 of a program or when compiling with -Os) was improved to
                 better handle C++ programs with larger abstraction
                 penalty, leading to smaller and faster code.
          + The IPA reference optimization pass detecting global variables
            used or modified by functions was strengthened and sped up.
          + Functions whose address was taken are now optimized out when
            all references to them are dead.
          + A new inter-procedural static profile estimation pass detects
            functions that are executed once or unlikely to be executed.
            Unlikely executed functions are optimized for size. Functions
            executed once are optimized for size except for the inner
            loops.
          + On most targets with named section support, functions used
            only at startup (static constructors and main), functions used
            only at exit and functions detected to be cold are placed into
            separate text segment subsections. This extends the
            -freorder-functions feature and is controlled by the same
            switch. The goal is to improve the startup time of large C++
            programs.
            Proper function placement requires linker support. GNU ld
            2.21.51 on ELF targets was updated to place those functions
            together within the text section leading to better code
            locality and faster startup times of large C++ programs. The
            feature is also supported in the Apple linker. Support in the
            gold linker is planned.
     * A new switch -fstack-usage has been added. It makes the compiler
       output stack usage information for the program, on a per-function
       basis, in an auxiliary file.
     * A new switch -fcombine-stack-adjustments has been added. It can be
       used to enable or disable the compiler's stack-slot combining pass
       which before was enabled automatically at -O1 and above, but could
       not be controlled on its own.
     * A new switch -fstrict-volatile-bitfields has been added. Using it
       indicates that accesses to volatile bitfields should use a single
       access of the width of the field's type. This option can be useful
       for precisely defining and accessing memory-mapped peripheral
       registers from C or C++.

Compile time and memory usage improvements

     * Datastructures used by the dataflow framework in GCC were
       reorganized for better memory usage and more cache locality.
       Compile time is improved especially on units with large functions
       (possibly resulting from a lot of inlining) not fitting into the
       processor cache. The compile time of the GCC C compiler binary with
       link-time optimization went down by over 10% (benchmarked on x86-64
       target).

New Languages and Language specific improvements

  Ada

     * Stack checking has been improved on selected architectures (Alpha,
       IA-32/x86-64, RS/6000 and SPARC): it now will detect stack
       overflows in all cases on these architectures.
     * Initial support for Ada 2012 has been added.

  C family

     * A new warning, enabled by -Wdouble-promotion, has been added that
       warns about cases where a value of type float is implicitly
       promoted to double. This is especially helpful for CPUs that handle
       the former in hardware, but emulate the latter in software.
     * A new function attribute leaf was introduced. This attribute allows
       better inter-procedural optimization across calls to functions that
       return to the current unit only via returning or exception
       handling. This is the case for most library functions that have no
       callbacks.
     * Support for a new data type __int128 for targets having wide enough
       machine-mode support.
     * The new function attribute callee_pop_aggregate allows to specify
       if the caller or callee is responsible for popping the aggregate
       return pointer value from the stack.
     * Support for selectively enabling and disabling warnings via #pragma
       GCC diagnostic has been added. For instance:
#pragma GCC diagnostic error "-Wuninitialized"
  foo(a);                       /* error is given for this one */
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wuninitialized"
  foo(b);                       /* no diagnostic for this one */
#pragma GCC diagnostic pop
  foo(c);                       /* error is given for this one */
#pragma GCC diagnostic pop
  foo(d);                       /* depends on command-line options */

     * The -fmax-errors=N option is now supported. Using this option
       causes the compiler to exit after N errors have been issued.

  C

     * There is now experimental support for some features from the
       upcoming C1X revision of the ISO C standard. This support may be
       selected with -std=c1x, or -std=gnu1x for C1X with GNU extensions.
       Note that this support is experimental and may change incompatibly
       in future releases for consistency with changes to the C1X standard
       draft. The following features are newly supported as described in
       the N1539 draft of C1X (with changes agreed at the March 2011 WG14
       meeting); some other features were already supported with no
       compiler changes being needed, or have some support but not in full
       accord with N1539 (as amended).
          + Static assertions (_Static_assert keyword)
          + Typedef redefinition
          + New macros in <float.h>
          + Anonymous structures and unions
     * The new -fplan9-extensions option directs the compiler to support
       some extensions for anonymous struct fields which are implemented
       by the Plan 9 compiler. A pointer to a struct may be automatically
       converted to a pointer to an anonymous field when calling a
       function, in order to make the types match. An anonymous struct
       field whose type is a typedef name may be referred to using the
       typedef name.

  C++

     * Improved [7]experimental support for the upcoming C++0x ISO C++
       standard, including support for constexpr (thanks to Gabriel Dos
       Reis and Jason Merrill), nullptr (thanks to Magnus Fromreide),
       noexcept, unrestricted unions, range-based for loops (thanks to
       Rodrigo Rivas Costa), opaque enum declarations (thanks also to
       Rodrigo), implicitly deleted functions and implicit move
       constructors.
     * When an extern declaration within a function does not match a
       declaration in the enclosing context, G++ now properly declares the
       name within the namespace of the function rather than the namespace
       which was open just before the function definition ([8]c++/43145).
     * GCC now warns by default when casting integers to larger pointer
       types. These warnings can be disabled with the option
       -Wno-int-to-pointer-cast, which is now also available in C++.
     * G++ no longer optimizes using the assumption that a value of
       enumeration type will fall within the range specified by the
       standard, since that assumption is easily violated with a
       conversion from integer type ([9]c++/43680). The old behavior can
       be restored with -fstrict-enums.
     * The new -fnothrow-opt flag changes the semantics of a throw()
       exception specification to match the proposed semantics of the
       noexcept specification: just call terminate if an exception tries
       to propagate out of a function with such an exception
       specification. This dramatically reduces or eliminates the code
       size overhead from adding the exception specification.
     * The new -Wnoexcept flag will suggest adding a noexcept qualifier to
       a function that the compiler can tell doesn't throw if it would
       change the value of a noexcept expression.
     * The -Wshadow option now warns if a local variable or type
       declaration shadows another type in C++. Note that the compiler
       will not warn if a local variable shadows a struct/class/enum, but
       will warn if it shadows an explicit typedef.
     * When an identifier is not found in the current scope, G++ now
       offers suggestions about which identifier might have been intended.
     * G++ now issues clearer diagnostics for missing semicolons after
       class, struct, and union definitions.
     * G++ now issues clearer diagnostics for missing semicolons after
       class member declarations.
     * G++ now issues clearer diagnostics when a colon is used in a place
       where a double-colon was intended.
     * G++ no longer accepts mutable on reference members ([10]c++/33558).
       Use -fpermissive to allow the old, non-conforming behaviour.
     * A few mangling fixes have been made, to attribute const/volatile on
       function pointer types, decltype of a plain decl, and use of a
       function parameter in the declaration of another parameter. By
       default the compiler still uses the old mangling, but emits aliases
       with the new mangling on targets that support strong aliases. Users
       can switch over entirely to the new mangling with -fabi-version=5
       or -fabi-version=0. -Wabi will now warn about code that uses the
       old mangling.
     * In 4.6.0 and 4.6.1 G++ no longer allows objects of const-qualified
       type to be default initialized unless the type has a user-declared
       default constructor. In 4.6.2 G++ implements the proposed
       resolution of [11]DR 253, so default initialization is allowed if
       it initializes all subobjects. Code that fails to compile can be
       fixed by providing an initializer e.g.
    struct A { A(); };
    struct B : A { int i; };
    const B b = B();
       Use -fpermissive to allow the old, non-conforming behaviour.

    Runtime Library (libstdc++)

     * [12]Improved experimental support for the upcoming ISO C++
       standard, C++0x, including using constexpr and nullptr.
     * Performance improvements to the [13]Debug Mode, thanks to Franc,ois
       Dumont.
     * Atomic operations used for reference-counting are annotated so that
       they can be understood by race detectors such as Helgrind, see
       [14]Data Race Hunting.
     * Most libstdc++ standard headers have been changed to no longer
       include the cstddef header as an implementation detail. Code that
       relied on that header being included as side-effect of including
       other standard headers will need to include cstddef explicitly.

  Fortran

     * On systems supporting the libquadmath library, GNU Fortran now also
       supports a quad-precision, kind=16 floating-point data type
       (REAL(16), COMPLEX(16)). As the data type is not fully supported in
       hardware, calculations might be one to two orders of magnitude
       slower than with the 4, 8 or 10 bytes floating-point data types.
       This change does not affect systems which support REAL(16) in
       hardware nor those which do not support libquadmath.
     * Much improved compile time for large array constructors.
     * In order to reduce execution time and memory consumption, use of
       temporary arrays in assignment expressions is avoided for many
       cases. The compiler now reverses loops in order to avoid generating
       a temporary array where possible.
     * Improved diagnostics, especially with -fwhole-file.
     * The -fwhole-file flag is now enabled by default. This improves code
       generation and diagnostics. It can be disabled using the deprecated
       -fno-whole-file flag.
     * Support the generation of Makefile dependencies via the [15]-M...
       flags of GCC; you may need to specify the -cpp option in addition.
       The dependencies take modules, Fortran's include, and CPP's
       #include into account. Note: Using -M for the module path is no
       longer supported, use -J instead.
     * The flag -Wconversion has been modified to only issue warnings
       where a conversion leads to information loss. This drastically
       reduces the number of warnings; -Wconversion is thus now enabled
       with -Wall. The flag -Wconversion-extra has been added and also
       warns about other conversions; -Wconversion-extra typically issues
       a huge number of warnings, most of which can be ignored.
     * A new command-line option -Wunused-dummy-argument warns about
       unused dummy arguments and is included in -Wall. Before,
       -Wunused-variable also warned about unused dummy arguments.
     * Fortran 2003 support has been extended:
          + Improved support for polymorphism between libraries and
            programs and for complicated inheritance patterns (cf.
            [16]object-oriented programming).
          + Experimental support of the ASSOCIATE construct.
          + In pointer assignments it is now possible to specify the lower
            bounds of the pointer and, for a rank-1 or a simply contiguous
            data-target, to remap the bounds.
          + Automatic (re)allocation: In intrinsic assignments to
            allocatable variables the left-hand side will be automatically
            allocated (if unallocated) or reallocated (if the shape or
            type parameter is different). To avoid the small performance
            penalty, you can use a(:) = ... instead of a = ... for arrays
            and character strings - or disable the feature using -std=f95
            or -fno-realloc-lhs.
          + Deferred type parameter: For scalar allocatable and pointer
            variables the character length can be deferred.
          + Namelist variables with allocatable and pointer attribute and
            nonconstant length type parameter are supported.
     * Fortran 2008 support has been extended:
          + Experimental [17]coarray support (for one image only, i.e.
            num_images() == 1); use the [18]-fcoarray=single flag to
            enable it.
          + The STOP and the new ERROR STOP statements now support all
            constant expressions.
          + Support for the CONTIGUOUS attribute.
          + Support for ALLOCATE with MOLD.
          + Support for the STORAGE_SIZE intrinsic inquiry function.
          + Support of the NORM2 and PARITY intrinsic functions.
          + The following bit intrinsics were added: POPCNT and POPPAR for
            counting the number of 1 bits and returning the parity; BGE,
            BGT, BLE, and BLT for bitwise comparisons; DSHIFTL and DSHIFTR
            for combined left and right shifts, MASKL and MASKR for simple
            left and right justified masks, MERGE_BITS for a bitwise merge
            using a mask, SHIFTA, SHIFTL and SHIFTR for shift operations,
            and the transformational bit intrinsics IALL, IANY and
            IPARITY.
          + Support of the EXECUTE_COMMAND_LINE intrinsic subroutine.
          + Support for the IMPURE attribute for procedures, which allows
            for ELEMENTAL procedures without the restrictions of PURE.
          + Null pointers (including NULL()) and not allocated variables
            can be used as actual argument to optional non-pointer,
            non-allocatable dummy arguments, denoting an absent argument.
          + Non-pointer variables with TARGET attribute can be used as
            actual argument to POINTER dummies with INTENT(IN)
          + Pointers including procedure pointers and those in a derived
            type (pointer components) can now be initialized by a target
            instead of only by NULL.
          + The EXIT statement (with construct-name) can now be used to
            leave not only the DO but also the ASSOCIATE, BLOCK, IF,
            SELECT CASE and SELECT TYPE constructs.
          + Internal procedures can now be used as actual argument.
          + The named constants INTEGER_KINDS, LOGICAL_KINDS, REAL_KINDS
            and CHARACTER_KINDS of the intrinsic module ISO_FORTRAN_ENV
            have been added; these arrays contain the supported kind
            values for the respective types.
          + The module procedures C_SIZEOF of the intrinsic module
            ISO_C_BINDINGS and COMPILER_VERSION and COMPILER_OPTIONS of
            ISO_FORTRAN_ENV have been implemented.
          + Minor changes: obsolescence diagnostics for ENTRY was added
            for -std=f2008; a line may start with a semicolon; for
            internal and module procedures END can be used instead of END
            SUBROUTINE and END FUNCTION; SELECTED_REAL_KIND now also takes
            a RADIX argument; intrinsic types are supported for
            TYPE(intrinsic-type-spec); multiple type-bound procedures can
            be declared in a single PROCEDURE statement; implied-shape
            arrays are supported for named constants (PARAMETER). The
            transformational, three argument versions of BESSEL_JN and
            BESSEL_YN were added - the elemental, two-argument version had
            been added in GCC 4.4; note that the transformational
            functions use a recurrence algorithm.

  Go

   Support for the [19]Go programming language has been added to GCC. It
   is not enabled by default when you build GCC; use the
   --enable-languages configure option to build it. The driver program for
   compiling Go code is gccgo.

   Go is currently known to work on GNU/Linux and RTEMS. Solaris support
   is in progress. It may or may not work on other platforms.

  Objective-C and Objective-C++

     * The -fobjc-exceptions flag is now required to enable Objective-C
       exception and synchronization syntax (introduced by the keywords
       @try, @catch, @finally and @synchronized).
     * A number of Objective-C 2.0 features and extensions are now
       supported by GCC. These features are enabled by default; you can
       disable them by using the new -fobjc-std=objc1 command-line option.
     * The Objective-C 2.0 dot-syntax is now supported. It is an
       alternative syntax for using getters and setters; object.count is
       automatically converted into [object count] or [object setCount:
       ...] depending on context; for example if (object.count > 0) is
       automatically compiled into the equivalent of if ([object count] >
       0) while object.count = 0; is automatically compiled into the
       equivalent ot [object setCount: 0];. The dot-syntax can be used
       with instance and class objects and with any setters or getters, no
       matter if they are part of a declared property or not.
     * Objective-C 2.0 declared properties are now supported. They are
       declared using the new @property keyword, and are most commonly
       used in conjunction with the new Objective-C 2.0 dot-syntax. The
       nonatomic, readonly, readwrite, assign, retain, copy, setter and
       getter attributes are all supported. Marking declared properties
       with __attribute__ ((deprecated)) is supported too.
     * The Objective-C 2.0 @synthesize and @dynamic keywords are
       supported. @synthesize causes the compiler to automatically
       synthesize a declared property, while @dynamic is used to disable
       all warnings for a declared property for which no implementation is
       provided at compile time. Synthesizing declared properties requires
       runtime support in most useful cases; to be able to use it with the
       GNU runtime, appropriate helper functions have been added to the
       GNU Objective-C runtime ABI, and are implemented by the GNU
       Objective-C runtime library shipped with GCC.
     * The Objective-C 2.0 fast enumeration syntax is supported in
       Objective-C. This is currently not yet available in Objective-C++.
       Fast enumeration requires support in the runtime, and such support
       has been added to the GNU Objective-C runtime library (shipped with
       GCC).
     * The Objective-C 2.0 @optional keyword is supported. It allows you
       to mark methods or properties in a protocol as optional as opposed
       to required.
     * The Objective-C 2.0 @package keyword is supported. It has currently
       the same effect as the @public keyword.
     * Objective-C 2.0 method attributes are supported. Currently the
       supported attributes are deprecated, sentinel, noreturn and format.
     * Objective-C 2.0 method argument attributes are supported. The most
       widely used attribute is unused, to mark an argument as unused in
       the implementation.
     * Objective-C 2.0 class and protocol attributes are supported.
       Currently the only supported attribute is deprecated.
     * Objective-C 2.0 class extensions are supported. A class extension
       has the same syntax as a category declaration with no category
       name, and the methods and properties declared in it are added
       directly to the main class. It is mostly used as an alternative to
       a category to add methods to a class without advertising them in
       the public headers, with the advantage that for class extensions
       the compiler checks that all the privately declared methods are
       actually implemented.
     * As a result of these enhancements, GCC can now be used to build
       Objective-C and Objective-C++ software that uses Foundation and
       other important system frameworks with the NeXT runtime on Darwin 9
       and Darwin 10 (OSX 10.5 and 10.6).
     * Many bugs in the compiler have been fixed in this release; in
       particular, LTO can now be used when compiling Objective-C and
       Objective-C++ and the parser is much more robust in dealing with
       invalid code.

    Runtime Library (libobjc)

     * The GNU Objective-C runtime library now defines the macro
       __GNU_LIBOBJC__ (with a value that is increased at every release
       where there is any change to the API) in objc/objc.h, making it
       easy to determine if the GNU Objective-C runtime library is being
       used, and if so, which version. Previous versions of the GNU
       Objective-C runtime library (and other Objective-C runtime
       libraries such as the Apple one) do not define this macro.
     * A new Objective-C 2.0 API, almost identical to the one implemented
       by the Apple Objective-C runtime, has been implemented in the GNU
       Objective-C runtime library. The new API hides the internals of
       most runtime structures but provides a more extensive set of
       functions to operate on them. It is much easier, for example, to
       create or modify classes at runtime. The new API also makes it
       easier to port software from Apple to GNU as almost no changes
       should be required. The old API is still supported for backwards
       compatibility; including the old objc/objc-api.h header file
       automatically selects the old API, while including the new
       objc/runtime.h header file automatically selects the new API.
       Support for the old API is being phased out and upgrading the
       software to use the new API is strongly recommended. To check for
       the availability of the new API, the __GNU_LIBOBJC__ macro can be
       used as older versions of the GNU Objective-C runtime library,
       which do not support the new API, do not define such a macro.
     * Runtime support for @synchronized has been added.
     * Runtime support for Objective-C 2.0 synthesized property accessors
       has been added.
     * Runtime support for Objective-C 2.0 fast enumeration has been
       added.

New Targets and Target Specific Improvements

  ARM

     * GCC now supports the Cortex-M4 processor implementing the v7-em
       version of the architecture using the option -mcpu=cortex-m4.
     * Scheduling descriptions for the Cortex-M4, the Neon and the
       floating point units of the Cortex-A9 and a pipeline description
       for the Cortex-A5 have been added.
     * Synchronization primitives such as __sync_fetch_and_add and friends
       are now inlined for supported architectures rather than calling
       into a kernel helper function.
     * SSA loop prefetching is enabled by default for the Cortex-A9 at
       -O3.
     * Several improvements were committed to improve code generation for
       the ARM architecture including a rewritten implementation for load
       and store multiples.
     * Several enhancements were committed to improve SIMD code generation
       for NEON by adding support for widening instructions, misaligned
       loads and stores, vector conditionals and support for 64 bit
       arithmetic.
     * Support was added for the Faraday cores fa526, fa606te, fa626te,
       fmp626te, fmp626 and fa726te and can be used with the respective
       names as parameters to the -mcpu= option.
     * Basic support was added for Cortex-A15 and is available through
       -mcpu=cortex-a15.
     * GCC for AAPCS configurations now more closely adheres to the AAPCS
       specification by enabling -fstrict-volatile-bitfields by default.

  IA-32/x86-64

     * The new -fsplit-stack option permits programs to use a
       discontiguous stack. This is useful for threaded programs, in that
       it is no longer necessary to specify the maximum stack size when
       creating a thread. This feature is currently only implemented for
       32-bit and 64-bit x86 GNU/Linux targets.
     * Support for emitting profiler counter calls before function
       prologues. This is enabled via a new command-line option -mfentry.
     * Optimization for the Intel Core 2 processors is now available
       through the -march=core2 and -mtune=core2 options.
     * Support for Intel Core i3/i5/i7 processors is now available through
       the -march=corei7 and -mtune=corei7 options.
     * Support for Intel Core i3/i5/i7 processors with AVX is now
       available through the -march=corei7-avx and -mtune=corei7-avx
       options.
     * Support for AMD Bobcat (family 14) processors is now available
       through the -march=btver1 and -mtune=btver1 options.
     * Support for AMD Bulldozer (family 15) processors is now available
       through the -march=bdver1 and -mtune=bdver1 options.
     * The default setting (when not optimizing for size) for 32-bit
       GNU/Linux and Darwin x86 targets has been changed to
       -fomit-frame-pointer. The default can be reverted to
       -fno-omit-frame-pointer by configuring GCC with the
       --enable-frame-pointer configure option.
     * Darwin, FreeBSD, Solaris 2, MinGW and Cygwin now all support
       __float128 on 32-bit and 64-bit x86 targets.
     * AVX floating-point arithmetic can now be enabled by default at
       configure time with the new --with-fpmath=avx option.
     * The SSA loop prefetching pass is enabled when using -O3 when
       optimizing for CPUs where prefetching is beneficial (AMD CPUs newer
       than K6).
     * Support for TBM (Trailing Bit Manipulation) built-in functions and
       code generation is available via -mtbm.
     * Support for AMD's BMI (Bit Manipulation) built-in functions and
       code generation is available via -mbmi.

  MicroBlaze

     * Support has been added for the Xilinx MicroBlaze softcore processor
       (microblaze-elf) embedded target. This configurable processor is
       supported on several Xilinx Spartan and Virtex FPGAs.

  MIPS

     * GCC now supports the Loongson 3A processor. Its canonical -march=
       and -mtune= name is loongson3a.

  MN10300 / AM33

     * The inline assembly register constraint "A" has been renamed "c".
       This constraint is used to select a floating-point register that
       can be used as the destination of a multiply-accumulate
       instruction.
     * New inline assembly register constraints "A" and "D" have been
       added. These constraint letters resolve to all general registers
       when compiling for AM33, and resolve to address registers only or
       data registers only when compiling for MN10300.
     * The MDR register is represented in the compiler. One can access the
       register via the "z" constraint in inline assembly. It can be
       marked as clobbered or used as a local register variable via the
       "mdr" name. The compiler uses the RETF instruction if the function
       does not modify the MDR register, so it is important that inline
       assembly properly annotate any usage of the register.

  PowerPC/PowerPC64

     * GCC now supports the Applied Micro Titan processor with
       -mcpu=titan.
     * The -mrecip option has been added, which indicates whether the
       reciprocal and reciprocal square root instructions should be used.
     * The -mveclibabi=mass option can be used to enable the compiler to
       autovectorize mathematical functions using the Mathematical
       Acceleration Subsystem library.
     * The -msingle-pic-base option has been added, which instructs the
       compiler to avoid loading the PIC base register in function
       prologues. The PIC base register must be initialized by the runtime
       system.
     * The -mblock-move-inline-limit option has been added, which enables
       the user to control the maximum size of inlined memcpy calls and
       similar.
     * PowerPC64 GNU/Linux support for applications requiring a large TOC
       section has been improved. A new command-line option,
       -mcmodel=MODEL, controls this feature; valid values for MODEL are
       small, medium, or large.
     * The Altivec builtin functions vec_ld and vec_st have been modified
       to generate the Altivec memory instructions LVX and STVX, even if
       the -mvsx option is used. In the initial GCC 4.5 release, these
       builtin functions were changed to generate VSX memory reference
       instructions instead of Altivec memory instructions, but there are
       differences between the two instructions. If the VSX instruction
       set is available, you can now use the new builtin functions
       vec_vsx_ld and vec_vsx_st which always generates the VSX memory
       instructions.
     * The GCC compiler on AIX now defaults to a process layout with a
       larger data space allowing larger programs to be compiled.
     * The GCC long double type on AIX 6.1 and above has reverted to 64
       bit double precision, matching the AIX XL compiler default, because
       of missing C99 symbols required by the GCC runtime.
     * The default processor scheduling model and tuning for PowerPC64
       GNU/Linux and for AIX 6.1 and above now is POWER7.
     * Starting with GCC 4.6.1, vectors of type vector long long or vector
       long are passed and returned in the same method as other vectors
       with the VSX instruction set. Previously the GCC compiler did not
       adhere to the ABI for 128-bit vectors with 64-bit integer base
       types (PR 48857). This is also fixed in the GCC 4.5.4 release.

  S/390, zSeries and System z9/z10, IBM zEnterprise z196

     * Support for the zEnterprise z196 processor has been added. When
       using the -march=z196 option, the compiler will generate code
       making use of the following instruction facilities:
          + Conditional load/store
          + Distinct-operands
          + Floating-point-extension
          + Interlocked-access
          + Population-count
       The -mtune=z196 option avoids the compare and branch instructions
       as well as the load address instruction with an index register as
       much as possible and performs instruction scheduling appropriate
       for the new out-of-order pipeline architecture.
     * When using the -m31 -mzarch options the generated code still
       conforms to the 32-bit ABI but uses the general purpose registers
       as 64-bit registers internally. This requires a Linux kernel saving
       the whole 64-bit registers when doing a context switch. Kernels
       providing that feature indicate that by the 'highgprs' string in
       /proc/cpuinfo.
     * The SSA loop prefetching pass is enabled when using -O3.

  SPARC

     * GCC now supports the LEON series of SPARC V8 processors. The code
       generated by the compiler can either be tuned to it by means of the
       --with-tune=leon configure option and -mtune=leon compilation
       option, or the compiler can be built for the sparc-leon-{elf,linux}
       and sparc-leon3-{elf,linux} targets directly.
     * GCC has stopped sign/zero-extending parameter registers in the
       callee for functions taking parameters with sub-word size in 32-bit
       mode, since this is redundant with the specification of the ABI.
       GCC has never done so in 64-bit mode since this is also redundant.
     * The command-line option -mfix-at697f has been added to enable the
       documented workaround for the single erratum of the Atmel AT697F
       processor.

Operating Systems

  Android

     * GCC now supports the Bionic C library and provides a convenient way
       of building native libraries and applications for the Android
       platform. Refer to the documentation of the -mandroid and -mbionic
       options for details on building native code. At the moment, Android
       support is enabled only for ARM.

  Darwin/Mac OS X

     * General
          + Initial support for CFString types has been added.
            This allows GCC to build projects including the system Core
            Foundation frameworks. The GCC Objective-C family supports
            CFString "toll-free bridged" as per the Mac OS X system tools.
            CFString is also recognized in the context of format
            attributes and arguments (see the documentation for format
            attributes for limitations). At present, 8-bit character types
            are supported.
          + Object file size reduction.
            The Darwin zeroed memory allocators have been re-written to
            make more use of .zerofill sections. For non-debug code, this
            can reduce object file size significantly.
          + Objective-C family 64-bit support (NeXT ABI 2).
            Initial support has been added to support 64-bit Objective-C
            code using the Darwin/OS X native (NeXT) runtime. ABI version
            2 will be selected automatically when 64-bit code is built.
          + Objective-C family 32-bit ABI 1.
            For 32-bit code ABI 1 is also now also allowed. At present it
            must be selected manually using -fobjc-abi-version=1 where
            applicable - i.e. on Darwin 9/10 (OS X 10.5/10.6).
     * x86 Architecture
          + The -mdynamic-no-pic option has been enabled.
            Code supporting -mdynamic-no-pic optimization has been added
            and is applicable to -m32 builds. The compiler bootstrap uses
            the option where appropriate.
          + The default value for -mtune= has been changed.
            Since Darwin systems are primarily Xeon, Core-2 or similar the
            default tuning has been changed to -mtune=core2.
          + Enable 128-bit long double (__float128) support on Darwin.
     * PPC Architecture
          + Darwin64 ABI.
            Several significant bugs have been fixed, such that GCC now
            produces code compatible with the Darwin64 PowerPC ABI.
          + libffi and boehm-gc.
            The Darwin ports of the libffi and boehm-gc libraries have
            been upgraded to include a Darwin64 implementation. This means
            that powerpc*-*-darwin9 platforms may now, for example, build
            Java applications with -m64 enabled.
          + Plug-in support has been enabled.
          + The -fsection-anchors option is now available although,
            presently, not heavily tested.

  Solaris 2

    New Features

     * Support symbol versioning with the Sun linker.
     * Allow libstdc++ to leverage full ISO C99 support on Solaris 10+.
     * Support thread-local storage (TLS) with the Sun assembler on
       Solaris 2/x86.
     * Support TLS on Solaris 8/9 if prerequisites are met.
     * Support COMDAT group with the GNU assembler and recent Sun linker.
     * Support the Sun assembler visibility syntax.
     * Default Solaris 2/x86 to -march=pentium4 (Solaris 10+) resp.
       -march=pentiumpro (Solaris 8/9).
     * Don't use SSE on Solaris 8/9 x86 by default.
     * Enable 128-bit long double (__float128) support on Solaris 2/x86.

    ABI Change

     * Change the ABI for returning 8-byte vectors like __m64 in MMX
       registers on Solaris 10+/x86 to match the Sun Studio 12.1+
       compilers. This is an incompatible change. If you use such types,
       you must either recompile all your code with the new compiler or
       use the new -mvect8-ret-in-mem option to remain compatible with
       previous versions of GCC and Sun Studio.

  Windows x86/x86_64

     * Initial support for decimal floating point.
     * Support for the __thiscall calling-convention.
     * Support for hot-patchable function prologues via the
       ms_hook_prologue attribute for x86_64 in addition to 32-bit x86.
     * Improvements of stack-probing and stack-allocation mechanisms.
     * Support of push/pop-macro pragma as preprocessor command.
       With #pragma push_macro("macro-name") the current definition of
       macro-name is saved and can be restored with #pragma
       pop_macro("macro-name") to its saved definition.
     * Enable 128-bit long double (__float128) support on MinGW and
       Cygwin.

Other significant improvements

  Installation changes

     * An install-strip make target is provided that installs stripped
       executables, and may install libraries with unneeded or debugging
       sections stripped.
     * On Power7 systems, there is a potential problem if you build the
       GCC compiler with a host compiler using options that enable the VSX
       instruction set generation. If the host compiler has been patched
       so that the vec_ld and vec_st builtin functions generate Altivec
       memory instructions instead of VSX memory instructions, then you
       should be able to build the compiler with VSX instruction
       generation.

Changes for GCC Developers

   Note: these changes concern developers that develop GCC itself or
   software that integrates with GCC, such as plugins, and not the general
   GCC users.
     * The gengtype utility, which previously was internal to the GCC
       build process, has been enchanced to provide GC root information
       for plugins as necessary.
     * The old GC allocation interface of ggc_alloc and friends was
       replaced with a type-safe alternative.

GCC 4.6.1

   This is the [20]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.6.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 4.6.2

   This is the [21]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.6.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 4.6.3

   This is the [22]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.6.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 4.6.4

   This is the [23]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 4.6.4 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).


    For questions related to the use of GCC, please consult these web
    pages and the [24]GCC manuals. If that fails, the
    [25]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [26]gcc@gcc.gnu.org. All of [27]our lists have public
    archives.

   Copyright (C) [28]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [29]maintained by the GCC team. Last modified
   2016-11-27[30].

References

   1. https://sourceware.org/bugzilla/show_bug.cgi?id=10401
   2. http://gcc.gnu.org/gcc-4.5/changes.html
   3. http://gcc.gnu.org/gcc-4.5/changes.html#obsoleted
   4. http://gcc.gnu.org/gcc-4.6/porting_to.html
   5. http://gcc.gnu.org/projects/lto/whopr.pdf
   6. https://gcc.gnu.org/onlinedocs/gcc/Warning-Options.html#Warning-Options
   7. http://gcc.gnu.org/gcc-4.6/cxx0x_status.html
   8. https://gcc.gnu.org/PR43145
   9. https://gcc.gnu.org/PR43680
  10. https://gcc.gnu.org/PR33558
  11. http://www.open-std.org/jtc1/sc22/wg21/docs/cwg_active.html#253
  12. https://gcc.gnu.org/onlinedocs/gcc-4.6.4/libstdc++/manual/manual/status.html#status.iso.200x
  13. https://gcc.gnu.org/onlinedocs/libstdc++/manual/debug_mode.html
  14. https://gcc.gnu.org/onlinedocs/libstdc++/manual/debug.html#debug.races
  15. https://gcc.gnu.org/onlinedocs/gcc/Preprocessor-Options.html
  16. https://gcc.gnu.org/wiki/OOP
  17. https://gcc.gnu.org/wiki/Coarray
  18. https://gcc.gnu.org/onlinedocs/gfortran/Code-Gen-Options.html#index-g_t_0040code_007bfcoarray_007d-233
  19. https://golang.org/
  20. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.6.1
  21. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.6.2
  22. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.6.3
  23. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=4.6.4
  24. https://gcc.gnu.org/onlinedocs/
  25. mailto:gcc-help@gcc.gnu.org
  26. mailto:gcc@gcc.gnu.org
  27. https://gcc.gnu.org/lists.html
  28. http://www.fsf.org/
  29. https://gcc.gnu.org/about.html
  30. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-4.5/index.html

                             GCC 4.5 Release Series

   Jul 2, 2012

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 4.5.4.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 4.5.3 relative to previous releases of GCC.

   This release series is no longer maintained.

Release History

   GCC 4.5.4
          Jul 2, 2012 ([2]changes)

   GCC 4.5.3
          Apr 28, 2011 ([3]changes)

   GCC 4.5.2
          Dec 16, 2010 ([4]changes)

   GCC 4.5.1
          Jul 31, 2010 ([5]changes)

   GCC 4.5.0
          April 14, 2010 ([6]changes)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [7]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [8]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [9]GCC project
   web site or contact the [10]GCC development mailing list.

   To obtain GCC please use [11]our mirror sites or [12]our SVN server.


    For questions related to the use of GCC, please consult these web
    pages and the [13]GCC manuals. If that fails, the
    [14]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [15]gcc@gcc.gnu.org. All of [16]our lists have public
    archives.

   Copyright (C) [17]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [18]maintained by the GCC team. Last modified
   2016-09-30[19].

References

   1. http://www.gnu.org/
   2. http://gcc.gnu.org/gcc-4.5/changes.html
   3. http://gcc.gnu.org/gcc-4.5/changes.html
   4. http://gcc.gnu.org/gcc-4.5/changes.html
   5. http://gcc.gnu.org/gcc-4.5/changes.html
   6. http://gcc.gnu.org/gcc-4.5/changes.html
   7. http://gcc.gnu.org/gcc-4.5/buildstat.html
   8. https://gcc.gnu.org/onlinedocs/gcc/Contributors.html
   9. http://gcc.gnu.org/index.html
  10. mailto:gcc@gcc.gnu.org
  11. http://gcc.gnu.org/mirrors.html
  12. http://gcc.gnu.org/svn.html
  13. https://gcc.gnu.org/onlinedocs/
  14. mailto:gcc-help@gcc.gnu.org
  15. mailto:gcc@gcc.gnu.org
  16. https://gcc.gnu.org/lists.html
  17. http://www.fsf.org/
  18. https://gcc.gnu.org/about.html
  19. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-4.5/changes.html

                             GCC 4.5 Release Series
                        Changes, New Features, and Fixes

Caveats

     * GCC now requires the [1]MPC library in order to build. See the
       [2]prerequisites page for version requirements.
     * Support for a number of older systems and recently unmaintained or
       untested target ports of GCC has been declared obsolete in GCC 4.5.
       Unless there is activity to revive them, the next release of GCC
       will have their sources permanently removed.
       The following ports for individual systems on particular
       architectures have been obsoleted:
          + IRIX releases before 6.5 (mips-sgi-irix5*,
            mips-sgi-irix6.[0-4])
          + Solaris 7 (*-*-solaris2.7)
          + Tru64 UNIX releases before V5.1 (alpha*-dec-osf4*,
            alpha-dec-osf5.0*)
          + Details for the IRIX, Solaris 7, and Tru64 UNIX obsoletions
            can be found in the [3]announcement.
       Support for the classic POWER architecture implemented in the
       original RIOS and RIOS2 processors of the old IBM RS/6000 product
       line has been obsoleted in the rs6000 port. This does not affect
       the new generation Power and PowerPC architectures.
     * Support has been removed for all the [4]configurations obsoleted in
       GCC 4.4.
     * Support has been removed for the protoize and unprotoize utilities,
       obsoleted in GCC 4.4.
     * Support has been removed for tuning for Itanium1 (Merced) variants.
       Note that code tuned for Itanium2 should also run correctly on
       Itanium1.
     * GCC now generates unwind info also for epilogues. DWARF debuginfo
       generated by GCC now uses more features of DWARF3 than before, and
       also some DWARF4 features. GDB older than 7.0 is not able to handle
       either of these, so to debug GCC 4.5 generated binaries or
       libraries GDB 7.0 or later is needed. You can disable use of DWARF4
       features with the -gdwarf-3 -gstrict-dwarf options, or use
       -gdwarf-2 -gstrict-dwarf to restrict GCC to just DWARF2, but
       epilogue unwind info is emitted unconditionally whenever unwind
       info is emitted.
     * On x86 targets, code containing floating-point calculations may run
       significantly more slowly when compiled with GCC 4.5 in strict C99
       conformance mode than they did with earlier GCC versions. This is
       due to stricter standard conformance of the compiler and can be
       avoided by using the option -fexcess-precision=fast; also see
       [5]below.
     * The function attribute noinline no longer prevents GCC from cloning
       the function. A new attribute noclone has been introduced for this
       purpose. Cloning a function means that it is duplicated and the new
       copy is specialized for certain contexts (for example when a
       parameter is a known constant).

General Optimizer Improvements

     * The -save-temps now takes an optional argument. The -save-temps and
       -save-temps=cwd switches write the temporary files in the current
       working directory based on the original source file. The
       -save-temps=obj switch will write files into the directory
       specified with the -o option, and the intermediate filenames are
       based on the output file. This will allow the user to get the
       compiler intermediate files when doing parallel builds without two
       builds of the same filename located in different directories from
       interfering with each other.
     * Debugging dumps are now created in the same directory as the object
       file rather than in the current working directory. This allows the
       user to get debugging dumps when doing parallel builds without two
       builds of the same filename interfering with each other.
     * GCC has been integrated with the [6]MPC library. This allows GCC to
       evaluate complex arithmetic at compile time [7]more accurately. It
       also allows GCC to evaluate calls to complex built-in math
       functions having constant arguments and replace them at compile
       time with their mathematically equivalent results. In doing so, GCC
       can generate correct results regardless of the math library
       implementation or floating point precision of the host platform.
       This also allows GCC to generate identical results regardless of
       whether one compiles in native or cross-compile configurations to a
       particular target. The following built-in functions take advantage
       of this new capability: cacos, cacosh, casin, casinh, catan,
       catanh, ccos, ccosh, cexp, clog, cpow, csin, csinh, csqrt, ctan,
       and ctanh. The float and long double variants of these functions
       (e.g. csinf and csinl) are also handled.
     * A new link-time optimizer has been added ([8]-flto). When this
       option is used, GCC generates a bytecode representation of each
       input file and writes it to specially-named sections in each object
       file. When the object files are linked together, all the function
       bodies are read from these named sections and instantiated as if
       they had been part of the same translation unit. This enables
       interprocedural optimizations to work across different files (and
       even different languages), potentially improving the performance of
       the generated code. To use the link-timer optimizer, -flto needs to
       be specified at compile time and during the final link. If the
       program does not require any symbols to be exported, it is possible
       to combine -flto and the experimental [9]-fwhopr with
       [10]-fwhole-program to allow the interprocedural optimizers to use
       more aggressive assumptions.
     * The automatic parallelization pass was enhanced to support
       parallelization of outer loops.
     * Automatic parallelization can be enabled as part of Graphite. In
       addition to -ftree-parallelize-loops=, specify
       -floop-parallelize-all to enable the Graphite-based optimization.
     * The infrastructure for optimizing based on [11]restrict qualified
       pointers has been rewritten and should result in code generation
       improvements. Optimizations based on restrict qualified pointers
       are now also available when using -fno-strict-aliasing.
     * There is a new optimization pass that attempts to change prototype
       of functions to avoid unused parameters, pass only relevant parts
       of structures and turn arguments passed by reference to arguments
       passed by value when possible. It is enabled by -O2 and above as
       well as -Os and can be manually invoked using the new command-line
       switch -fipa-sra.
     * GCC now optimize exception handling code. In particular cleanup
       regions that are proved to not have any effect are optimized out.

New Languages and Language specific improvements

  All languages

     * The -fshow-column option is now on by default. This means error
       messages now have a column associated with them.

  Ada

     * Compilation of programs heavily using discriminated record types
       with variant parts has been sped up and generates more compact
       code.
     * Stack checking now works reasonably well on most plaforms. In some
       specific cases, stack overflows may still fail to be detected, but
       a compile-time warning will be issued for these cases.

  C family

     * If a header named in a #include directive is not found, the
       compiler exits immediately. This avoids a cascade of errors arising
       from declarations expected to be found in that header being
       missing.
     * A new built-in function __builtin_unreachable() has been added that
       tells the compiler that control will never reach that point. It may
       be used after asm statements that terminate by transferring control
       elsewhere, and in other places that are known to be unreachable.
     * The -Wlogical-op option now warns for logical expressions such as
       (c == 1 && c == 2) and (c != 1 || c != 2), which are likely to be
       mistakes. This option is disabled by default.
     * An asm goto feature has been added to allow asm statements that
       jump to C labels.
     * C++0x raw strings are supported for C++ and for C with -std=gnu99.
     * The deprecated attribute now takes an optional string argument, for
       example, __attribute__((deprecated("text string"))), that will be
       printed together with the deprecation warning.

  C

     * The -Wenum-compare option, which warns when comparing values of
       different enum types, now works for C. It formerly only worked for
       C++. This warning is enabled by -Wall. It may be avoided by using a
       type cast.
     * The -Wcast-qual option now warns about casts which are unsafe in
       that they permit const-correctness to be violated without further
       warnings. Specifically, it warns about cases where a qualifier is
       added when all the lower types are not const. For example, it warns
       about a cast from char ** to const char **.
     * The -Wc++-compat option is significantly improved. It issues new
       warnings for:
          + Using C++ reserved operator names as identifiers.
          + Conversions to enum types without explicit casts.
          + Using va_arg with an enum type.
          + Using different enum types in the two branches of ?:.
          + Using ++ or -- on a variable of enum type.
          + Using the same name as both a struct, union or enum tag and a
            typedef, unless the typedef refers to the tagged type itself.
          + Using a struct, union, or enum which is defined within another
            struct or union.
          + A struct field defined using a typedef if there is a field in
            the struct, or an enclosing struct, whose name is the typedef
            name.
          + Duplicate definitions at file scope.
          + Uninitialized const variables.
          + A global variable with an anonymous struct, union, or enum
            type.
          + Using a string constant to initialize a char array whose size
            is the length of the string.
     * The new -Wjump-misses-init option warns about cases where a goto or
       switch skips the initialization of a variable. This sort of branch
       is an error in C++ but not in C. This warning is enabled by
       -Wc++-compat.
     * GCC now ensures that a C99-conforming <stdint.h> is present on most
       targets, and uses information about the types in this header to
       implement the Fortran bindings to those types. GCC does not ensure
       the presence of such a header, and does not implement the Fortran
       bindings, on the following targets: NetBSD, VxWorks, VMS,
       SymbianOS, WinCE, LynxOS, Netware, QNX, Interix, TPF.
     * GCC now implements C90- and C99-conforming rules for constant
       expressions. This may cause warnings or errors for some code using
       expressions that can be folded to a constant but are not constant
       expressions as defined by ISO C.
     * All known target-independent C90 and C90 Amendment 1 conformance
       bugs, and all known target-independent C99 conformance bugs not
       related to floating point or extended identifiers, have been fixed.
     * The C decimal floating point support now includes support for the
       FLOAT_CONST_DECIMAL64 pragma.
     * The named address space feature from ISO/IEC TR 18037 is now
       supported. This is currently only implemented for the SPU
       processor.

  C++

     * Improved [12]experimental support for the upcoming C++0x ISO C++
       standard, including support for raw strings, lambda expressions and
       explicit type conversion operators.
     * When printing the name of a class template specialization, G++ will
       now omit any template arguments which come from default template
       arguments. This behavior (and the pretty-printing of function
       template specializations as template signature and arguments) can
       be disabled with the -fno-pretty-templates option.
     * Access control is now applied to typedef names used in a template,
       which may cause G++ to reject some ill-formed code that was
       accepted by earlier releases. The -fno-access-control option can be
       used as a temporary workaround until the code is corrected.
     * Compilation time for code that uses templates should now scale
       linearly with the number of instantiations rather than
       quadratically, as template instantiations are now looked up using
       hash tables.
     * Declarations of functions that look like builtin declarations of
       library functions are only considered to be redeclarations if they
       are declared with extern "C". This may cause problems with code
       that omits extern "C" on hand-written declarations of C library
       functions such as abort or memcpy. Such code is ill-formed, but was
       accepted by earlier releases.
     * Diagnostics that used to complain about passing non-POD types to
       ... or jumping past the declaration of a non-POD variable now check
       for triviality rather than PODness, as per C++0x.
     * In C++0x mode local and anonymous classes are now allowed as
       template arguments, and in declarations of variables and functions
       with linkage, so long as any such declaration that is used is also
       defined ([13]DR 757).
     * Labels may now have attributes, as has been permitted for a while
       in C. This is only permitted when the label definition and the
       attribute specifier is followed by a semicolon--i.e., the label
       applies to an empty statement. The only useful attribute for a
       label is unused.
     * G++ now implements [14]DR 176. Previously G++ did not support using
       the injected-class-name of a template base class as a type name,
       and lookup of the name found the declaration of the template in the
       enclosing scope. Now lookup of the name finds the
       injected-class-name, which can be used either as a type or as a
       template, depending on whether or not the name is followed by a
       template argument list. As a result of this change, some code that
       was previously accepted may be ill-formed because
         1. The injected-class-name is not accessible because it's from a
            private base, or
         2. The injected-class-name cannot be used as an argument for a
            template template parameter.
       In either of these cases, the code can be fixed by adding a
       nested-name-specifier to explicitly name the template. The first
       can be worked around with -fno-access-control; the second is only
       rejected with -pedantic.
     * A new standard mangling for SIMD vector types has been added, to
       avoid name clashes on systems with vectors of varying length. By
       default the compiler still uses the old mangling, but emits aliases
       with the new mangling on targets that support strong aliases. Users
       can switch over entirely to the new mangling with -fabi-version=4
       or -fabi-version=0. -Wabi will now warn about code that uses the
       old mangling.
     * The command-line option -ftemplate-depth-N is now written as
       -ftemplate-depth=N and the old form is deprecated.
     * Conversions between NULL and non-pointer types are now warned by
       default. The new option -Wno-conversion-null disables these
       warnings. Previously these warnings were only available when using
       -Wconversion explicitly.

    Runtime Library (libstdc++)

     * Improved experimental support for the upcoming ISO C++ standard,
       C++0x, including:
          + Support for <future>, <functional>, and <random>.
          + Existing facilities now exploit explicit operators and the
            newly implemented core C++0x features.
          + The header <cstdatomic> has been renamed to <atomic>.
     * An experimental [15]profile mode has been added. This is an
       implementation of many C++ standard library constructs with an
       additional analysis layer that gives performance improvement advice
       based on recognition of suboptimal usage patterns. For example,
#include <vector>
int main()
{
  std::vector<int> v;
  for (int k = 0; k < 1024; ++k)
    v.insert(v.begin(), k);
}

       When instrumented via the profile mode, can return suggestions
       about the initial size and choice of the container used as follows:
vector-to-list: improvement = 5: call stack = 0x804842c ...
    : advice = change std::vector to std::list
vector-size: improvement = 3: call stack = 0x804842c ...
    : advice = change initial container size from 0 to 1024

       These constructs can be substituted for the normal libstdc++
       constructs on a piecemeal basis, or all existing components can be
       transformed via the -D_GLIBCXX_PROFILE macro.
     * [16]Support for decimal floating-point arithmetic (aka ISO C++ TR
       24733) has been added. This support is in header file
       <decimal/decimal>, uses namespace std::decimal, and includes
       classes decimal32, decimal64, and decimal128.
     * Sources have been audited for application of function attributes
       nothrow, const, pure, and noreturn.
     * Python pretty-printers have been added for many standard library
       components that simplify the internal representation and present a
       more intuitive view of components when used with
       appropriately-advanced versions of GDB. For more information,
       please consult the more [17]detailed description.
     * The default behavior for comparing typeinfo names has changed, so
       in <typeinfo>, __GXX_MERGED_TYPEINFO_NAMES now defaults to zero.
     * The new -static-libstdc++ option directs g++ to link the C++
       library statically, even if the default would normally be to link
       it dynamically.

  Fortran

     * The COMMON default padding has been changed - instead of adding the
       padding before a variable it is now added afterwards, which
       increases the compatibility with other vendors and helps to obtain
       the correct output in some cases. Cf. also the -falign-commons
       option ([18]added in 4.4).
     * The -finit-real= option now also supports the value snan for
       signaling not-a-number; to be effective, one additionally needs to
       enable trapping (e.g. via -ffpe-trap=). Note: Compile-time
       optimizations can turn a signaling NaN into a quiet one.
     * The new option -fcheck= has been added with the options bounds,
       array-temps, do, pointer, and recursive. The bounds and array-temps
       options are equivalent to -fbounds-check and
       -fcheck-array-temporaries. The do option checks for invalid
       modification of loop iteration variables, and the recursive option
       tests for recursive calls to subroutines/functions which are not
       marked as recursive. With pointer pointer association checks in
       calls are performed; however, neither undefined pointers nor
       pointers in expressions are handled. Using -fcheck=all enables all
       these run-time checks.
     * The run-time checking -fcheck=bounds now warns about invalid string
       lengths of character dummy arguments. Additionally, more
       compile-time checks have been added.
     * The new option [19]-fno-protect-parens has been added; if set, the
       compiler may reorder REAL and COMPLEX expressions without regard to
       parentheses.
     * GNU Fortran no longer links against libgfortranbegin. As before,
       MAIN__ (assembler symbol name) is the actual Fortran main program,
       which is invoked by the main function. However, main is now
       generated and put in the same object file as MAIN__. For the time
       being, libgfortranbegin still exists for backward compatibility.
       For details see the new [20]Mixed-Language Programming chapter in
       the manual.
     * The I/O library was restructured for performance and cleaner code.
     * Array assignments and WHERE are now run in parallel when OpenMP's
       WORKSHARE is used.
     * The experimental option -fwhole-file was added. The option allows
       whole-file checking of procedure arguments and allows for better
       optimizations. It can also be used with -fwhole-program, which is
       now also supported in gfortran.
     * More Fortran 2003 and Fortran 2008 mathematical functions can now
       be used as initialization expressions.
     * Some extended attributes such as STDCALL are now supported via the
       [21]GCC$ compiler directive.
     * For Fortran 77 compatibility: If -fno-sign-zero is used, the SIGN
       intrinsic behaves now as if zero were always positive.
     * For legacy compatibiliy: On Cygwin and MinGW, the special files
       CONOUT$ and CONIN$ (and CONERR$ which maps to CONOUT$) are now
       supported.
     * Fortran 2003 support has been extended:
          + Procedure-pointer function results and procedure-pointer
            components (including PASS),
          + allocatable scalars (experimental),
          + DEFERRED type-bound procedures,
          + the ERRMSG= argument of the ALLOCATE and DEALLOCATE statements
            have been implemented.
          + The ALLOCATE statement supports type-specs and the SOURCE=
            argument.
          + OPERATOR(*) and ASSIGNMENT(=) are now allowed as GENERIC
            type-bound procedure (i.e. as type-bound operators).
          + Rounding (ROUND=, RZ, ...) for output is now supported.
          + The INT_FAST{8,16,32,64,128}_T kind type parameters of the
            intrinsic module ISO_C_BINDING are now supported, except for
            the targets listed above as ones where GCC does not have
            <stdint.h> type information.
          + Extensible derived types with type-bound procedure or
            procedure pointer with PASS attribute now have to use CLASS in
            line with the Fortran 2003 standard; the workaround to use
            TYPE is no longer supported.
          + [22]Experimental, incomplete support for polymorphism,
            including CLASS, SELECT TYPE and dynamic dispatch of
            type-bound procedure calls. Some features do not work yet such
            as unlimited polymorphism (CLASS(*)).
     * Fortran 2008 support has been extended:
          + The OPEN statement now supports the NEWUNIT= option, which
            returns a unique file unit, thus preventing inadvertent use of
            the same unit in different parts of the program.
          + Support for unlimited format items has been added.
          + The INT{8,16,32} and REAL{32,64,128} kind type parameters of
            the intrinsic module ISO_FORTRAN_ENV are now supported.
          + Using complex arguments with TAN, SINH, COSH, TANH, ASIN,
            ACOS, and ATAN is now possible; the functions ASINH, ACOSH,
            and ATANH have been added (for real and complex arguments) and
            ATAN(Y,X) is now an alias for ATAN2(Y,X).
          + The BLOCK construct has been implemented.

New Targets and Target Specific Improvements

  AIX

     * Full cross-toolchain support now available with GNU Binutils

  ARM

     * GCC now supports the Cortex-M0 and Cortex-A5 processors.
     * GCC now supports the ARM v7E-M architecture.
     * GCC now supports VFPv4-based FPUs and FPUs with
       single-precision-only VFP.
     * GCC has many improvements to optimization for other ARM processors,
       including scheduling support for the integer pipeline on Cortex-A9.
